{-# LANGUAGE MultiWayIf #-}
-- CHANGE WITH CAUTION: This is a generated code file generated by https://github.com/Haskell-OpenAPI-Code-Generator/Haskell-OpenAPI-Client-Code-Generator.
{-# LANGUAGE OverloadedStrings #-}

-- | Contains the types generated from the schema AccountRequirementsError
module StripeAPI.Types.AccountRequirementsError where

import qualified Control.Monad.Fail
import qualified Data.Aeson
import qualified Data.Aeson as Data.Aeson.Encoding.Internal
import qualified Data.Aeson as Data.Aeson.Types
import qualified Data.Aeson as Data.Aeson.Types.FromJSON
import qualified Data.Aeson as Data.Aeson.Types.Internal
import qualified Data.Aeson as Data.Aeson.Types.ToJSON
import qualified Data.ByteString.Char8
import qualified Data.ByteString.Char8 as Data.ByteString.Internal
import qualified Data.Functor
import qualified Data.Scientific
import qualified Data.Text
import qualified Data.Text.Internal
import qualified Data.Time.Calendar as Data.Time.Calendar.Days
import qualified Data.Time.LocalTime as Data.Time.LocalTime.Internal.ZonedTime
import qualified GHC.Base
import qualified GHC.Classes
import qualified GHC.Int
import qualified GHC.Show
import qualified GHC.Types
import qualified StripeAPI.Common
import StripeAPI.TypeAlias
import qualified Prelude as GHC.Integer.Type
import qualified Prelude as GHC.Maybe

-- | Defines the object schema located at @components.schemas.account_requirements_error@ in the specification.
data AccountRequirementsError = AccountRequirementsError
  { -- | code: The code for the type of error.
    accountRequirementsErrorCode :: AccountRequirementsErrorCode',
    -- | reason: An informative message that indicates the error type and provides additional details about the error.
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    accountRequirementsErrorReason :: Data.Text.Internal.Text,
    -- | requirement: The specific user onboarding requirement field (in the requirements hash) that needs to be resolved.
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    accountRequirementsErrorRequirement :: Data.Text.Internal.Text
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON AccountRequirementsError where
  toJSON obj = Data.Aeson.Types.Internal.object ("code" Data.Aeson.Types.ToJSON..= accountRequirementsErrorCode obj : "reason" Data.Aeson.Types.ToJSON..= accountRequirementsErrorReason obj : "requirement" Data.Aeson.Types.ToJSON..= accountRequirementsErrorRequirement obj : GHC.Base.mempty)
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (("code" Data.Aeson.Types.ToJSON..= accountRequirementsErrorCode obj) GHC.Base.<> (("reason" Data.Aeson.Types.ToJSON..= accountRequirementsErrorReason obj) GHC.Base.<> ("requirement" Data.Aeson.Types.ToJSON..= accountRequirementsErrorRequirement obj)))

instance Data.Aeson.Types.FromJSON.FromJSON AccountRequirementsError where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "AccountRequirementsError" (\obj -> ((GHC.Base.pure AccountRequirementsError GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "code")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "reason")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "requirement"))

-- | Create a new 'AccountRequirementsError' with all required fields.
mkAccountRequirementsError ::
  -- | 'accountRequirementsErrorCode'
  AccountRequirementsErrorCode' ->
  -- | 'accountRequirementsErrorReason'
  Data.Text.Internal.Text ->
  -- | 'accountRequirementsErrorRequirement'
  Data.Text.Internal.Text ->
  AccountRequirementsError
mkAccountRequirementsError accountRequirementsErrorCode accountRequirementsErrorReason accountRequirementsErrorRequirement =
  AccountRequirementsError
    { accountRequirementsErrorCode = accountRequirementsErrorCode,
      accountRequirementsErrorReason = accountRequirementsErrorReason,
      accountRequirementsErrorRequirement = accountRequirementsErrorRequirement
    }

-- | Defines the enum schema located at @components.schemas.account_requirements_error.properties.code@ in the specification.
--
-- The code for the type of error.
data AccountRequirementsErrorCode'
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    AccountRequirementsErrorCode'Other Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    AccountRequirementsErrorCode'Typed Data.Text.Internal.Text
  | -- | Represents the JSON value @"invalid_address_city_state_postal_code"@
    AccountRequirementsErrorCode'EnumInvalidAddressCityStatePostalCode
  | -- | Represents the JSON value @"invalid_street_address"@
    AccountRequirementsErrorCode'EnumInvalidStreetAddress
  | -- | Represents the JSON value @"invalid_value_other"@
    AccountRequirementsErrorCode'EnumInvalidValueOther
  | -- | Represents the JSON value @"verification_document_address_mismatch"@
    AccountRequirementsErrorCode'EnumVerificationDocumentAddressMismatch
  | -- | Represents the JSON value @"verification_document_address_missing"@
    AccountRequirementsErrorCode'EnumVerificationDocumentAddressMissing
  | -- | Represents the JSON value @"verification_document_corrupt"@
    AccountRequirementsErrorCode'EnumVerificationDocumentCorrupt
  | -- | Represents the JSON value @"verification_document_country_not_supported"@
    AccountRequirementsErrorCode'EnumVerificationDocumentCountryNotSupported
  | -- | Represents the JSON value @"verification_document_dob_mismatch"@
    AccountRequirementsErrorCode'EnumVerificationDocumentDobMismatch
  | -- | Represents the JSON value @"verification_document_duplicate_type"@
    AccountRequirementsErrorCode'EnumVerificationDocumentDuplicateType
  | -- | Represents the JSON value @"verification_document_expired"@
    AccountRequirementsErrorCode'EnumVerificationDocumentExpired
  | -- | Represents the JSON value @"verification_document_failed_copy"@
    AccountRequirementsErrorCode'EnumVerificationDocumentFailedCopy
  | -- | Represents the JSON value @"verification_document_failed_greyscale"@
    AccountRequirementsErrorCode'EnumVerificationDocumentFailedGreyscale
  | -- | Represents the JSON value @"verification_document_failed_other"@
    AccountRequirementsErrorCode'EnumVerificationDocumentFailedOther
  | -- | Represents the JSON value @"verification_document_failed_test_mode"@
    AccountRequirementsErrorCode'EnumVerificationDocumentFailedTestMode
  | -- | Represents the JSON value @"verification_document_fraudulent"@
    AccountRequirementsErrorCode'EnumVerificationDocumentFraudulent
  | -- | Represents the JSON value @"verification_document_id_number_mismatch"@
    AccountRequirementsErrorCode'EnumVerificationDocumentIdNumberMismatch
  | -- | Represents the JSON value @"verification_document_id_number_missing"@
    AccountRequirementsErrorCode'EnumVerificationDocumentIdNumberMissing
  | -- | Represents the JSON value @"verification_document_incomplete"@
    AccountRequirementsErrorCode'EnumVerificationDocumentIncomplete
  | -- | Represents the JSON value @"verification_document_invalid"@
    AccountRequirementsErrorCode'EnumVerificationDocumentInvalid
  | -- | Represents the JSON value @"verification_document_issue_or_expiry_date_missing"@
    AccountRequirementsErrorCode'EnumVerificationDocumentIssueOrExpiryDateMissing
  | -- | Represents the JSON value @"verification_document_manipulated"@
    AccountRequirementsErrorCode'EnumVerificationDocumentManipulated
  | -- | Represents the JSON value @"verification_document_missing_back"@
    AccountRequirementsErrorCode'EnumVerificationDocumentMissingBack
  | -- | Represents the JSON value @"verification_document_missing_front"@
    AccountRequirementsErrorCode'EnumVerificationDocumentMissingFront
  | -- | Represents the JSON value @"verification_document_name_mismatch"@
    AccountRequirementsErrorCode'EnumVerificationDocumentNameMismatch
  | -- | Represents the JSON value @"verification_document_name_missing"@
    AccountRequirementsErrorCode'EnumVerificationDocumentNameMissing
  | -- | Represents the JSON value @"verification_document_nationality_mismatch"@
    AccountRequirementsErrorCode'EnumVerificationDocumentNationalityMismatch
  | -- | Represents the JSON value @"verification_document_not_readable"@
    AccountRequirementsErrorCode'EnumVerificationDocumentNotReadable
  | -- | Represents the JSON value @"verification_document_not_signed"@
    AccountRequirementsErrorCode'EnumVerificationDocumentNotSigned
  | -- | Represents the JSON value @"verification_document_not_uploaded"@
    AccountRequirementsErrorCode'EnumVerificationDocumentNotUploaded
  | -- | Represents the JSON value @"verification_document_photo_mismatch"@
    AccountRequirementsErrorCode'EnumVerificationDocumentPhotoMismatch
  | -- | Represents the JSON value @"verification_document_too_large"@
    AccountRequirementsErrorCode'EnumVerificationDocumentTooLarge
  | -- | Represents the JSON value @"verification_document_type_not_supported"@
    AccountRequirementsErrorCode'EnumVerificationDocumentTypeNotSupported
  | -- | Represents the JSON value @"verification_failed_address_match"@
    AccountRequirementsErrorCode'EnumVerificationFailedAddressMatch
  | -- | Represents the JSON value @"verification_failed_business_iec_number"@
    AccountRequirementsErrorCode'EnumVerificationFailedBusinessIecNumber
  | -- | Represents the JSON value @"verification_failed_document_match"@
    AccountRequirementsErrorCode'EnumVerificationFailedDocumentMatch
  | -- | Represents the JSON value @"verification_failed_id_number_match"@
    AccountRequirementsErrorCode'EnumVerificationFailedIdNumberMatch
  | -- | Represents the JSON value @"verification_failed_keyed_identity"@
    AccountRequirementsErrorCode'EnumVerificationFailedKeyedIdentity
  | -- | Represents the JSON value @"verification_failed_keyed_match"@
    AccountRequirementsErrorCode'EnumVerificationFailedKeyedMatch
  | -- | Represents the JSON value @"verification_failed_name_match"@
    AccountRequirementsErrorCode'EnumVerificationFailedNameMatch
  | -- | Represents the JSON value @"verification_failed_other"@
    AccountRequirementsErrorCode'EnumVerificationFailedOther
  | -- | Represents the JSON value @"verification_failed_tax_id_match"@
    AccountRequirementsErrorCode'EnumVerificationFailedTaxIdMatch
  | -- | Represents the JSON value @"verification_failed_tax_id_not_issued"@
    AccountRequirementsErrorCode'EnumVerificationFailedTaxIdNotIssued
  | -- | Represents the JSON value @"verification_missing_executives"@
    AccountRequirementsErrorCode'EnumVerificationMissingExecutives
  | -- | Represents the JSON value @"verification_missing_owners"@
    AccountRequirementsErrorCode'EnumVerificationMissingOwners
  | -- | Represents the JSON value @"verification_requires_additional_memorandum_of_associations"@
    AccountRequirementsErrorCode'EnumVerificationRequiresAdditionalMemorandumOfAssociations
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON AccountRequirementsErrorCode' where
  toJSON (AccountRequirementsErrorCode'Other val) = val
  toJSON (AccountRequirementsErrorCode'Typed val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (AccountRequirementsErrorCode'EnumInvalidAddressCityStatePostalCode) = "invalid_address_city_state_postal_code"
  toJSON (AccountRequirementsErrorCode'EnumInvalidStreetAddress) = "invalid_street_address"
  toJSON (AccountRequirementsErrorCode'EnumInvalidValueOther) = "invalid_value_other"
  toJSON (AccountRequirementsErrorCode'EnumVerificationDocumentAddressMismatch) = "verification_document_address_mismatch"
  toJSON (AccountRequirementsErrorCode'EnumVerificationDocumentAddressMissing) = "verification_document_address_missing"
  toJSON (AccountRequirementsErrorCode'EnumVerificationDocumentCorrupt) = "verification_document_corrupt"
  toJSON (AccountRequirementsErrorCode'EnumVerificationDocumentCountryNotSupported) = "verification_document_country_not_supported"
  toJSON (AccountRequirementsErrorCode'EnumVerificationDocumentDobMismatch) = "verification_document_dob_mismatch"
  toJSON (AccountRequirementsErrorCode'EnumVerificationDocumentDuplicateType) = "verification_document_duplicate_type"
  toJSON (AccountRequirementsErrorCode'EnumVerificationDocumentExpired) = "verification_document_expired"
  toJSON (AccountRequirementsErrorCode'EnumVerificationDocumentFailedCopy) = "verification_document_failed_copy"
  toJSON (AccountRequirementsErrorCode'EnumVerificationDocumentFailedGreyscale) = "verification_document_failed_greyscale"
  toJSON (AccountRequirementsErrorCode'EnumVerificationDocumentFailedOther) = "verification_document_failed_other"
  toJSON (AccountRequirementsErrorCode'EnumVerificationDocumentFailedTestMode) = "verification_document_failed_test_mode"
  toJSON (AccountRequirementsErrorCode'EnumVerificationDocumentFraudulent) = "verification_document_fraudulent"
  toJSON (AccountRequirementsErrorCode'EnumVerificationDocumentIdNumberMismatch) = "verification_document_id_number_mismatch"
  toJSON (AccountRequirementsErrorCode'EnumVerificationDocumentIdNumberMissing) = "verification_document_id_number_missing"
  toJSON (AccountRequirementsErrorCode'EnumVerificationDocumentIncomplete) = "verification_document_incomplete"
  toJSON (AccountRequirementsErrorCode'EnumVerificationDocumentInvalid) = "verification_document_invalid"
  toJSON (AccountRequirementsErrorCode'EnumVerificationDocumentIssueOrExpiryDateMissing) = "verification_document_issue_or_expiry_date_missing"
  toJSON (AccountRequirementsErrorCode'EnumVerificationDocumentManipulated) = "verification_document_manipulated"
  toJSON (AccountRequirementsErrorCode'EnumVerificationDocumentMissingBack) = "verification_document_missing_back"
  toJSON (AccountRequirementsErrorCode'EnumVerificationDocumentMissingFront) = "verification_document_missing_front"
  toJSON (AccountRequirementsErrorCode'EnumVerificationDocumentNameMismatch) = "verification_document_name_mismatch"
  toJSON (AccountRequirementsErrorCode'EnumVerificationDocumentNameMissing) = "verification_document_name_missing"
  toJSON (AccountRequirementsErrorCode'EnumVerificationDocumentNationalityMismatch) = "verification_document_nationality_mismatch"
  toJSON (AccountRequirementsErrorCode'EnumVerificationDocumentNotReadable) = "verification_document_not_readable"
  toJSON (AccountRequirementsErrorCode'EnumVerificationDocumentNotSigned) = "verification_document_not_signed"
  toJSON (AccountRequirementsErrorCode'EnumVerificationDocumentNotUploaded) = "verification_document_not_uploaded"
  toJSON (AccountRequirementsErrorCode'EnumVerificationDocumentPhotoMismatch) = "verification_document_photo_mismatch"
  toJSON (AccountRequirementsErrorCode'EnumVerificationDocumentTooLarge) = "verification_document_too_large"
  toJSON (AccountRequirementsErrorCode'EnumVerificationDocumentTypeNotSupported) = "verification_document_type_not_supported"
  toJSON (AccountRequirementsErrorCode'EnumVerificationFailedAddressMatch) = "verification_failed_address_match"
  toJSON (AccountRequirementsErrorCode'EnumVerificationFailedBusinessIecNumber) = "verification_failed_business_iec_number"
  toJSON (AccountRequirementsErrorCode'EnumVerificationFailedDocumentMatch) = "verification_failed_document_match"
  toJSON (AccountRequirementsErrorCode'EnumVerificationFailedIdNumberMatch) = "verification_failed_id_number_match"
  toJSON (AccountRequirementsErrorCode'EnumVerificationFailedKeyedIdentity) = "verification_failed_keyed_identity"
  toJSON (AccountRequirementsErrorCode'EnumVerificationFailedKeyedMatch) = "verification_failed_keyed_match"
  toJSON (AccountRequirementsErrorCode'EnumVerificationFailedNameMatch) = "verification_failed_name_match"
  toJSON (AccountRequirementsErrorCode'EnumVerificationFailedOther) = "verification_failed_other"
  toJSON (AccountRequirementsErrorCode'EnumVerificationFailedTaxIdMatch) = "verification_failed_tax_id_match"
  toJSON (AccountRequirementsErrorCode'EnumVerificationFailedTaxIdNotIssued) = "verification_failed_tax_id_not_issued"
  toJSON (AccountRequirementsErrorCode'EnumVerificationMissingExecutives) = "verification_missing_executives"
  toJSON (AccountRequirementsErrorCode'EnumVerificationMissingOwners) = "verification_missing_owners"
  toJSON (AccountRequirementsErrorCode'EnumVerificationRequiresAdditionalMemorandumOfAssociations) = "verification_requires_additional_memorandum_of_associations"

instance Data.Aeson.Types.FromJSON.FromJSON AccountRequirementsErrorCode' where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "invalid_address_city_state_postal_code" -> AccountRequirementsErrorCode'EnumInvalidAddressCityStatePostalCode
            | val GHC.Classes.== "invalid_street_address" -> AccountRequirementsErrorCode'EnumInvalidStreetAddress
            | val GHC.Classes.== "invalid_value_other" -> AccountRequirementsErrorCode'EnumInvalidValueOther
            | val GHC.Classes.== "verification_document_address_mismatch" -> AccountRequirementsErrorCode'EnumVerificationDocumentAddressMismatch
            | val GHC.Classes.== "verification_document_address_missing" -> AccountRequirementsErrorCode'EnumVerificationDocumentAddressMissing
            | val GHC.Classes.== "verification_document_corrupt" -> AccountRequirementsErrorCode'EnumVerificationDocumentCorrupt
            | val GHC.Classes.== "verification_document_country_not_supported" -> AccountRequirementsErrorCode'EnumVerificationDocumentCountryNotSupported
            | val GHC.Classes.== "verification_document_dob_mismatch" -> AccountRequirementsErrorCode'EnumVerificationDocumentDobMismatch
            | val GHC.Classes.== "verification_document_duplicate_type" -> AccountRequirementsErrorCode'EnumVerificationDocumentDuplicateType
            | val GHC.Classes.== "verification_document_expired" -> AccountRequirementsErrorCode'EnumVerificationDocumentExpired
            | val GHC.Classes.== "verification_document_failed_copy" -> AccountRequirementsErrorCode'EnumVerificationDocumentFailedCopy
            | val GHC.Classes.== "verification_document_failed_greyscale" -> AccountRequirementsErrorCode'EnumVerificationDocumentFailedGreyscale
            | val GHC.Classes.== "verification_document_failed_other" -> AccountRequirementsErrorCode'EnumVerificationDocumentFailedOther
            | val GHC.Classes.== "verification_document_failed_test_mode" -> AccountRequirementsErrorCode'EnumVerificationDocumentFailedTestMode
            | val GHC.Classes.== "verification_document_fraudulent" -> AccountRequirementsErrorCode'EnumVerificationDocumentFraudulent
            | val GHC.Classes.== "verification_document_id_number_mismatch" -> AccountRequirementsErrorCode'EnumVerificationDocumentIdNumberMismatch
            | val GHC.Classes.== "verification_document_id_number_missing" -> AccountRequirementsErrorCode'EnumVerificationDocumentIdNumberMissing
            | val GHC.Classes.== "verification_document_incomplete" -> AccountRequirementsErrorCode'EnumVerificationDocumentIncomplete
            | val GHC.Classes.== "verification_document_invalid" -> AccountRequirementsErrorCode'EnumVerificationDocumentInvalid
            | val GHC.Classes.== "verification_document_issue_or_expiry_date_missing" -> AccountRequirementsErrorCode'EnumVerificationDocumentIssueOrExpiryDateMissing
            | val GHC.Classes.== "verification_document_manipulated" -> AccountRequirementsErrorCode'EnumVerificationDocumentManipulated
            | val GHC.Classes.== "verification_document_missing_back" -> AccountRequirementsErrorCode'EnumVerificationDocumentMissingBack
            | val GHC.Classes.== "verification_document_missing_front" -> AccountRequirementsErrorCode'EnumVerificationDocumentMissingFront
            | val GHC.Classes.== "verification_document_name_mismatch" -> AccountRequirementsErrorCode'EnumVerificationDocumentNameMismatch
            | val GHC.Classes.== "verification_document_name_missing" -> AccountRequirementsErrorCode'EnumVerificationDocumentNameMissing
            | val GHC.Classes.== "verification_document_nationality_mismatch" -> AccountRequirementsErrorCode'EnumVerificationDocumentNationalityMismatch
            | val GHC.Classes.== "verification_document_not_readable" -> AccountRequirementsErrorCode'EnumVerificationDocumentNotReadable
            | val GHC.Classes.== "verification_document_not_signed" -> AccountRequirementsErrorCode'EnumVerificationDocumentNotSigned
            | val GHC.Classes.== "verification_document_not_uploaded" -> AccountRequirementsErrorCode'EnumVerificationDocumentNotUploaded
            | val GHC.Classes.== "verification_document_photo_mismatch" -> AccountRequirementsErrorCode'EnumVerificationDocumentPhotoMismatch
            | val GHC.Classes.== "verification_document_too_large" -> AccountRequirementsErrorCode'EnumVerificationDocumentTooLarge
            | val GHC.Classes.== "verification_document_type_not_supported" -> AccountRequirementsErrorCode'EnumVerificationDocumentTypeNotSupported
            | val GHC.Classes.== "verification_failed_address_match" -> AccountRequirementsErrorCode'EnumVerificationFailedAddressMatch
            | val GHC.Classes.== "verification_failed_business_iec_number" -> AccountRequirementsErrorCode'EnumVerificationFailedBusinessIecNumber
            | val GHC.Classes.== "verification_failed_document_match" -> AccountRequirementsErrorCode'EnumVerificationFailedDocumentMatch
            | val GHC.Classes.== "verification_failed_id_number_match" -> AccountRequirementsErrorCode'EnumVerificationFailedIdNumberMatch
            | val GHC.Classes.== "verification_failed_keyed_identity" -> AccountRequirementsErrorCode'EnumVerificationFailedKeyedIdentity
            | val GHC.Classes.== "verification_failed_keyed_match" -> AccountRequirementsErrorCode'EnumVerificationFailedKeyedMatch
            | val GHC.Classes.== "verification_failed_name_match" -> AccountRequirementsErrorCode'EnumVerificationFailedNameMatch
            | val GHC.Classes.== "verification_failed_other" -> AccountRequirementsErrorCode'EnumVerificationFailedOther
            | val GHC.Classes.== "verification_failed_tax_id_match" -> AccountRequirementsErrorCode'EnumVerificationFailedTaxIdMatch
            | val GHC.Classes.== "verification_failed_tax_id_not_issued" -> AccountRequirementsErrorCode'EnumVerificationFailedTaxIdNotIssued
            | val GHC.Classes.== "verification_missing_executives" -> AccountRequirementsErrorCode'EnumVerificationMissingExecutives
            | val GHC.Classes.== "verification_missing_owners" -> AccountRequirementsErrorCode'EnumVerificationMissingOwners
            | val GHC.Classes.== "verification_requires_additional_memorandum_of_associations" -> AccountRequirementsErrorCode'EnumVerificationRequiresAdditionalMemorandumOfAssociations
            | GHC.Base.otherwise -> AccountRequirementsErrorCode'Other val
      )
