{-# LANGUAGE MultiWayIf #-}
-- CHANGE WITH CAUTION: This is a generated code file generated by https://github.com/Haskell-OpenAPI-Code-Generator/Haskell-OpenAPI-Client-Code-Generator.
{-# LANGUAGE OverloadedStrings #-}

-- | Contains the types generated from the schema GelatoSelfieReportError
module StripeAPI.Types.GelatoSelfieReportError where

import qualified Control.Monad.Fail
import qualified Data.Aeson
import qualified Data.Aeson as Data.Aeson.Encoding.Internal
import qualified Data.Aeson as Data.Aeson.Types
import qualified Data.Aeson as Data.Aeson.Types.FromJSON
import qualified Data.Aeson as Data.Aeson.Types.Internal
import qualified Data.Aeson as Data.Aeson.Types.ToJSON
import qualified Data.ByteString.Char8
import qualified Data.ByteString.Char8 as Data.ByteString.Internal
import qualified Data.Functor
import qualified Data.Scientific
import qualified Data.Text
import qualified Data.Text.Internal
import qualified Data.Time.Calendar as Data.Time.Calendar.Days
import qualified Data.Time.LocalTime as Data.Time.LocalTime.Internal.ZonedTime
import qualified GHC.Base
import qualified GHC.Classes
import qualified GHC.Int
import qualified GHC.Show
import qualified GHC.Types
import qualified StripeAPI.Common
import StripeAPI.TypeAlias
import qualified Prelude as GHC.Integer.Type
import qualified Prelude as GHC.Maybe

-- | Defines the object schema located at @components.schemas.gelato_selfie_report_error@ in the specification.
data GelatoSelfieReportError = GelatoSelfieReportError
  { -- | code: A short machine-readable string giving the reason for the verification failure.
    gelatoSelfieReportErrorCode :: (GHC.Maybe.Maybe GelatoSelfieReportErrorCode'),
    -- | reason: A human-readable message giving the reason for the failure. These messages can be shown to your users.
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    gelatoSelfieReportErrorReason :: (GHC.Maybe.Maybe Data.Text.Internal.Text)
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON GelatoSelfieReportError where
  toJSON obj = Data.Aeson.Types.Internal.object ("code" Data.Aeson.Types.ToJSON..= gelatoSelfieReportErrorCode obj : "reason" Data.Aeson.Types.ToJSON..= gelatoSelfieReportErrorReason obj : GHC.Base.mempty)
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (("code" Data.Aeson.Types.ToJSON..= gelatoSelfieReportErrorCode obj) GHC.Base.<> ("reason" Data.Aeson.Types.ToJSON..= gelatoSelfieReportErrorReason obj))

instance Data.Aeson.Types.FromJSON.FromJSON GelatoSelfieReportError where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "GelatoSelfieReportError" (\obj -> (GHC.Base.pure GelatoSelfieReportError GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "code")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "reason"))

-- | Create a new 'GelatoSelfieReportError' with all required fields.
mkGelatoSelfieReportError :: GelatoSelfieReportError
mkGelatoSelfieReportError =
  GelatoSelfieReportError
    { gelatoSelfieReportErrorCode = GHC.Maybe.Nothing,
      gelatoSelfieReportErrorReason = GHC.Maybe.Nothing
    }

-- | Defines the enum schema located at @components.schemas.gelato_selfie_report_error.properties.code@ in the specification.
--
-- A short machine-readable string giving the reason for the verification failure.
data GelatoSelfieReportErrorCode'
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    GelatoSelfieReportErrorCode'Other Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    GelatoSelfieReportErrorCode'Typed Data.Text.Internal.Text
  | -- | Represents the JSON value @"selfie_document_missing_photo"@
    GelatoSelfieReportErrorCode'EnumSelfieDocumentMissingPhoto
  | -- | Represents the JSON value @"selfie_face_mismatch"@
    GelatoSelfieReportErrorCode'EnumSelfieFaceMismatch
  | -- | Represents the JSON value @"selfie_manipulated"@
    GelatoSelfieReportErrorCode'EnumSelfieManipulated
  | -- | Represents the JSON value @"selfie_unverified_other"@
    GelatoSelfieReportErrorCode'EnumSelfieUnverifiedOther
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON GelatoSelfieReportErrorCode' where
  toJSON (GelatoSelfieReportErrorCode'Other val) = val
  toJSON (GelatoSelfieReportErrorCode'Typed val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (GelatoSelfieReportErrorCode'EnumSelfieDocumentMissingPhoto) = "selfie_document_missing_photo"
  toJSON (GelatoSelfieReportErrorCode'EnumSelfieFaceMismatch) = "selfie_face_mismatch"
  toJSON (GelatoSelfieReportErrorCode'EnumSelfieManipulated) = "selfie_manipulated"
  toJSON (GelatoSelfieReportErrorCode'EnumSelfieUnverifiedOther) = "selfie_unverified_other"

instance Data.Aeson.Types.FromJSON.FromJSON GelatoSelfieReportErrorCode' where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "selfie_document_missing_photo" -> GelatoSelfieReportErrorCode'EnumSelfieDocumentMissingPhoto
            | val GHC.Classes.== "selfie_face_mismatch" -> GelatoSelfieReportErrorCode'EnumSelfieFaceMismatch
            | val GHC.Classes.== "selfie_manipulated" -> GelatoSelfieReportErrorCode'EnumSelfieManipulated
            | val GHC.Classes.== "selfie_unverified_other" -> GelatoSelfieReportErrorCode'EnumSelfieUnverifiedOther
            | GHC.Base.otherwise -> GelatoSelfieReportErrorCode'Other val
      )
