{-# LANGUAGE ExplicitForAll #-}
{-# LANGUAGE MultiWayIf #-}
-- CHANGE WITH CAUTION: This is a generated code file generated by https://github.com/Haskell-OpenAPI-Code-Generator/Haskell-OpenAPI-Client-Code-Generator.
{-# LANGUAGE OverloadedStrings #-}

-- | Contains the different functions to run the operation postCheckoutSessions
module StripeAPI.Operations.PostCheckoutSessions where

import qualified Control.Monad.Fail
import qualified Control.Monad.Trans.Reader
import qualified Data.Aeson
import qualified Data.Aeson as Data.Aeson.Encoding.Internal
import qualified Data.Aeson as Data.Aeson.Types
import qualified Data.Aeson as Data.Aeson.Types.FromJSON
import qualified Data.Aeson as Data.Aeson.Types.Internal
import qualified Data.Aeson as Data.Aeson.Types.ToJSON
import qualified Data.ByteString.Char8
import qualified Data.ByteString.Char8 as Data.ByteString.Internal
import qualified Data.Either
import qualified Data.Functor
import qualified Data.Scientific
import qualified Data.Text
import qualified Data.Text.Internal
import qualified Data.Time.Calendar as Data.Time.Calendar.Days
import qualified Data.Time.LocalTime as Data.Time.LocalTime.Internal.ZonedTime
import qualified Data.Vector
import qualified GHC.Base
import qualified GHC.Classes
import qualified GHC.Int
import qualified GHC.Show
import qualified GHC.Types
import qualified Network.HTTP.Client
import qualified Network.HTTP.Client as Network.HTTP.Client.Request
import qualified Network.HTTP.Client as Network.HTTP.Client.Types
import qualified Network.HTTP.Simple
import qualified Network.HTTP.Types
import qualified Network.HTTP.Types as Network.HTTP.Types.Status
import qualified Network.HTTP.Types as Network.HTTP.Types.URI
import qualified StripeAPI.Common
import StripeAPI.Types
import qualified Prelude as GHC.Integer.Type
import qualified Prelude as GHC.Maybe

-- | > POST /v1/checkout/sessions
--
-- \<p>Creates a Session object.\<\/p>
postCheckoutSessions ::
  forall m.
  StripeAPI.Common.MonadHTTP m =>
  -- | The request body to send
  PostCheckoutSessionsRequestBody ->
  -- | Monadic computation which returns the result of the operation
  StripeAPI.Common.ClientT m (Network.HTTP.Client.Types.Response PostCheckoutSessionsResponse)
postCheckoutSessions body =
  GHC.Base.fmap
    ( \response_0 ->
        GHC.Base.fmap
          ( Data.Either.either PostCheckoutSessionsResponseError GHC.Base.id
              GHC.Base.. ( \response body ->
                             if
                                 | (\status_1 -> Network.HTTP.Types.Status.statusCode status_1 GHC.Classes.== 200) (Network.HTTP.Client.Types.responseStatus response) ->
                                   PostCheckoutSessionsResponse200
                                     Data.Functor.<$> ( Data.Aeson.eitherDecodeStrict body ::
                                                          Data.Either.Either
                                                            GHC.Base.String
                                                            Checkout'session
                                                      )
                                 | GHC.Base.const GHC.Types.True (Network.HTTP.Client.Types.responseStatus response) ->
                                   PostCheckoutSessionsResponseDefault
                                     Data.Functor.<$> ( Data.Aeson.eitherDecodeStrict body ::
                                                          Data.Either.Either
                                                            GHC.Base.String
                                                            Error
                                                      )
                                 | GHC.Base.otherwise -> Data.Either.Left "Missing default response type"
                         )
                response_0
          )
          response_0
    )
    (StripeAPI.Common.doBodyCallWithConfigurationM (Data.Text.toUpper GHC.Base.$ Data.Text.pack "POST") (Data.Text.pack "/v1/checkout/sessions") GHC.Base.mempty (GHC.Maybe.Just body) StripeAPI.Common.RequestBodyEncodingFormData)

-- | Defines the object schema located at @paths.\/v1\/checkout\/sessions.POST.requestBody.content.application\/x-www-form-urlencoded.schema@ in the specification.
data PostCheckoutSessionsRequestBody = PostCheckoutSessionsRequestBody
  { -- | allow_promotion_codes: Enables user redeemable promotion codes.
    postCheckoutSessionsRequestBodyAllowPromotionCodes :: (GHC.Maybe.Maybe GHC.Types.Bool),
    -- | automatic_tax
    postCheckoutSessionsRequestBodyAutomaticTax :: (GHC.Maybe.Maybe PostCheckoutSessionsRequestBodyAutomaticTax'),
    -- | billing_address_collection: Specify whether Checkout should collect the customer\'s billing address.
    postCheckoutSessionsRequestBodyBillingAddressCollection :: (GHC.Maybe.Maybe PostCheckoutSessionsRequestBodyBillingAddressCollection'),
    -- | cancel_url: The URL the customer will be directed to if they decide to cancel payment and return to your website.
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    postCheckoutSessionsRequestBodyCancelUrl :: Data.Text.Internal.Text,
    -- | client_reference_id: A unique string to reference the Checkout Session. This can be a
    -- customer ID, a cart ID, or similar, and can be used to reconcile the
    -- session with your internal systems.
    --
    -- Constraints:
    --
    -- * Maximum length of 200
    postCheckoutSessionsRequestBodyClientReferenceId :: (GHC.Maybe.Maybe Data.Text.Internal.Text),
    -- | customer: ID of an existing Customer, if one exists. In \`payment\` mode, the customer’s most recent card
    -- payment method will be used to prefill the email, name, card details, and billing address
    -- on the Checkout page. In \`subscription\` mode, the customer’s [default payment method](https:\/\/stripe.com\/docs\/api\/customers\/update\#update_customer-invoice_settings-default_payment_method)
    -- will be used if it’s a card, and otherwise the most recent card will be used. A valid billing address is required for Checkout to prefill the customer\'s card details.
    --
    -- If the customer changes their email on the Checkout page, the Customer object will be updated with the new email.
    --
    -- If blank for Checkout Sessions in \`payment\` or \`subscription\` mode, Checkout will create a new Customer object based on information provided during the payment flow.
    --
    -- You can set [\`payment_intent_data.setup_future_usage\`](https:\/\/stripe.com\/docs\/api\/checkout\/sessions\/create\#create_checkout_session-payment_intent_data-setup_future_usage) to have Checkout automatically attach the payment method to the Customer you pass in for future reuse.
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    postCheckoutSessionsRequestBodyCustomer :: (GHC.Maybe.Maybe Data.Text.Internal.Text),
    -- | customer_email: If provided, this value will be used when the Customer object is created.
    -- If not provided, customers will be asked to enter their email address.
    -- Use this parameter to prefill customer data if you already have an email
    -- on file. To access information about the customer once a session is
    -- complete, use the \`customer\` field.
    postCheckoutSessionsRequestBodyCustomerEmail :: (GHC.Maybe.Maybe Data.Text.Internal.Text),
    -- | customer_update: Controls what fields on Customer can be updated by the Checkout Session. Can only be provided when \`customer\` is provided.
    postCheckoutSessionsRequestBodyCustomerUpdate :: (GHC.Maybe.Maybe PostCheckoutSessionsRequestBodyCustomerUpdate'),
    -- | discounts: The coupon or promotion code to apply to this Session. Currently, only up to one may be specified.
    postCheckoutSessionsRequestBodyDiscounts :: (GHC.Maybe.Maybe ([PostCheckoutSessionsRequestBodyDiscounts'])),
    -- | expand: Specifies which fields in the response should be expanded.
    postCheckoutSessionsRequestBodyExpand :: (GHC.Maybe.Maybe ([Data.Text.Internal.Text])),
    -- | line_items: A list of items the customer is purchasing. Use this parameter to pass one-time or recurring [Prices](https:\/\/stripe.com\/docs\/api\/prices).
    --
    -- For \`payment\` mode, there is a maximum of 100 line items, however it is recommended to consolidate line items if there are more than a few dozen.
    --
    -- For \`subscription\` mode, there is a maximum of 20 line items with recurring Prices and 20 line items with one-time Prices. Line items with one-time Prices in will be on the initial invoice only.
    postCheckoutSessionsRequestBodyLineItems :: (GHC.Maybe.Maybe ([PostCheckoutSessionsRequestBodyLineItems'])),
    -- | locale: The IETF language tag of the locale Checkout is displayed in. If blank or \`auto\`, the browser\'s locale is used.
    postCheckoutSessionsRequestBodyLocale :: (GHC.Maybe.Maybe PostCheckoutSessionsRequestBodyLocale'),
    -- | metadata: Set of [key-value pairs](https:\/\/stripe.com\/docs\/api\/metadata) that you can attach to an object. This can be useful for storing additional information about the object in a structured format. Individual keys can be unset by posting an empty value to them. All keys can be unset by posting an empty value to \`metadata\`.
    postCheckoutSessionsRequestBodyMetadata :: (GHC.Maybe.Maybe Data.Aeson.Types.Internal.Object),
    -- | mode: The mode of the Checkout Session. Required when using prices or \`setup\` mode. Pass \`subscription\` if the Checkout Session includes at least one recurring item.
    postCheckoutSessionsRequestBodyMode :: (GHC.Maybe.Maybe PostCheckoutSessionsRequestBodyMode'),
    -- | payment_intent_data: A subset of parameters to be passed to PaymentIntent creation for Checkout Sessions in \`payment\` mode.
    postCheckoutSessionsRequestBodyPaymentIntentData :: (GHC.Maybe.Maybe PostCheckoutSessionsRequestBodyPaymentIntentData'),
    -- | payment_method_options: Payment-method-specific configuration.
    postCheckoutSessionsRequestBodyPaymentMethodOptions :: (GHC.Maybe.Maybe PostCheckoutSessionsRequestBodyPaymentMethodOptions'),
    -- | payment_method_types: A list of the types of payment methods (e.g., \`card\`) this Checkout Session can accept.
    --
    -- Read more about the supported payment methods and their requirements in our [payment
    -- method details guide](\/docs\/payments\/checkout\/payment-methods).
    --
    -- If multiple payment methods are passed, Checkout will dynamically reorder them to
    -- prioritize the most relevant payment methods based on the customer\'s location and
    -- other characteristics.
    postCheckoutSessionsRequestBodyPaymentMethodTypes :: (GHC.Maybe.Maybe ([PostCheckoutSessionsRequestBodyPaymentMethodTypes'])),
    -- | setup_intent_data: A subset of parameters to be passed to SetupIntent creation for Checkout Sessions in \`setup\` mode.
    postCheckoutSessionsRequestBodySetupIntentData :: (GHC.Maybe.Maybe PostCheckoutSessionsRequestBodySetupIntentData'),
    -- | shipping_address_collection: When set, provides configuration for Checkout to collect a shipping address from a customer.
    postCheckoutSessionsRequestBodyShippingAddressCollection :: (GHC.Maybe.Maybe PostCheckoutSessionsRequestBodyShippingAddressCollection'),
    -- | shipping_rates: The shipping rate to apply to this Session. Currently, only up to one may be specified
    postCheckoutSessionsRequestBodyShippingRates :: (GHC.Maybe.Maybe ([Data.Text.Internal.Text])),
    -- | submit_type: Describes the type of transaction being performed by Checkout in order to customize
    -- relevant text on the page, such as the submit button. \`submit_type\` can only be
    -- specified on Checkout Sessions in \`payment\` mode, but not Checkout Sessions
    -- in \`subscription\` or \`setup\` mode.
    postCheckoutSessionsRequestBodySubmitType :: (GHC.Maybe.Maybe PostCheckoutSessionsRequestBodySubmitType'),
    -- | subscription_data: A subset of parameters to be passed to subscription creation for Checkout Sessions in \`subscription\` mode.
    postCheckoutSessionsRequestBodySubscriptionData :: (GHC.Maybe.Maybe PostCheckoutSessionsRequestBodySubscriptionData'),
    -- | success_url: The URL to which Stripe should send customers when payment or setup
    -- is complete.
    -- If you’d like access to the Checkout Session for the successful
    -- payment, read more about it in the guide on [fulfilling orders](https:\/\/stripe.com\/docs\/payments\/checkout\/fulfill-orders).
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    postCheckoutSessionsRequestBodySuccessUrl :: Data.Text.Internal.Text,
    -- | tax_id_collection: Controls tax ID collection settings for the session.
    postCheckoutSessionsRequestBodyTaxIdCollection :: (GHC.Maybe.Maybe PostCheckoutSessionsRequestBodyTaxIdCollection')
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostCheckoutSessionsRequestBody where
  toJSON obj = Data.Aeson.Types.Internal.object ("allow_promotion_codes" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodyAllowPromotionCodes obj : "automatic_tax" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodyAutomaticTax obj : "billing_address_collection" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodyBillingAddressCollection obj : "cancel_url" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodyCancelUrl obj : "client_reference_id" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodyClientReferenceId obj : "customer" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodyCustomer obj : "customer_email" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodyCustomerEmail obj : "customer_update" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodyCustomerUpdate obj : "discounts" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodyDiscounts obj : "expand" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodyExpand obj : "line_items" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodyLineItems obj : "locale" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodyLocale obj : "metadata" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodyMetadata obj : "mode" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodyMode obj : "payment_intent_data" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodyPaymentIntentData obj : "payment_method_options" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodyPaymentMethodOptions obj : "payment_method_types" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodyPaymentMethodTypes obj : "setup_intent_data" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodySetupIntentData obj : "shipping_address_collection" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodyShippingAddressCollection obj : "shipping_rates" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodyShippingRates obj : "submit_type" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodySubmitType obj : "subscription_data" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodySubscriptionData obj : "success_url" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodySuccessUrl obj : "tax_id_collection" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodyTaxIdCollection obj : GHC.Base.mempty)
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (("allow_promotion_codes" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodyAllowPromotionCodes obj) GHC.Base.<> (("automatic_tax" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodyAutomaticTax obj) GHC.Base.<> (("billing_address_collection" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodyBillingAddressCollection obj) GHC.Base.<> (("cancel_url" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodyCancelUrl obj) GHC.Base.<> (("client_reference_id" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodyClientReferenceId obj) GHC.Base.<> (("customer" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodyCustomer obj) GHC.Base.<> (("customer_email" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodyCustomerEmail obj) GHC.Base.<> (("customer_update" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodyCustomerUpdate obj) GHC.Base.<> (("discounts" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodyDiscounts obj) GHC.Base.<> (("expand" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodyExpand obj) GHC.Base.<> (("line_items" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodyLineItems obj) GHC.Base.<> (("locale" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodyLocale obj) GHC.Base.<> (("metadata" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodyMetadata obj) GHC.Base.<> (("mode" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodyMode obj) GHC.Base.<> (("payment_intent_data" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodyPaymentIntentData obj) GHC.Base.<> (("payment_method_options" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodyPaymentMethodOptions obj) GHC.Base.<> (("payment_method_types" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodyPaymentMethodTypes obj) GHC.Base.<> (("setup_intent_data" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodySetupIntentData obj) GHC.Base.<> (("shipping_address_collection" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodyShippingAddressCollection obj) GHC.Base.<> (("shipping_rates" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodyShippingRates obj) GHC.Base.<> (("submit_type" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodySubmitType obj) GHC.Base.<> (("subscription_data" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodySubscriptionData obj) GHC.Base.<> (("success_url" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodySuccessUrl obj) GHC.Base.<> ("tax_id_collection" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodyTaxIdCollection obj))))))))))))))))))))))))

instance Data.Aeson.Types.FromJSON.FromJSON PostCheckoutSessionsRequestBody where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostCheckoutSessionsRequestBody" (\obj -> (((((((((((((((((((((((GHC.Base.pure PostCheckoutSessionsRequestBody GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "allow_promotion_codes")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "automatic_tax")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "billing_address_collection")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "cancel_url")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "client_reference_id")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "customer")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "customer_email")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "customer_update")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "discounts")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "expand")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "line_items")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "locale")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "metadata")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "mode")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "payment_intent_data")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "payment_method_options")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "payment_method_types")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "setup_intent_data")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "shipping_address_collection")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "shipping_rates")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "submit_type")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "subscription_data")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "success_url")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "tax_id_collection"))

-- | Create a new 'PostCheckoutSessionsRequestBody' with all required fields.
mkPostCheckoutSessionsRequestBody ::
  -- | 'postCheckoutSessionsRequestBodyCancelUrl'
  Data.Text.Internal.Text ->
  -- | 'postCheckoutSessionsRequestBodySuccessUrl'
  Data.Text.Internal.Text ->
  PostCheckoutSessionsRequestBody
mkPostCheckoutSessionsRequestBody postCheckoutSessionsRequestBodyCancelUrl postCheckoutSessionsRequestBodySuccessUrl =
  PostCheckoutSessionsRequestBody
    { postCheckoutSessionsRequestBodyAllowPromotionCodes = GHC.Maybe.Nothing,
      postCheckoutSessionsRequestBodyAutomaticTax = GHC.Maybe.Nothing,
      postCheckoutSessionsRequestBodyBillingAddressCollection = GHC.Maybe.Nothing,
      postCheckoutSessionsRequestBodyCancelUrl = postCheckoutSessionsRequestBodyCancelUrl,
      postCheckoutSessionsRequestBodyClientReferenceId = GHC.Maybe.Nothing,
      postCheckoutSessionsRequestBodyCustomer = GHC.Maybe.Nothing,
      postCheckoutSessionsRequestBodyCustomerEmail = GHC.Maybe.Nothing,
      postCheckoutSessionsRequestBodyCustomerUpdate = GHC.Maybe.Nothing,
      postCheckoutSessionsRequestBodyDiscounts = GHC.Maybe.Nothing,
      postCheckoutSessionsRequestBodyExpand = GHC.Maybe.Nothing,
      postCheckoutSessionsRequestBodyLineItems = GHC.Maybe.Nothing,
      postCheckoutSessionsRequestBodyLocale = GHC.Maybe.Nothing,
      postCheckoutSessionsRequestBodyMetadata = GHC.Maybe.Nothing,
      postCheckoutSessionsRequestBodyMode = GHC.Maybe.Nothing,
      postCheckoutSessionsRequestBodyPaymentIntentData = GHC.Maybe.Nothing,
      postCheckoutSessionsRequestBodyPaymentMethodOptions = GHC.Maybe.Nothing,
      postCheckoutSessionsRequestBodyPaymentMethodTypes = GHC.Maybe.Nothing,
      postCheckoutSessionsRequestBodySetupIntentData = GHC.Maybe.Nothing,
      postCheckoutSessionsRequestBodyShippingAddressCollection = GHC.Maybe.Nothing,
      postCheckoutSessionsRequestBodyShippingRates = GHC.Maybe.Nothing,
      postCheckoutSessionsRequestBodySubmitType = GHC.Maybe.Nothing,
      postCheckoutSessionsRequestBodySubscriptionData = GHC.Maybe.Nothing,
      postCheckoutSessionsRequestBodySuccessUrl = postCheckoutSessionsRequestBodySuccessUrl,
      postCheckoutSessionsRequestBodyTaxIdCollection = GHC.Maybe.Nothing
    }

-- | Defines the object schema located at @paths.\/v1\/checkout\/sessions.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.automatic_tax@ in the specification.
data PostCheckoutSessionsRequestBodyAutomaticTax' = PostCheckoutSessionsRequestBodyAutomaticTax'
  { -- | enabled
    postCheckoutSessionsRequestBodyAutomaticTax'Enabled :: GHC.Types.Bool
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostCheckoutSessionsRequestBodyAutomaticTax' where
  toJSON obj = Data.Aeson.Types.Internal.object ("enabled" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodyAutomaticTax'Enabled obj : GHC.Base.mempty)
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs ("enabled" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodyAutomaticTax'Enabled obj)

instance Data.Aeson.Types.FromJSON.FromJSON PostCheckoutSessionsRequestBodyAutomaticTax' where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostCheckoutSessionsRequestBodyAutomaticTax'" (\obj -> GHC.Base.pure PostCheckoutSessionsRequestBodyAutomaticTax' GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "enabled"))

-- | Create a new 'PostCheckoutSessionsRequestBodyAutomaticTax'' with all required fields.
mkPostCheckoutSessionsRequestBodyAutomaticTax' ::
  -- | 'postCheckoutSessionsRequestBodyAutomaticTax'Enabled'
  GHC.Types.Bool ->
  PostCheckoutSessionsRequestBodyAutomaticTax'
mkPostCheckoutSessionsRequestBodyAutomaticTax' postCheckoutSessionsRequestBodyAutomaticTax'Enabled = PostCheckoutSessionsRequestBodyAutomaticTax' {postCheckoutSessionsRequestBodyAutomaticTax'Enabled = postCheckoutSessionsRequestBodyAutomaticTax'Enabled}

-- | Defines the enum schema located at @paths.\/v1\/checkout\/sessions.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.billing_address_collection@ in the specification.
--
-- Specify whether Checkout should collect the customer\'s billing address.
data PostCheckoutSessionsRequestBodyBillingAddressCollection'
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    PostCheckoutSessionsRequestBodyBillingAddressCollection'Other Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    PostCheckoutSessionsRequestBodyBillingAddressCollection'Typed Data.Text.Internal.Text
  | -- | Represents the JSON value @"auto"@
    PostCheckoutSessionsRequestBodyBillingAddressCollection'EnumAuto
  | -- | Represents the JSON value @"required"@
    PostCheckoutSessionsRequestBodyBillingAddressCollection'EnumRequired
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PostCheckoutSessionsRequestBodyBillingAddressCollection' where
  toJSON (PostCheckoutSessionsRequestBodyBillingAddressCollection'Other val) = val
  toJSON (PostCheckoutSessionsRequestBodyBillingAddressCollection'Typed val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (PostCheckoutSessionsRequestBodyBillingAddressCollection'EnumAuto) = "auto"
  toJSON (PostCheckoutSessionsRequestBodyBillingAddressCollection'EnumRequired) = "required"

instance Data.Aeson.Types.FromJSON.FromJSON PostCheckoutSessionsRequestBodyBillingAddressCollection' where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "auto" -> PostCheckoutSessionsRequestBodyBillingAddressCollection'EnumAuto
            | val GHC.Classes.== "required" -> PostCheckoutSessionsRequestBodyBillingAddressCollection'EnumRequired
            | GHC.Base.otherwise -> PostCheckoutSessionsRequestBodyBillingAddressCollection'Other val
      )

-- | Defines the object schema located at @paths.\/v1\/checkout\/sessions.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.customer_update@ in the specification.
--
-- Controls what fields on Customer can be updated by the Checkout Session. Can only be provided when \`customer\` is provided.
data PostCheckoutSessionsRequestBodyCustomerUpdate' = PostCheckoutSessionsRequestBodyCustomerUpdate'
  { -- | address
    postCheckoutSessionsRequestBodyCustomerUpdate'Address :: (GHC.Maybe.Maybe PostCheckoutSessionsRequestBodyCustomerUpdate'Address'),
    -- | name
    postCheckoutSessionsRequestBodyCustomerUpdate'Name :: (GHC.Maybe.Maybe PostCheckoutSessionsRequestBodyCustomerUpdate'Name'),
    -- | shipping
    postCheckoutSessionsRequestBodyCustomerUpdate'Shipping :: (GHC.Maybe.Maybe PostCheckoutSessionsRequestBodyCustomerUpdate'Shipping')
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostCheckoutSessionsRequestBodyCustomerUpdate' where
  toJSON obj = Data.Aeson.Types.Internal.object ("address" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodyCustomerUpdate'Address obj : "name" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodyCustomerUpdate'Name obj : "shipping" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodyCustomerUpdate'Shipping obj : GHC.Base.mempty)
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (("address" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodyCustomerUpdate'Address obj) GHC.Base.<> (("name" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodyCustomerUpdate'Name obj) GHC.Base.<> ("shipping" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodyCustomerUpdate'Shipping obj)))

instance Data.Aeson.Types.FromJSON.FromJSON PostCheckoutSessionsRequestBodyCustomerUpdate' where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostCheckoutSessionsRequestBodyCustomerUpdate'" (\obj -> ((GHC.Base.pure PostCheckoutSessionsRequestBodyCustomerUpdate' GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "address")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "name")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "shipping"))

-- | Create a new 'PostCheckoutSessionsRequestBodyCustomerUpdate'' with all required fields.
mkPostCheckoutSessionsRequestBodyCustomerUpdate' :: PostCheckoutSessionsRequestBodyCustomerUpdate'
mkPostCheckoutSessionsRequestBodyCustomerUpdate' =
  PostCheckoutSessionsRequestBodyCustomerUpdate'
    { postCheckoutSessionsRequestBodyCustomerUpdate'Address = GHC.Maybe.Nothing,
      postCheckoutSessionsRequestBodyCustomerUpdate'Name = GHC.Maybe.Nothing,
      postCheckoutSessionsRequestBodyCustomerUpdate'Shipping = GHC.Maybe.Nothing
    }

-- | Defines the enum schema located at @paths.\/v1\/checkout\/sessions.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.customer_update.properties.address@ in the specification.
data PostCheckoutSessionsRequestBodyCustomerUpdate'Address'
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    PostCheckoutSessionsRequestBodyCustomerUpdate'Address'Other Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    PostCheckoutSessionsRequestBodyCustomerUpdate'Address'Typed Data.Text.Internal.Text
  | -- | Represents the JSON value @"auto"@
    PostCheckoutSessionsRequestBodyCustomerUpdate'Address'EnumAuto
  | -- | Represents the JSON value @"never"@
    PostCheckoutSessionsRequestBodyCustomerUpdate'Address'EnumNever
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PostCheckoutSessionsRequestBodyCustomerUpdate'Address' where
  toJSON (PostCheckoutSessionsRequestBodyCustomerUpdate'Address'Other val) = val
  toJSON (PostCheckoutSessionsRequestBodyCustomerUpdate'Address'Typed val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (PostCheckoutSessionsRequestBodyCustomerUpdate'Address'EnumAuto) = "auto"
  toJSON (PostCheckoutSessionsRequestBodyCustomerUpdate'Address'EnumNever) = "never"

instance Data.Aeson.Types.FromJSON.FromJSON PostCheckoutSessionsRequestBodyCustomerUpdate'Address' where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "auto" -> PostCheckoutSessionsRequestBodyCustomerUpdate'Address'EnumAuto
            | val GHC.Classes.== "never" -> PostCheckoutSessionsRequestBodyCustomerUpdate'Address'EnumNever
            | GHC.Base.otherwise -> PostCheckoutSessionsRequestBodyCustomerUpdate'Address'Other val
      )

-- | Defines the enum schema located at @paths.\/v1\/checkout\/sessions.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.customer_update.properties.name@ in the specification.
data PostCheckoutSessionsRequestBodyCustomerUpdate'Name'
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    PostCheckoutSessionsRequestBodyCustomerUpdate'Name'Other Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    PostCheckoutSessionsRequestBodyCustomerUpdate'Name'Typed Data.Text.Internal.Text
  | -- | Represents the JSON value @"auto"@
    PostCheckoutSessionsRequestBodyCustomerUpdate'Name'EnumAuto
  | -- | Represents the JSON value @"never"@
    PostCheckoutSessionsRequestBodyCustomerUpdate'Name'EnumNever
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PostCheckoutSessionsRequestBodyCustomerUpdate'Name' where
  toJSON (PostCheckoutSessionsRequestBodyCustomerUpdate'Name'Other val) = val
  toJSON (PostCheckoutSessionsRequestBodyCustomerUpdate'Name'Typed val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (PostCheckoutSessionsRequestBodyCustomerUpdate'Name'EnumAuto) = "auto"
  toJSON (PostCheckoutSessionsRequestBodyCustomerUpdate'Name'EnumNever) = "never"

instance Data.Aeson.Types.FromJSON.FromJSON PostCheckoutSessionsRequestBodyCustomerUpdate'Name' where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "auto" -> PostCheckoutSessionsRequestBodyCustomerUpdate'Name'EnumAuto
            | val GHC.Classes.== "never" -> PostCheckoutSessionsRequestBodyCustomerUpdate'Name'EnumNever
            | GHC.Base.otherwise -> PostCheckoutSessionsRequestBodyCustomerUpdate'Name'Other val
      )

-- | Defines the enum schema located at @paths.\/v1\/checkout\/sessions.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.customer_update.properties.shipping@ in the specification.
data PostCheckoutSessionsRequestBodyCustomerUpdate'Shipping'
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    PostCheckoutSessionsRequestBodyCustomerUpdate'Shipping'Other Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    PostCheckoutSessionsRequestBodyCustomerUpdate'Shipping'Typed Data.Text.Internal.Text
  | -- | Represents the JSON value @"auto"@
    PostCheckoutSessionsRequestBodyCustomerUpdate'Shipping'EnumAuto
  | -- | Represents the JSON value @"never"@
    PostCheckoutSessionsRequestBodyCustomerUpdate'Shipping'EnumNever
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PostCheckoutSessionsRequestBodyCustomerUpdate'Shipping' where
  toJSON (PostCheckoutSessionsRequestBodyCustomerUpdate'Shipping'Other val) = val
  toJSON (PostCheckoutSessionsRequestBodyCustomerUpdate'Shipping'Typed val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (PostCheckoutSessionsRequestBodyCustomerUpdate'Shipping'EnumAuto) = "auto"
  toJSON (PostCheckoutSessionsRequestBodyCustomerUpdate'Shipping'EnumNever) = "never"

instance Data.Aeson.Types.FromJSON.FromJSON PostCheckoutSessionsRequestBodyCustomerUpdate'Shipping' where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "auto" -> PostCheckoutSessionsRequestBodyCustomerUpdate'Shipping'EnumAuto
            | val GHC.Classes.== "never" -> PostCheckoutSessionsRequestBodyCustomerUpdate'Shipping'EnumNever
            | GHC.Base.otherwise -> PostCheckoutSessionsRequestBodyCustomerUpdate'Shipping'Other val
      )

-- | Defines the object schema located at @paths.\/v1\/checkout\/sessions.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.discounts.items@ in the specification.
data PostCheckoutSessionsRequestBodyDiscounts' = PostCheckoutSessionsRequestBodyDiscounts'
  { -- | coupon
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    postCheckoutSessionsRequestBodyDiscounts'Coupon :: (GHC.Maybe.Maybe Data.Text.Internal.Text),
    -- | promotion_code
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    postCheckoutSessionsRequestBodyDiscounts'PromotionCode :: (GHC.Maybe.Maybe Data.Text.Internal.Text)
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostCheckoutSessionsRequestBodyDiscounts' where
  toJSON obj = Data.Aeson.Types.Internal.object ("coupon" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodyDiscounts'Coupon obj : "promotion_code" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodyDiscounts'PromotionCode obj : GHC.Base.mempty)
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (("coupon" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodyDiscounts'Coupon obj) GHC.Base.<> ("promotion_code" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodyDiscounts'PromotionCode obj))

instance Data.Aeson.Types.FromJSON.FromJSON PostCheckoutSessionsRequestBodyDiscounts' where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostCheckoutSessionsRequestBodyDiscounts'" (\obj -> (GHC.Base.pure PostCheckoutSessionsRequestBodyDiscounts' GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "coupon")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "promotion_code"))

-- | Create a new 'PostCheckoutSessionsRequestBodyDiscounts'' with all required fields.
mkPostCheckoutSessionsRequestBodyDiscounts' :: PostCheckoutSessionsRequestBodyDiscounts'
mkPostCheckoutSessionsRequestBodyDiscounts' =
  PostCheckoutSessionsRequestBodyDiscounts'
    { postCheckoutSessionsRequestBodyDiscounts'Coupon = GHC.Maybe.Nothing,
      postCheckoutSessionsRequestBodyDiscounts'PromotionCode = GHC.Maybe.Nothing
    }

-- | Defines the object schema located at @paths.\/v1\/checkout\/sessions.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.line_items.items@ in the specification.
data PostCheckoutSessionsRequestBodyLineItems' = PostCheckoutSessionsRequestBodyLineItems'
  { -- | adjustable_quantity
    postCheckoutSessionsRequestBodyLineItems'AdjustableQuantity :: (GHC.Maybe.Maybe PostCheckoutSessionsRequestBodyLineItems'AdjustableQuantity'),
    -- | amount
    postCheckoutSessionsRequestBodyLineItems'Amount :: (GHC.Maybe.Maybe GHC.Types.Int),
    -- | currency
    postCheckoutSessionsRequestBodyLineItems'Currency :: (GHC.Maybe.Maybe Data.Text.Internal.Text),
    -- | description
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    postCheckoutSessionsRequestBodyLineItems'Description :: (GHC.Maybe.Maybe Data.Text.Internal.Text),
    -- | dynamic_tax_rates
    postCheckoutSessionsRequestBodyLineItems'DynamicTaxRates :: (GHC.Maybe.Maybe ([Data.Text.Internal.Text])),
    -- | images
    postCheckoutSessionsRequestBodyLineItems'Images :: (GHC.Maybe.Maybe ([Data.Text.Internal.Text])),
    -- | name
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    postCheckoutSessionsRequestBodyLineItems'Name :: (GHC.Maybe.Maybe Data.Text.Internal.Text),
    -- | price
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    postCheckoutSessionsRequestBodyLineItems'Price :: (GHC.Maybe.Maybe Data.Text.Internal.Text),
    -- | price_data
    postCheckoutSessionsRequestBodyLineItems'PriceData :: (GHC.Maybe.Maybe PostCheckoutSessionsRequestBodyLineItems'PriceData'),
    -- | quantity
    postCheckoutSessionsRequestBodyLineItems'Quantity :: (GHC.Maybe.Maybe GHC.Types.Int),
    -- | tax_rates
    postCheckoutSessionsRequestBodyLineItems'TaxRates :: (GHC.Maybe.Maybe ([Data.Text.Internal.Text]))
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostCheckoutSessionsRequestBodyLineItems' where
  toJSON obj = Data.Aeson.Types.Internal.object ("adjustable_quantity" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodyLineItems'AdjustableQuantity obj : "amount" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodyLineItems'Amount obj : "currency" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodyLineItems'Currency obj : "description" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodyLineItems'Description obj : "dynamic_tax_rates" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodyLineItems'DynamicTaxRates obj : "images" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodyLineItems'Images obj : "name" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodyLineItems'Name obj : "price" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodyLineItems'Price obj : "price_data" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodyLineItems'PriceData obj : "quantity" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodyLineItems'Quantity obj : "tax_rates" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodyLineItems'TaxRates obj : GHC.Base.mempty)
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (("adjustable_quantity" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodyLineItems'AdjustableQuantity obj) GHC.Base.<> (("amount" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodyLineItems'Amount obj) GHC.Base.<> (("currency" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodyLineItems'Currency obj) GHC.Base.<> (("description" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodyLineItems'Description obj) GHC.Base.<> (("dynamic_tax_rates" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodyLineItems'DynamicTaxRates obj) GHC.Base.<> (("images" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodyLineItems'Images obj) GHC.Base.<> (("name" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodyLineItems'Name obj) GHC.Base.<> (("price" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodyLineItems'Price obj) GHC.Base.<> (("price_data" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodyLineItems'PriceData obj) GHC.Base.<> (("quantity" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodyLineItems'Quantity obj) GHC.Base.<> ("tax_rates" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodyLineItems'TaxRates obj)))))))))))

instance Data.Aeson.Types.FromJSON.FromJSON PostCheckoutSessionsRequestBodyLineItems' where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostCheckoutSessionsRequestBodyLineItems'" (\obj -> ((((((((((GHC.Base.pure PostCheckoutSessionsRequestBodyLineItems' GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "adjustable_quantity")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "amount")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "currency")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "description")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "dynamic_tax_rates")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "images")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "name")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "price")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "price_data")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "quantity")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "tax_rates"))

-- | Create a new 'PostCheckoutSessionsRequestBodyLineItems'' with all required fields.
mkPostCheckoutSessionsRequestBodyLineItems' :: PostCheckoutSessionsRequestBodyLineItems'
mkPostCheckoutSessionsRequestBodyLineItems' =
  PostCheckoutSessionsRequestBodyLineItems'
    { postCheckoutSessionsRequestBodyLineItems'AdjustableQuantity = GHC.Maybe.Nothing,
      postCheckoutSessionsRequestBodyLineItems'Amount = GHC.Maybe.Nothing,
      postCheckoutSessionsRequestBodyLineItems'Currency = GHC.Maybe.Nothing,
      postCheckoutSessionsRequestBodyLineItems'Description = GHC.Maybe.Nothing,
      postCheckoutSessionsRequestBodyLineItems'DynamicTaxRates = GHC.Maybe.Nothing,
      postCheckoutSessionsRequestBodyLineItems'Images = GHC.Maybe.Nothing,
      postCheckoutSessionsRequestBodyLineItems'Name = GHC.Maybe.Nothing,
      postCheckoutSessionsRequestBodyLineItems'Price = GHC.Maybe.Nothing,
      postCheckoutSessionsRequestBodyLineItems'PriceData = GHC.Maybe.Nothing,
      postCheckoutSessionsRequestBodyLineItems'Quantity = GHC.Maybe.Nothing,
      postCheckoutSessionsRequestBodyLineItems'TaxRates = GHC.Maybe.Nothing
    }

-- | Defines the object schema located at @paths.\/v1\/checkout\/sessions.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.line_items.items.properties.adjustable_quantity@ in the specification.
data PostCheckoutSessionsRequestBodyLineItems'AdjustableQuantity' = PostCheckoutSessionsRequestBodyLineItems'AdjustableQuantity'
  { -- | enabled
    postCheckoutSessionsRequestBodyLineItems'AdjustableQuantity'Enabled :: GHC.Types.Bool,
    -- | maximum
    postCheckoutSessionsRequestBodyLineItems'AdjustableQuantity'Maximum :: (GHC.Maybe.Maybe GHC.Types.Int),
    -- | minimum
    postCheckoutSessionsRequestBodyLineItems'AdjustableQuantity'Minimum :: (GHC.Maybe.Maybe GHC.Types.Int)
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostCheckoutSessionsRequestBodyLineItems'AdjustableQuantity' where
  toJSON obj = Data.Aeson.Types.Internal.object ("enabled" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodyLineItems'AdjustableQuantity'Enabled obj : "maximum" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodyLineItems'AdjustableQuantity'Maximum obj : "minimum" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodyLineItems'AdjustableQuantity'Minimum obj : GHC.Base.mempty)
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (("enabled" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodyLineItems'AdjustableQuantity'Enabled obj) GHC.Base.<> (("maximum" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodyLineItems'AdjustableQuantity'Maximum obj) GHC.Base.<> ("minimum" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodyLineItems'AdjustableQuantity'Minimum obj)))

instance Data.Aeson.Types.FromJSON.FromJSON PostCheckoutSessionsRequestBodyLineItems'AdjustableQuantity' where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostCheckoutSessionsRequestBodyLineItems'AdjustableQuantity'" (\obj -> ((GHC.Base.pure PostCheckoutSessionsRequestBodyLineItems'AdjustableQuantity' GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "enabled")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "maximum")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "minimum"))

-- | Create a new 'PostCheckoutSessionsRequestBodyLineItems'AdjustableQuantity'' with all required fields.
mkPostCheckoutSessionsRequestBodyLineItems'AdjustableQuantity' ::
  -- | 'postCheckoutSessionsRequestBodyLineItems'AdjustableQuantity'Enabled'
  GHC.Types.Bool ->
  PostCheckoutSessionsRequestBodyLineItems'AdjustableQuantity'
mkPostCheckoutSessionsRequestBodyLineItems'AdjustableQuantity' postCheckoutSessionsRequestBodyLineItems'AdjustableQuantity'Enabled =
  PostCheckoutSessionsRequestBodyLineItems'AdjustableQuantity'
    { postCheckoutSessionsRequestBodyLineItems'AdjustableQuantity'Enabled = postCheckoutSessionsRequestBodyLineItems'AdjustableQuantity'Enabled,
      postCheckoutSessionsRequestBodyLineItems'AdjustableQuantity'Maximum = GHC.Maybe.Nothing,
      postCheckoutSessionsRequestBodyLineItems'AdjustableQuantity'Minimum = GHC.Maybe.Nothing
    }

-- | Defines the object schema located at @paths.\/v1\/checkout\/sessions.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.line_items.items.properties.price_data@ in the specification.
data PostCheckoutSessionsRequestBodyLineItems'PriceData' = PostCheckoutSessionsRequestBodyLineItems'PriceData'
  { -- | currency
    postCheckoutSessionsRequestBodyLineItems'PriceData'Currency :: Data.Text.Internal.Text,
    -- | product
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    postCheckoutSessionsRequestBodyLineItems'PriceData'Product :: (GHC.Maybe.Maybe Data.Text.Internal.Text),
    -- | product_data
    postCheckoutSessionsRequestBodyLineItems'PriceData'ProductData :: (GHC.Maybe.Maybe PostCheckoutSessionsRequestBodyLineItems'PriceData'ProductData'),
    -- | recurring
    postCheckoutSessionsRequestBodyLineItems'PriceData'Recurring :: (GHC.Maybe.Maybe PostCheckoutSessionsRequestBodyLineItems'PriceData'Recurring'),
    -- | tax_behavior
    postCheckoutSessionsRequestBodyLineItems'PriceData'TaxBehavior :: (GHC.Maybe.Maybe PostCheckoutSessionsRequestBodyLineItems'PriceData'TaxBehavior'),
    -- | unit_amount
    postCheckoutSessionsRequestBodyLineItems'PriceData'UnitAmount :: (GHC.Maybe.Maybe GHC.Types.Int),
    -- | unit_amount_decimal
    postCheckoutSessionsRequestBodyLineItems'PriceData'UnitAmountDecimal :: (GHC.Maybe.Maybe Data.Text.Internal.Text)
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostCheckoutSessionsRequestBodyLineItems'PriceData' where
  toJSON obj = Data.Aeson.Types.Internal.object ("currency" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodyLineItems'PriceData'Currency obj : "product" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodyLineItems'PriceData'Product obj : "product_data" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodyLineItems'PriceData'ProductData obj : "recurring" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodyLineItems'PriceData'Recurring obj : "tax_behavior" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodyLineItems'PriceData'TaxBehavior obj : "unit_amount" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodyLineItems'PriceData'UnitAmount obj : "unit_amount_decimal" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodyLineItems'PriceData'UnitAmountDecimal obj : GHC.Base.mempty)
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (("currency" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodyLineItems'PriceData'Currency obj) GHC.Base.<> (("product" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodyLineItems'PriceData'Product obj) GHC.Base.<> (("product_data" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodyLineItems'PriceData'ProductData obj) GHC.Base.<> (("recurring" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodyLineItems'PriceData'Recurring obj) GHC.Base.<> (("tax_behavior" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodyLineItems'PriceData'TaxBehavior obj) GHC.Base.<> (("unit_amount" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodyLineItems'PriceData'UnitAmount obj) GHC.Base.<> ("unit_amount_decimal" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodyLineItems'PriceData'UnitAmountDecimal obj)))))))

instance Data.Aeson.Types.FromJSON.FromJSON PostCheckoutSessionsRequestBodyLineItems'PriceData' where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostCheckoutSessionsRequestBodyLineItems'PriceData'" (\obj -> ((((((GHC.Base.pure PostCheckoutSessionsRequestBodyLineItems'PriceData' GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "currency")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "product")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "product_data")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "recurring")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "tax_behavior")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "unit_amount")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "unit_amount_decimal"))

-- | Create a new 'PostCheckoutSessionsRequestBodyLineItems'PriceData'' with all required fields.
mkPostCheckoutSessionsRequestBodyLineItems'PriceData' ::
  -- | 'postCheckoutSessionsRequestBodyLineItems'PriceData'Currency'
  Data.Text.Internal.Text ->
  PostCheckoutSessionsRequestBodyLineItems'PriceData'
mkPostCheckoutSessionsRequestBodyLineItems'PriceData' postCheckoutSessionsRequestBodyLineItems'PriceData'Currency =
  PostCheckoutSessionsRequestBodyLineItems'PriceData'
    { postCheckoutSessionsRequestBodyLineItems'PriceData'Currency = postCheckoutSessionsRequestBodyLineItems'PriceData'Currency,
      postCheckoutSessionsRequestBodyLineItems'PriceData'Product = GHC.Maybe.Nothing,
      postCheckoutSessionsRequestBodyLineItems'PriceData'ProductData = GHC.Maybe.Nothing,
      postCheckoutSessionsRequestBodyLineItems'PriceData'Recurring = GHC.Maybe.Nothing,
      postCheckoutSessionsRequestBodyLineItems'PriceData'TaxBehavior = GHC.Maybe.Nothing,
      postCheckoutSessionsRequestBodyLineItems'PriceData'UnitAmount = GHC.Maybe.Nothing,
      postCheckoutSessionsRequestBodyLineItems'PriceData'UnitAmountDecimal = GHC.Maybe.Nothing
    }

-- | Defines the object schema located at @paths.\/v1\/checkout\/sessions.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.line_items.items.properties.price_data.properties.product_data@ in the specification.
data PostCheckoutSessionsRequestBodyLineItems'PriceData'ProductData' = PostCheckoutSessionsRequestBodyLineItems'PriceData'ProductData'
  { -- | description
    --
    -- Constraints:
    --
    -- * Maximum length of 40000
    postCheckoutSessionsRequestBodyLineItems'PriceData'ProductData'Description :: (GHC.Maybe.Maybe Data.Text.Internal.Text),
    -- | images
    postCheckoutSessionsRequestBodyLineItems'PriceData'ProductData'Images :: (GHC.Maybe.Maybe ([Data.Text.Internal.Text])),
    -- | metadata
    postCheckoutSessionsRequestBodyLineItems'PriceData'ProductData'Metadata :: (GHC.Maybe.Maybe Data.Aeson.Types.Internal.Object),
    -- | name
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    postCheckoutSessionsRequestBodyLineItems'PriceData'ProductData'Name :: Data.Text.Internal.Text,
    -- | tax_code
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    postCheckoutSessionsRequestBodyLineItems'PriceData'ProductData'TaxCode :: (GHC.Maybe.Maybe Data.Text.Internal.Text)
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostCheckoutSessionsRequestBodyLineItems'PriceData'ProductData' where
  toJSON obj = Data.Aeson.Types.Internal.object ("description" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodyLineItems'PriceData'ProductData'Description obj : "images" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodyLineItems'PriceData'ProductData'Images obj : "metadata" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodyLineItems'PriceData'ProductData'Metadata obj : "name" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodyLineItems'PriceData'ProductData'Name obj : "tax_code" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodyLineItems'PriceData'ProductData'TaxCode obj : GHC.Base.mempty)
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (("description" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodyLineItems'PriceData'ProductData'Description obj) GHC.Base.<> (("images" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodyLineItems'PriceData'ProductData'Images obj) GHC.Base.<> (("metadata" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodyLineItems'PriceData'ProductData'Metadata obj) GHC.Base.<> (("name" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodyLineItems'PriceData'ProductData'Name obj) GHC.Base.<> ("tax_code" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodyLineItems'PriceData'ProductData'TaxCode obj)))))

instance Data.Aeson.Types.FromJSON.FromJSON PostCheckoutSessionsRequestBodyLineItems'PriceData'ProductData' where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostCheckoutSessionsRequestBodyLineItems'PriceData'ProductData'" (\obj -> ((((GHC.Base.pure PostCheckoutSessionsRequestBodyLineItems'PriceData'ProductData' GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "description")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "images")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "metadata")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "name")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "tax_code"))

-- | Create a new 'PostCheckoutSessionsRequestBodyLineItems'PriceData'ProductData'' with all required fields.
mkPostCheckoutSessionsRequestBodyLineItems'PriceData'ProductData' ::
  -- | 'postCheckoutSessionsRequestBodyLineItems'PriceData'ProductData'Name'
  Data.Text.Internal.Text ->
  PostCheckoutSessionsRequestBodyLineItems'PriceData'ProductData'
mkPostCheckoutSessionsRequestBodyLineItems'PriceData'ProductData' postCheckoutSessionsRequestBodyLineItems'PriceData'ProductData'Name =
  PostCheckoutSessionsRequestBodyLineItems'PriceData'ProductData'
    { postCheckoutSessionsRequestBodyLineItems'PriceData'ProductData'Description = GHC.Maybe.Nothing,
      postCheckoutSessionsRequestBodyLineItems'PriceData'ProductData'Images = GHC.Maybe.Nothing,
      postCheckoutSessionsRequestBodyLineItems'PriceData'ProductData'Metadata = GHC.Maybe.Nothing,
      postCheckoutSessionsRequestBodyLineItems'PriceData'ProductData'Name = postCheckoutSessionsRequestBodyLineItems'PriceData'ProductData'Name,
      postCheckoutSessionsRequestBodyLineItems'PriceData'ProductData'TaxCode = GHC.Maybe.Nothing
    }

-- | Defines the object schema located at @paths.\/v1\/checkout\/sessions.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.line_items.items.properties.price_data.properties.recurring@ in the specification.
data PostCheckoutSessionsRequestBodyLineItems'PriceData'Recurring' = PostCheckoutSessionsRequestBodyLineItems'PriceData'Recurring'
  { -- | interval
    postCheckoutSessionsRequestBodyLineItems'PriceData'Recurring'Interval :: PostCheckoutSessionsRequestBodyLineItems'PriceData'Recurring'Interval',
    -- | interval_count
    postCheckoutSessionsRequestBodyLineItems'PriceData'Recurring'IntervalCount :: (GHC.Maybe.Maybe GHC.Types.Int)
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostCheckoutSessionsRequestBodyLineItems'PriceData'Recurring' where
  toJSON obj = Data.Aeson.Types.Internal.object ("interval" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodyLineItems'PriceData'Recurring'Interval obj : "interval_count" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodyLineItems'PriceData'Recurring'IntervalCount obj : GHC.Base.mempty)
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (("interval" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodyLineItems'PriceData'Recurring'Interval obj) GHC.Base.<> ("interval_count" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodyLineItems'PriceData'Recurring'IntervalCount obj))

instance Data.Aeson.Types.FromJSON.FromJSON PostCheckoutSessionsRequestBodyLineItems'PriceData'Recurring' where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostCheckoutSessionsRequestBodyLineItems'PriceData'Recurring'" (\obj -> (GHC.Base.pure PostCheckoutSessionsRequestBodyLineItems'PriceData'Recurring' GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "interval")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "interval_count"))

-- | Create a new 'PostCheckoutSessionsRequestBodyLineItems'PriceData'Recurring'' with all required fields.
mkPostCheckoutSessionsRequestBodyLineItems'PriceData'Recurring' ::
  -- | 'postCheckoutSessionsRequestBodyLineItems'PriceData'Recurring'Interval'
  PostCheckoutSessionsRequestBodyLineItems'PriceData'Recurring'Interval' ->
  PostCheckoutSessionsRequestBodyLineItems'PriceData'Recurring'
mkPostCheckoutSessionsRequestBodyLineItems'PriceData'Recurring' postCheckoutSessionsRequestBodyLineItems'PriceData'Recurring'Interval =
  PostCheckoutSessionsRequestBodyLineItems'PriceData'Recurring'
    { postCheckoutSessionsRequestBodyLineItems'PriceData'Recurring'Interval = postCheckoutSessionsRequestBodyLineItems'PriceData'Recurring'Interval,
      postCheckoutSessionsRequestBodyLineItems'PriceData'Recurring'IntervalCount = GHC.Maybe.Nothing
    }

-- | Defines the enum schema located at @paths.\/v1\/checkout\/sessions.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.line_items.items.properties.price_data.properties.recurring.properties.interval@ in the specification.
data PostCheckoutSessionsRequestBodyLineItems'PriceData'Recurring'Interval'
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    PostCheckoutSessionsRequestBodyLineItems'PriceData'Recurring'Interval'Other Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    PostCheckoutSessionsRequestBodyLineItems'PriceData'Recurring'Interval'Typed Data.Text.Internal.Text
  | -- | Represents the JSON value @"day"@
    PostCheckoutSessionsRequestBodyLineItems'PriceData'Recurring'Interval'EnumDay
  | -- | Represents the JSON value @"month"@
    PostCheckoutSessionsRequestBodyLineItems'PriceData'Recurring'Interval'EnumMonth
  | -- | Represents the JSON value @"week"@
    PostCheckoutSessionsRequestBodyLineItems'PriceData'Recurring'Interval'EnumWeek
  | -- | Represents the JSON value @"year"@
    PostCheckoutSessionsRequestBodyLineItems'PriceData'Recurring'Interval'EnumYear
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PostCheckoutSessionsRequestBodyLineItems'PriceData'Recurring'Interval' where
  toJSON (PostCheckoutSessionsRequestBodyLineItems'PriceData'Recurring'Interval'Other val) = val
  toJSON (PostCheckoutSessionsRequestBodyLineItems'PriceData'Recurring'Interval'Typed val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (PostCheckoutSessionsRequestBodyLineItems'PriceData'Recurring'Interval'EnumDay) = "day"
  toJSON (PostCheckoutSessionsRequestBodyLineItems'PriceData'Recurring'Interval'EnumMonth) = "month"
  toJSON (PostCheckoutSessionsRequestBodyLineItems'PriceData'Recurring'Interval'EnumWeek) = "week"
  toJSON (PostCheckoutSessionsRequestBodyLineItems'PriceData'Recurring'Interval'EnumYear) = "year"

instance Data.Aeson.Types.FromJSON.FromJSON PostCheckoutSessionsRequestBodyLineItems'PriceData'Recurring'Interval' where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "day" -> PostCheckoutSessionsRequestBodyLineItems'PriceData'Recurring'Interval'EnumDay
            | val GHC.Classes.== "month" -> PostCheckoutSessionsRequestBodyLineItems'PriceData'Recurring'Interval'EnumMonth
            | val GHC.Classes.== "week" -> PostCheckoutSessionsRequestBodyLineItems'PriceData'Recurring'Interval'EnumWeek
            | val GHC.Classes.== "year" -> PostCheckoutSessionsRequestBodyLineItems'PriceData'Recurring'Interval'EnumYear
            | GHC.Base.otherwise -> PostCheckoutSessionsRequestBodyLineItems'PriceData'Recurring'Interval'Other val
      )

-- | Defines the enum schema located at @paths.\/v1\/checkout\/sessions.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.line_items.items.properties.price_data.properties.tax_behavior@ in the specification.
data PostCheckoutSessionsRequestBodyLineItems'PriceData'TaxBehavior'
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    PostCheckoutSessionsRequestBodyLineItems'PriceData'TaxBehavior'Other Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    PostCheckoutSessionsRequestBodyLineItems'PriceData'TaxBehavior'Typed Data.Text.Internal.Text
  | -- | Represents the JSON value @"exclusive"@
    PostCheckoutSessionsRequestBodyLineItems'PriceData'TaxBehavior'EnumExclusive
  | -- | Represents the JSON value @"inclusive"@
    PostCheckoutSessionsRequestBodyLineItems'PriceData'TaxBehavior'EnumInclusive
  | -- | Represents the JSON value @"unspecified"@
    PostCheckoutSessionsRequestBodyLineItems'PriceData'TaxBehavior'EnumUnspecified
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PostCheckoutSessionsRequestBodyLineItems'PriceData'TaxBehavior' where
  toJSON (PostCheckoutSessionsRequestBodyLineItems'PriceData'TaxBehavior'Other val) = val
  toJSON (PostCheckoutSessionsRequestBodyLineItems'PriceData'TaxBehavior'Typed val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (PostCheckoutSessionsRequestBodyLineItems'PriceData'TaxBehavior'EnumExclusive) = "exclusive"
  toJSON (PostCheckoutSessionsRequestBodyLineItems'PriceData'TaxBehavior'EnumInclusive) = "inclusive"
  toJSON (PostCheckoutSessionsRequestBodyLineItems'PriceData'TaxBehavior'EnumUnspecified) = "unspecified"

instance Data.Aeson.Types.FromJSON.FromJSON PostCheckoutSessionsRequestBodyLineItems'PriceData'TaxBehavior' where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "exclusive" -> PostCheckoutSessionsRequestBodyLineItems'PriceData'TaxBehavior'EnumExclusive
            | val GHC.Classes.== "inclusive" -> PostCheckoutSessionsRequestBodyLineItems'PriceData'TaxBehavior'EnumInclusive
            | val GHC.Classes.== "unspecified" -> PostCheckoutSessionsRequestBodyLineItems'PriceData'TaxBehavior'EnumUnspecified
            | GHC.Base.otherwise -> PostCheckoutSessionsRequestBodyLineItems'PriceData'TaxBehavior'Other val
      )

-- | Defines the enum schema located at @paths.\/v1\/checkout\/sessions.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.locale@ in the specification.
--
-- The IETF language tag of the locale Checkout is displayed in. If blank or \`auto\`, the browser\'s locale is used.
data PostCheckoutSessionsRequestBodyLocale'
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    PostCheckoutSessionsRequestBodyLocale'Other Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    PostCheckoutSessionsRequestBodyLocale'Typed Data.Text.Internal.Text
  | -- | Represents the JSON value @"auto"@
    PostCheckoutSessionsRequestBodyLocale'EnumAuto
  | -- | Represents the JSON value @"bg"@
    PostCheckoutSessionsRequestBodyLocale'EnumBg
  | -- | Represents the JSON value @"cs"@
    PostCheckoutSessionsRequestBodyLocale'EnumCs
  | -- | Represents the JSON value @"da"@
    PostCheckoutSessionsRequestBodyLocale'EnumDa
  | -- | Represents the JSON value @"de"@
    PostCheckoutSessionsRequestBodyLocale'EnumDe
  | -- | Represents the JSON value @"el"@
    PostCheckoutSessionsRequestBodyLocale'EnumEl
  | -- | Represents the JSON value @"en"@
    PostCheckoutSessionsRequestBodyLocale'EnumEn
  | -- | Represents the JSON value @"en-GB"@
    PostCheckoutSessionsRequestBodyLocale'EnumEnGB
  | -- | Represents the JSON value @"es"@
    PostCheckoutSessionsRequestBodyLocale'EnumEs
  | -- | Represents the JSON value @"es-419"@
    PostCheckoutSessionsRequestBodyLocale'EnumEs_419
  | -- | Represents the JSON value @"et"@
    PostCheckoutSessionsRequestBodyLocale'EnumEt
  | -- | Represents the JSON value @"fi"@
    PostCheckoutSessionsRequestBodyLocale'EnumFi
  | -- | Represents the JSON value @"fr"@
    PostCheckoutSessionsRequestBodyLocale'EnumFr
  | -- | Represents the JSON value @"fr-CA"@
    PostCheckoutSessionsRequestBodyLocale'EnumFrCA
  | -- | Represents the JSON value @"hu"@
    PostCheckoutSessionsRequestBodyLocale'EnumHu
  | -- | Represents the JSON value @"id"@
    PostCheckoutSessionsRequestBodyLocale'EnumId
  | -- | Represents the JSON value @"it"@
    PostCheckoutSessionsRequestBodyLocale'EnumIt
  | -- | Represents the JSON value @"ja"@
    PostCheckoutSessionsRequestBodyLocale'EnumJa
  | -- | Represents the JSON value @"lt"@
    PostCheckoutSessionsRequestBodyLocale'EnumLt
  | -- | Represents the JSON value @"lv"@
    PostCheckoutSessionsRequestBodyLocale'EnumLv
  | -- | Represents the JSON value @"ms"@
    PostCheckoutSessionsRequestBodyLocale'EnumMs
  | -- | Represents the JSON value @"mt"@
    PostCheckoutSessionsRequestBodyLocale'EnumMt
  | -- | Represents the JSON value @"nb"@
    PostCheckoutSessionsRequestBodyLocale'EnumNb
  | -- | Represents the JSON value @"nl"@
    PostCheckoutSessionsRequestBodyLocale'EnumNl
  | -- | Represents the JSON value @"pl"@
    PostCheckoutSessionsRequestBodyLocale'EnumPl
  | -- | Represents the JSON value @"pt"@
    PostCheckoutSessionsRequestBodyLocale'EnumPt
  | -- | Represents the JSON value @"pt-BR"@
    PostCheckoutSessionsRequestBodyLocale'EnumPtBR
  | -- | Represents the JSON value @"ro"@
    PostCheckoutSessionsRequestBodyLocale'EnumRo
  | -- | Represents the JSON value @"ru"@
    PostCheckoutSessionsRequestBodyLocale'EnumRu
  | -- | Represents the JSON value @"sk"@
    PostCheckoutSessionsRequestBodyLocale'EnumSk
  | -- | Represents the JSON value @"sl"@
    PostCheckoutSessionsRequestBodyLocale'EnumSl
  | -- | Represents the JSON value @"sv"@
    PostCheckoutSessionsRequestBodyLocale'EnumSv
  | -- | Represents the JSON value @"th"@
    PostCheckoutSessionsRequestBodyLocale'EnumTh
  | -- | Represents the JSON value @"tr"@
    PostCheckoutSessionsRequestBodyLocale'EnumTr
  | -- | Represents the JSON value @"zh"@
    PostCheckoutSessionsRequestBodyLocale'EnumZh
  | -- | Represents the JSON value @"zh-HK"@
    PostCheckoutSessionsRequestBodyLocale'EnumZhHK
  | -- | Represents the JSON value @"zh-TW"@
    PostCheckoutSessionsRequestBodyLocale'EnumZhTW
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PostCheckoutSessionsRequestBodyLocale' where
  toJSON (PostCheckoutSessionsRequestBodyLocale'Other val) = val
  toJSON (PostCheckoutSessionsRequestBodyLocale'Typed val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (PostCheckoutSessionsRequestBodyLocale'EnumAuto) = "auto"
  toJSON (PostCheckoutSessionsRequestBodyLocale'EnumBg) = "bg"
  toJSON (PostCheckoutSessionsRequestBodyLocale'EnumCs) = "cs"
  toJSON (PostCheckoutSessionsRequestBodyLocale'EnumDa) = "da"
  toJSON (PostCheckoutSessionsRequestBodyLocale'EnumDe) = "de"
  toJSON (PostCheckoutSessionsRequestBodyLocale'EnumEl) = "el"
  toJSON (PostCheckoutSessionsRequestBodyLocale'EnumEn) = "en"
  toJSON (PostCheckoutSessionsRequestBodyLocale'EnumEnGB) = "en-GB"
  toJSON (PostCheckoutSessionsRequestBodyLocale'EnumEs) = "es"
  toJSON (PostCheckoutSessionsRequestBodyLocale'EnumEs_419) = "es-419"
  toJSON (PostCheckoutSessionsRequestBodyLocale'EnumEt) = "et"
  toJSON (PostCheckoutSessionsRequestBodyLocale'EnumFi) = "fi"
  toJSON (PostCheckoutSessionsRequestBodyLocale'EnumFr) = "fr"
  toJSON (PostCheckoutSessionsRequestBodyLocale'EnumFrCA) = "fr-CA"
  toJSON (PostCheckoutSessionsRequestBodyLocale'EnumHu) = "hu"
  toJSON (PostCheckoutSessionsRequestBodyLocale'EnumId) = "id"
  toJSON (PostCheckoutSessionsRequestBodyLocale'EnumIt) = "it"
  toJSON (PostCheckoutSessionsRequestBodyLocale'EnumJa) = "ja"
  toJSON (PostCheckoutSessionsRequestBodyLocale'EnumLt) = "lt"
  toJSON (PostCheckoutSessionsRequestBodyLocale'EnumLv) = "lv"
  toJSON (PostCheckoutSessionsRequestBodyLocale'EnumMs) = "ms"
  toJSON (PostCheckoutSessionsRequestBodyLocale'EnumMt) = "mt"
  toJSON (PostCheckoutSessionsRequestBodyLocale'EnumNb) = "nb"
  toJSON (PostCheckoutSessionsRequestBodyLocale'EnumNl) = "nl"
  toJSON (PostCheckoutSessionsRequestBodyLocale'EnumPl) = "pl"
  toJSON (PostCheckoutSessionsRequestBodyLocale'EnumPt) = "pt"
  toJSON (PostCheckoutSessionsRequestBodyLocale'EnumPtBR) = "pt-BR"
  toJSON (PostCheckoutSessionsRequestBodyLocale'EnumRo) = "ro"
  toJSON (PostCheckoutSessionsRequestBodyLocale'EnumRu) = "ru"
  toJSON (PostCheckoutSessionsRequestBodyLocale'EnumSk) = "sk"
  toJSON (PostCheckoutSessionsRequestBodyLocale'EnumSl) = "sl"
  toJSON (PostCheckoutSessionsRequestBodyLocale'EnumSv) = "sv"
  toJSON (PostCheckoutSessionsRequestBodyLocale'EnumTh) = "th"
  toJSON (PostCheckoutSessionsRequestBodyLocale'EnumTr) = "tr"
  toJSON (PostCheckoutSessionsRequestBodyLocale'EnumZh) = "zh"
  toJSON (PostCheckoutSessionsRequestBodyLocale'EnumZhHK) = "zh-HK"
  toJSON (PostCheckoutSessionsRequestBodyLocale'EnumZhTW) = "zh-TW"

instance Data.Aeson.Types.FromJSON.FromJSON PostCheckoutSessionsRequestBodyLocale' where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "auto" -> PostCheckoutSessionsRequestBodyLocale'EnumAuto
            | val GHC.Classes.== "bg" -> PostCheckoutSessionsRequestBodyLocale'EnumBg
            | val GHC.Classes.== "cs" -> PostCheckoutSessionsRequestBodyLocale'EnumCs
            | val GHC.Classes.== "da" -> PostCheckoutSessionsRequestBodyLocale'EnumDa
            | val GHC.Classes.== "de" -> PostCheckoutSessionsRequestBodyLocale'EnumDe
            | val GHC.Classes.== "el" -> PostCheckoutSessionsRequestBodyLocale'EnumEl
            | val GHC.Classes.== "en" -> PostCheckoutSessionsRequestBodyLocale'EnumEn
            | val GHC.Classes.== "en-GB" -> PostCheckoutSessionsRequestBodyLocale'EnumEnGB
            | val GHC.Classes.== "es" -> PostCheckoutSessionsRequestBodyLocale'EnumEs
            | val GHC.Classes.== "es-419" -> PostCheckoutSessionsRequestBodyLocale'EnumEs_419
            | val GHC.Classes.== "et" -> PostCheckoutSessionsRequestBodyLocale'EnumEt
            | val GHC.Classes.== "fi" -> PostCheckoutSessionsRequestBodyLocale'EnumFi
            | val GHC.Classes.== "fr" -> PostCheckoutSessionsRequestBodyLocale'EnumFr
            | val GHC.Classes.== "fr-CA" -> PostCheckoutSessionsRequestBodyLocale'EnumFrCA
            | val GHC.Classes.== "hu" -> PostCheckoutSessionsRequestBodyLocale'EnumHu
            | val GHC.Classes.== "id" -> PostCheckoutSessionsRequestBodyLocale'EnumId
            | val GHC.Classes.== "it" -> PostCheckoutSessionsRequestBodyLocale'EnumIt
            | val GHC.Classes.== "ja" -> PostCheckoutSessionsRequestBodyLocale'EnumJa
            | val GHC.Classes.== "lt" -> PostCheckoutSessionsRequestBodyLocale'EnumLt
            | val GHC.Classes.== "lv" -> PostCheckoutSessionsRequestBodyLocale'EnumLv
            | val GHC.Classes.== "ms" -> PostCheckoutSessionsRequestBodyLocale'EnumMs
            | val GHC.Classes.== "mt" -> PostCheckoutSessionsRequestBodyLocale'EnumMt
            | val GHC.Classes.== "nb" -> PostCheckoutSessionsRequestBodyLocale'EnumNb
            | val GHC.Classes.== "nl" -> PostCheckoutSessionsRequestBodyLocale'EnumNl
            | val GHC.Classes.== "pl" -> PostCheckoutSessionsRequestBodyLocale'EnumPl
            | val GHC.Classes.== "pt" -> PostCheckoutSessionsRequestBodyLocale'EnumPt
            | val GHC.Classes.== "pt-BR" -> PostCheckoutSessionsRequestBodyLocale'EnumPtBR
            | val GHC.Classes.== "ro" -> PostCheckoutSessionsRequestBodyLocale'EnumRo
            | val GHC.Classes.== "ru" -> PostCheckoutSessionsRequestBodyLocale'EnumRu
            | val GHC.Classes.== "sk" -> PostCheckoutSessionsRequestBodyLocale'EnumSk
            | val GHC.Classes.== "sl" -> PostCheckoutSessionsRequestBodyLocale'EnumSl
            | val GHC.Classes.== "sv" -> PostCheckoutSessionsRequestBodyLocale'EnumSv
            | val GHC.Classes.== "th" -> PostCheckoutSessionsRequestBodyLocale'EnumTh
            | val GHC.Classes.== "tr" -> PostCheckoutSessionsRequestBodyLocale'EnumTr
            | val GHC.Classes.== "zh" -> PostCheckoutSessionsRequestBodyLocale'EnumZh
            | val GHC.Classes.== "zh-HK" -> PostCheckoutSessionsRequestBodyLocale'EnumZhHK
            | val GHC.Classes.== "zh-TW" -> PostCheckoutSessionsRequestBodyLocale'EnumZhTW
            | GHC.Base.otherwise -> PostCheckoutSessionsRequestBodyLocale'Other val
      )

-- | Defines the enum schema located at @paths.\/v1\/checkout\/sessions.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.mode@ in the specification.
--
-- The mode of the Checkout Session. Required when using prices or \`setup\` mode. Pass \`subscription\` if the Checkout Session includes at least one recurring item.
data PostCheckoutSessionsRequestBodyMode'
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    PostCheckoutSessionsRequestBodyMode'Other Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    PostCheckoutSessionsRequestBodyMode'Typed Data.Text.Internal.Text
  | -- | Represents the JSON value @"payment"@
    PostCheckoutSessionsRequestBodyMode'EnumPayment
  | -- | Represents the JSON value @"setup"@
    PostCheckoutSessionsRequestBodyMode'EnumSetup
  | -- | Represents the JSON value @"subscription"@
    PostCheckoutSessionsRequestBodyMode'EnumSubscription
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PostCheckoutSessionsRequestBodyMode' where
  toJSON (PostCheckoutSessionsRequestBodyMode'Other val) = val
  toJSON (PostCheckoutSessionsRequestBodyMode'Typed val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (PostCheckoutSessionsRequestBodyMode'EnumPayment) = "payment"
  toJSON (PostCheckoutSessionsRequestBodyMode'EnumSetup) = "setup"
  toJSON (PostCheckoutSessionsRequestBodyMode'EnumSubscription) = "subscription"

instance Data.Aeson.Types.FromJSON.FromJSON PostCheckoutSessionsRequestBodyMode' where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "payment" -> PostCheckoutSessionsRequestBodyMode'EnumPayment
            | val GHC.Classes.== "setup" -> PostCheckoutSessionsRequestBodyMode'EnumSetup
            | val GHC.Classes.== "subscription" -> PostCheckoutSessionsRequestBodyMode'EnumSubscription
            | GHC.Base.otherwise -> PostCheckoutSessionsRequestBodyMode'Other val
      )

-- | Defines the object schema located at @paths.\/v1\/checkout\/sessions.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.payment_intent_data@ in the specification.
--
-- A subset of parameters to be passed to PaymentIntent creation for Checkout Sessions in \`payment\` mode.
data PostCheckoutSessionsRequestBodyPaymentIntentData' = PostCheckoutSessionsRequestBodyPaymentIntentData'
  { -- | application_fee_amount
    postCheckoutSessionsRequestBodyPaymentIntentData'ApplicationFeeAmount :: (GHC.Maybe.Maybe GHC.Types.Int),
    -- | capture_method
    postCheckoutSessionsRequestBodyPaymentIntentData'CaptureMethod :: (GHC.Maybe.Maybe PostCheckoutSessionsRequestBodyPaymentIntentData'CaptureMethod'),
    -- | description
    --
    -- Constraints:
    --
    -- * Maximum length of 1000
    postCheckoutSessionsRequestBodyPaymentIntentData'Description :: (GHC.Maybe.Maybe Data.Text.Internal.Text),
    -- | metadata
    postCheckoutSessionsRequestBodyPaymentIntentData'Metadata :: (GHC.Maybe.Maybe Data.Aeson.Types.Internal.Object),
    -- | on_behalf_of
    postCheckoutSessionsRequestBodyPaymentIntentData'OnBehalfOf :: (GHC.Maybe.Maybe Data.Text.Internal.Text),
    -- | receipt_email
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    postCheckoutSessionsRequestBodyPaymentIntentData'ReceiptEmail :: (GHC.Maybe.Maybe Data.Text.Internal.Text),
    -- | setup_future_usage
    postCheckoutSessionsRequestBodyPaymentIntentData'SetupFutureUsage :: (GHC.Maybe.Maybe PostCheckoutSessionsRequestBodyPaymentIntentData'SetupFutureUsage'),
    -- | shipping
    postCheckoutSessionsRequestBodyPaymentIntentData'Shipping :: (GHC.Maybe.Maybe PostCheckoutSessionsRequestBodyPaymentIntentData'Shipping'),
    -- | statement_descriptor
    --
    -- Constraints:
    --
    -- * Maximum length of 22
    postCheckoutSessionsRequestBodyPaymentIntentData'StatementDescriptor :: (GHC.Maybe.Maybe Data.Text.Internal.Text),
    -- | statement_descriptor_suffix
    --
    -- Constraints:
    --
    -- * Maximum length of 22
    postCheckoutSessionsRequestBodyPaymentIntentData'StatementDescriptorSuffix :: (GHC.Maybe.Maybe Data.Text.Internal.Text),
    -- | transfer_data
    postCheckoutSessionsRequestBodyPaymentIntentData'TransferData :: (GHC.Maybe.Maybe PostCheckoutSessionsRequestBodyPaymentIntentData'TransferData'),
    -- | transfer_group
    postCheckoutSessionsRequestBodyPaymentIntentData'TransferGroup :: (GHC.Maybe.Maybe Data.Text.Internal.Text)
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostCheckoutSessionsRequestBodyPaymentIntentData' where
  toJSON obj = Data.Aeson.Types.Internal.object ("application_fee_amount" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodyPaymentIntentData'ApplicationFeeAmount obj : "capture_method" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodyPaymentIntentData'CaptureMethod obj : "description" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodyPaymentIntentData'Description obj : "metadata" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodyPaymentIntentData'Metadata obj : "on_behalf_of" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodyPaymentIntentData'OnBehalfOf obj : "receipt_email" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodyPaymentIntentData'ReceiptEmail obj : "setup_future_usage" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodyPaymentIntentData'SetupFutureUsage obj : "shipping" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodyPaymentIntentData'Shipping obj : "statement_descriptor" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodyPaymentIntentData'StatementDescriptor obj : "statement_descriptor_suffix" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodyPaymentIntentData'StatementDescriptorSuffix obj : "transfer_data" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodyPaymentIntentData'TransferData obj : "transfer_group" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodyPaymentIntentData'TransferGroup obj : GHC.Base.mempty)
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (("application_fee_amount" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodyPaymentIntentData'ApplicationFeeAmount obj) GHC.Base.<> (("capture_method" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodyPaymentIntentData'CaptureMethod obj) GHC.Base.<> (("description" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodyPaymentIntentData'Description obj) GHC.Base.<> (("metadata" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodyPaymentIntentData'Metadata obj) GHC.Base.<> (("on_behalf_of" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodyPaymentIntentData'OnBehalfOf obj) GHC.Base.<> (("receipt_email" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodyPaymentIntentData'ReceiptEmail obj) GHC.Base.<> (("setup_future_usage" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodyPaymentIntentData'SetupFutureUsage obj) GHC.Base.<> (("shipping" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodyPaymentIntentData'Shipping obj) GHC.Base.<> (("statement_descriptor" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodyPaymentIntentData'StatementDescriptor obj) GHC.Base.<> (("statement_descriptor_suffix" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodyPaymentIntentData'StatementDescriptorSuffix obj) GHC.Base.<> (("transfer_data" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodyPaymentIntentData'TransferData obj) GHC.Base.<> ("transfer_group" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodyPaymentIntentData'TransferGroup obj))))))))))))

instance Data.Aeson.Types.FromJSON.FromJSON PostCheckoutSessionsRequestBodyPaymentIntentData' where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostCheckoutSessionsRequestBodyPaymentIntentData'" (\obj -> (((((((((((GHC.Base.pure PostCheckoutSessionsRequestBodyPaymentIntentData' GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "application_fee_amount")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "capture_method")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "description")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "metadata")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "on_behalf_of")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "receipt_email")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "setup_future_usage")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "shipping")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "statement_descriptor")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "statement_descriptor_suffix")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "transfer_data")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "transfer_group"))

-- | Create a new 'PostCheckoutSessionsRequestBodyPaymentIntentData'' with all required fields.
mkPostCheckoutSessionsRequestBodyPaymentIntentData' :: PostCheckoutSessionsRequestBodyPaymentIntentData'
mkPostCheckoutSessionsRequestBodyPaymentIntentData' =
  PostCheckoutSessionsRequestBodyPaymentIntentData'
    { postCheckoutSessionsRequestBodyPaymentIntentData'ApplicationFeeAmount = GHC.Maybe.Nothing,
      postCheckoutSessionsRequestBodyPaymentIntentData'CaptureMethod = GHC.Maybe.Nothing,
      postCheckoutSessionsRequestBodyPaymentIntentData'Description = GHC.Maybe.Nothing,
      postCheckoutSessionsRequestBodyPaymentIntentData'Metadata = GHC.Maybe.Nothing,
      postCheckoutSessionsRequestBodyPaymentIntentData'OnBehalfOf = GHC.Maybe.Nothing,
      postCheckoutSessionsRequestBodyPaymentIntentData'ReceiptEmail = GHC.Maybe.Nothing,
      postCheckoutSessionsRequestBodyPaymentIntentData'SetupFutureUsage = GHC.Maybe.Nothing,
      postCheckoutSessionsRequestBodyPaymentIntentData'Shipping = GHC.Maybe.Nothing,
      postCheckoutSessionsRequestBodyPaymentIntentData'StatementDescriptor = GHC.Maybe.Nothing,
      postCheckoutSessionsRequestBodyPaymentIntentData'StatementDescriptorSuffix = GHC.Maybe.Nothing,
      postCheckoutSessionsRequestBodyPaymentIntentData'TransferData = GHC.Maybe.Nothing,
      postCheckoutSessionsRequestBodyPaymentIntentData'TransferGroup = GHC.Maybe.Nothing
    }

-- | Defines the enum schema located at @paths.\/v1\/checkout\/sessions.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.payment_intent_data.properties.capture_method@ in the specification.
data PostCheckoutSessionsRequestBodyPaymentIntentData'CaptureMethod'
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    PostCheckoutSessionsRequestBodyPaymentIntentData'CaptureMethod'Other Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    PostCheckoutSessionsRequestBodyPaymentIntentData'CaptureMethod'Typed Data.Text.Internal.Text
  | -- | Represents the JSON value @"automatic"@
    PostCheckoutSessionsRequestBodyPaymentIntentData'CaptureMethod'EnumAutomatic
  | -- | Represents the JSON value @"manual"@
    PostCheckoutSessionsRequestBodyPaymentIntentData'CaptureMethod'EnumManual
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PostCheckoutSessionsRequestBodyPaymentIntentData'CaptureMethod' where
  toJSON (PostCheckoutSessionsRequestBodyPaymentIntentData'CaptureMethod'Other val) = val
  toJSON (PostCheckoutSessionsRequestBodyPaymentIntentData'CaptureMethod'Typed val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (PostCheckoutSessionsRequestBodyPaymentIntentData'CaptureMethod'EnumAutomatic) = "automatic"
  toJSON (PostCheckoutSessionsRequestBodyPaymentIntentData'CaptureMethod'EnumManual) = "manual"

instance Data.Aeson.Types.FromJSON.FromJSON PostCheckoutSessionsRequestBodyPaymentIntentData'CaptureMethod' where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "automatic" -> PostCheckoutSessionsRequestBodyPaymentIntentData'CaptureMethod'EnumAutomatic
            | val GHC.Classes.== "manual" -> PostCheckoutSessionsRequestBodyPaymentIntentData'CaptureMethod'EnumManual
            | GHC.Base.otherwise -> PostCheckoutSessionsRequestBodyPaymentIntentData'CaptureMethod'Other val
      )

-- | Defines the enum schema located at @paths.\/v1\/checkout\/sessions.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.payment_intent_data.properties.setup_future_usage@ in the specification.
data PostCheckoutSessionsRequestBodyPaymentIntentData'SetupFutureUsage'
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    PostCheckoutSessionsRequestBodyPaymentIntentData'SetupFutureUsage'Other Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    PostCheckoutSessionsRequestBodyPaymentIntentData'SetupFutureUsage'Typed Data.Text.Internal.Text
  | -- | Represents the JSON value @"off_session"@
    PostCheckoutSessionsRequestBodyPaymentIntentData'SetupFutureUsage'EnumOffSession
  | -- | Represents the JSON value @"on_session"@
    PostCheckoutSessionsRequestBodyPaymentIntentData'SetupFutureUsage'EnumOnSession
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PostCheckoutSessionsRequestBodyPaymentIntentData'SetupFutureUsage' where
  toJSON (PostCheckoutSessionsRequestBodyPaymentIntentData'SetupFutureUsage'Other val) = val
  toJSON (PostCheckoutSessionsRequestBodyPaymentIntentData'SetupFutureUsage'Typed val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (PostCheckoutSessionsRequestBodyPaymentIntentData'SetupFutureUsage'EnumOffSession) = "off_session"
  toJSON (PostCheckoutSessionsRequestBodyPaymentIntentData'SetupFutureUsage'EnumOnSession) = "on_session"

instance Data.Aeson.Types.FromJSON.FromJSON PostCheckoutSessionsRequestBodyPaymentIntentData'SetupFutureUsage' where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "off_session" -> PostCheckoutSessionsRequestBodyPaymentIntentData'SetupFutureUsage'EnumOffSession
            | val GHC.Classes.== "on_session" -> PostCheckoutSessionsRequestBodyPaymentIntentData'SetupFutureUsage'EnumOnSession
            | GHC.Base.otherwise -> PostCheckoutSessionsRequestBodyPaymentIntentData'SetupFutureUsage'Other val
      )

-- | Defines the object schema located at @paths.\/v1\/checkout\/sessions.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.payment_intent_data.properties.shipping@ in the specification.
data PostCheckoutSessionsRequestBodyPaymentIntentData'Shipping' = PostCheckoutSessionsRequestBodyPaymentIntentData'Shipping'
  { -- | address
    postCheckoutSessionsRequestBodyPaymentIntentData'Shipping'Address :: PostCheckoutSessionsRequestBodyPaymentIntentData'Shipping'Address',
    -- | carrier
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    postCheckoutSessionsRequestBodyPaymentIntentData'Shipping'Carrier :: (GHC.Maybe.Maybe Data.Text.Internal.Text),
    -- | name
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    postCheckoutSessionsRequestBodyPaymentIntentData'Shipping'Name :: Data.Text.Internal.Text,
    -- | phone
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    postCheckoutSessionsRequestBodyPaymentIntentData'Shipping'Phone :: (GHC.Maybe.Maybe Data.Text.Internal.Text),
    -- | tracking_number
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    postCheckoutSessionsRequestBodyPaymentIntentData'Shipping'TrackingNumber :: (GHC.Maybe.Maybe Data.Text.Internal.Text)
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostCheckoutSessionsRequestBodyPaymentIntentData'Shipping' where
  toJSON obj = Data.Aeson.Types.Internal.object ("address" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodyPaymentIntentData'Shipping'Address obj : "carrier" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodyPaymentIntentData'Shipping'Carrier obj : "name" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodyPaymentIntentData'Shipping'Name obj : "phone" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodyPaymentIntentData'Shipping'Phone obj : "tracking_number" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodyPaymentIntentData'Shipping'TrackingNumber obj : GHC.Base.mempty)
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (("address" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodyPaymentIntentData'Shipping'Address obj) GHC.Base.<> (("carrier" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodyPaymentIntentData'Shipping'Carrier obj) GHC.Base.<> (("name" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodyPaymentIntentData'Shipping'Name obj) GHC.Base.<> (("phone" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodyPaymentIntentData'Shipping'Phone obj) GHC.Base.<> ("tracking_number" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodyPaymentIntentData'Shipping'TrackingNumber obj)))))

instance Data.Aeson.Types.FromJSON.FromJSON PostCheckoutSessionsRequestBodyPaymentIntentData'Shipping' where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostCheckoutSessionsRequestBodyPaymentIntentData'Shipping'" (\obj -> ((((GHC.Base.pure PostCheckoutSessionsRequestBodyPaymentIntentData'Shipping' GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "address")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "carrier")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "name")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "phone")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "tracking_number"))

-- | Create a new 'PostCheckoutSessionsRequestBodyPaymentIntentData'Shipping'' with all required fields.
mkPostCheckoutSessionsRequestBodyPaymentIntentData'Shipping' ::
  -- | 'postCheckoutSessionsRequestBodyPaymentIntentData'Shipping'Address'
  PostCheckoutSessionsRequestBodyPaymentIntentData'Shipping'Address' ->
  -- | 'postCheckoutSessionsRequestBodyPaymentIntentData'Shipping'Name'
  Data.Text.Internal.Text ->
  PostCheckoutSessionsRequestBodyPaymentIntentData'Shipping'
mkPostCheckoutSessionsRequestBodyPaymentIntentData'Shipping' postCheckoutSessionsRequestBodyPaymentIntentData'Shipping'Address postCheckoutSessionsRequestBodyPaymentIntentData'Shipping'Name =
  PostCheckoutSessionsRequestBodyPaymentIntentData'Shipping'
    { postCheckoutSessionsRequestBodyPaymentIntentData'Shipping'Address = postCheckoutSessionsRequestBodyPaymentIntentData'Shipping'Address,
      postCheckoutSessionsRequestBodyPaymentIntentData'Shipping'Carrier = GHC.Maybe.Nothing,
      postCheckoutSessionsRequestBodyPaymentIntentData'Shipping'Name = postCheckoutSessionsRequestBodyPaymentIntentData'Shipping'Name,
      postCheckoutSessionsRequestBodyPaymentIntentData'Shipping'Phone = GHC.Maybe.Nothing,
      postCheckoutSessionsRequestBodyPaymentIntentData'Shipping'TrackingNumber = GHC.Maybe.Nothing
    }

-- | Defines the object schema located at @paths.\/v1\/checkout\/sessions.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.payment_intent_data.properties.shipping.properties.address@ in the specification.
data PostCheckoutSessionsRequestBodyPaymentIntentData'Shipping'Address' = PostCheckoutSessionsRequestBodyPaymentIntentData'Shipping'Address'
  { -- | city
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    postCheckoutSessionsRequestBodyPaymentIntentData'Shipping'Address'City :: (GHC.Maybe.Maybe Data.Text.Internal.Text),
    -- | country
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    postCheckoutSessionsRequestBodyPaymentIntentData'Shipping'Address'Country :: (GHC.Maybe.Maybe Data.Text.Internal.Text),
    -- | line1
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    postCheckoutSessionsRequestBodyPaymentIntentData'Shipping'Address'Line1 :: Data.Text.Internal.Text,
    -- | line2
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    postCheckoutSessionsRequestBodyPaymentIntentData'Shipping'Address'Line2 :: (GHC.Maybe.Maybe Data.Text.Internal.Text),
    -- | postal_code
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    postCheckoutSessionsRequestBodyPaymentIntentData'Shipping'Address'PostalCode :: (GHC.Maybe.Maybe Data.Text.Internal.Text),
    -- | state
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    postCheckoutSessionsRequestBodyPaymentIntentData'Shipping'Address'State :: (GHC.Maybe.Maybe Data.Text.Internal.Text)
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostCheckoutSessionsRequestBodyPaymentIntentData'Shipping'Address' where
  toJSON obj = Data.Aeson.Types.Internal.object ("city" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodyPaymentIntentData'Shipping'Address'City obj : "country" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodyPaymentIntentData'Shipping'Address'Country obj : "line1" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodyPaymentIntentData'Shipping'Address'Line1 obj : "line2" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodyPaymentIntentData'Shipping'Address'Line2 obj : "postal_code" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodyPaymentIntentData'Shipping'Address'PostalCode obj : "state" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodyPaymentIntentData'Shipping'Address'State obj : GHC.Base.mempty)
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (("city" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodyPaymentIntentData'Shipping'Address'City obj) GHC.Base.<> (("country" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodyPaymentIntentData'Shipping'Address'Country obj) GHC.Base.<> (("line1" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodyPaymentIntentData'Shipping'Address'Line1 obj) GHC.Base.<> (("line2" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodyPaymentIntentData'Shipping'Address'Line2 obj) GHC.Base.<> (("postal_code" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodyPaymentIntentData'Shipping'Address'PostalCode obj) GHC.Base.<> ("state" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodyPaymentIntentData'Shipping'Address'State obj))))))

instance Data.Aeson.Types.FromJSON.FromJSON PostCheckoutSessionsRequestBodyPaymentIntentData'Shipping'Address' where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostCheckoutSessionsRequestBodyPaymentIntentData'Shipping'Address'" (\obj -> (((((GHC.Base.pure PostCheckoutSessionsRequestBodyPaymentIntentData'Shipping'Address' GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "city")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "country")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "line1")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "line2")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "postal_code")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "state"))

-- | Create a new 'PostCheckoutSessionsRequestBodyPaymentIntentData'Shipping'Address'' with all required fields.
mkPostCheckoutSessionsRequestBodyPaymentIntentData'Shipping'Address' ::
  -- | 'postCheckoutSessionsRequestBodyPaymentIntentData'Shipping'Address'Line1'
  Data.Text.Internal.Text ->
  PostCheckoutSessionsRequestBodyPaymentIntentData'Shipping'Address'
mkPostCheckoutSessionsRequestBodyPaymentIntentData'Shipping'Address' postCheckoutSessionsRequestBodyPaymentIntentData'Shipping'Address'Line1 =
  PostCheckoutSessionsRequestBodyPaymentIntentData'Shipping'Address'
    { postCheckoutSessionsRequestBodyPaymentIntentData'Shipping'Address'City = GHC.Maybe.Nothing,
      postCheckoutSessionsRequestBodyPaymentIntentData'Shipping'Address'Country = GHC.Maybe.Nothing,
      postCheckoutSessionsRequestBodyPaymentIntentData'Shipping'Address'Line1 = postCheckoutSessionsRequestBodyPaymentIntentData'Shipping'Address'Line1,
      postCheckoutSessionsRequestBodyPaymentIntentData'Shipping'Address'Line2 = GHC.Maybe.Nothing,
      postCheckoutSessionsRequestBodyPaymentIntentData'Shipping'Address'PostalCode = GHC.Maybe.Nothing,
      postCheckoutSessionsRequestBodyPaymentIntentData'Shipping'Address'State = GHC.Maybe.Nothing
    }

-- | Defines the object schema located at @paths.\/v1\/checkout\/sessions.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.payment_intent_data.properties.transfer_data@ in the specification.
data PostCheckoutSessionsRequestBodyPaymentIntentData'TransferData' = PostCheckoutSessionsRequestBodyPaymentIntentData'TransferData'
  { -- | amount
    postCheckoutSessionsRequestBodyPaymentIntentData'TransferData'Amount :: (GHC.Maybe.Maybe GHC.Types.Int),
    -- | destination
    postCheckoutSessionsRequestBodyPaymentIntentData'TransferData'Destination :: Data.Text.Internal.Text
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostCheckoutSessionsRequestBodyPaymentIntentData'TransferData' where
  toJSON obj = Data.Aeson.Types.Internal.object ("amount" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodyPaymentIntentData'TransferData'Amount obj : "destination" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodyPaymentIntentData'TransferData'Destination obj : GHC.Base.mempty)
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (("amount" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodyPaymentIntentData'TransferData'Amount obj) GHC.Base.<> ("destination" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodyPaymentIntentData'TransferData'Destination obj))

instance Data.Aeson.Types.FromJSON.FromJSON PostCheckoutSessionsRequestBodyPaymentIntentData'TransferData' where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostCheckoutSessionsRequestBodyPaymentIntentData'TransferData'" (\obj -> (GHC.Base.pure PostCheckoutSessionsRequestBodyPaymentIntentData'TransferData' GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "amount")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "destination"))

-- | Create a new 'PostCheckoutSessionsRequestBodyPaymentIntentData'TransferData'' with all required fields.
mkPostCheckoutSessionsRequestBodyPaymentIntentData'TransferData' ::
  -- | 'postCheckoutSessionsRequestBodyPaymentIntentData'TransferData'Destination'
  Data.Text.Internal.Text ->
  PostCheckoutSessionsRequestBodyPaymentIntentData'TransferData'
mkPostCheckoutSessionsRequestBodyPaymentIntentData'TransferData' postCheckoutSessionsRequestBodyPaymentIntentData'TransferData'Destination =
  PostCheckoutSessionsRequestBodyPaymentIntentData'TransferData'
    { postCheckoutSessionsRequestBodyPaymentIntentData'TransferData'Amount = GHC.Maybe.Nothing,
      postCheckoutSessionsRequestBodyPaymentIntentData'TransferData'Destination = postCheckoutSessionsRequestBodyPaymentIntentData'TransferData'Destination
    }

-- | Defines the object schema located at @paths.\/v1\/checkout\/sessions.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.payment_method_options@ in the specification.
--
-- Payment-method-specific configuration.
data PostCheckoutSessionsRequestBodyPaymentMethodOptions' = PostCheckoutSessionsRequestBodyPaymentMethodOptions'
  { -- | acss_debit
    postCheckoutSessionsRequestBodyPaymentMethodOptions'AcssDebit :: (GHC.Maybe.Maybe PostCheckoutSessionsRequestBodyPaymentMethodOptions'AcssDebit')
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostCheckoutSessionsRequestBodyPaymentMethodOptions' where
  toJSON obj = Data.Aeson.Types.Internal.object ("acss_debit" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodyPaymentMethodOptions'AcssDebit obj : GHC.Base.mempty)
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs ("acss_debit" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodyPaymentMethodOptions'AcssDebit obj)

instance Data.Aeson.Types.FromJSON.FromJSON PostCheckoutSessionsRequestBodyPaymentMethodOptions' where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostCheckoutSessionsRequestBodyPaymentMethodOptions'" (\obj -> GHC.Base.pure PostCheckoutSessionsRequestBodyPaymentMethodOptions' GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "acss_debit"))

-- | Create a new 'PostCheckoutSessionsRequestBodyPaymentMethodOptions'' with all required fields.
mkPostCheckoutSessionsRequestBodyPaymentMethodOptions' :: PostCheckoutSessionsRequestBodyPaymentMethodOptions'
mkPostCheckoutSessionsRequestBodyPaymentMethodOptions' = PostCheckoutSessionsRequestBodyPaymentMethodOptions' {postCheckoutSessionsRequestBodyPaymentMethodOptions'AcssDebit = GHC.Maybe.Nothing}

-- | Defines the object schema located at @paths.\/v1\/checkout\/sessions.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.payment_method_options.properties.acss_debit@ in the specification.
data PostCheckoutSessionsRequestBodyPaymentMethodOptions'AcssDebit' = PostCheckoutSessionsRequestBodyPaymentMethodOptions'AcssDebit'
  { -- | currency
    postCheckoutSessionsRequestBodyPaymentMethodOptions'AcssDebit'Currency :: (GHC.Maybe.Maybe PostCheckoutSessionsRequestBodyPaymentMethodOptions'AcssDebit'Currency'),
    -- | mandate_options
    postCheckoutSessionsRequestBodyPaymentMethodOptions'AcssDebit'MandateOptions :: (GHC.Maybe.Maybe PostCheckoutSessionsRequestBodyPaymentMethodOptions'AcssDebit'MandateOptions'),
    -- | verification_method
    postCheckoutSessionsRequestBodyPaymentMethodOptions'AcssDebit'VerificationMethod :: (GHC.Maybe.Maybe PostCheckoutSessionsRequestBodyPaymentMethodOptions'AcssDebit'VerificationMethod')
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostCheckoutSessionsRequestBodyPaymentMethodOptions'AcssDebit' where
  toJSON obj = Data.Aeson.Types.Internal.object ("currency" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodyPaymentMethodOptions'AcssDebit'Currency obj : "mandate_options" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodyPaymentMethodOptions'AcssDebit'MandateOptions obj : "verification_method" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodyPaymentMethodOptions'AcssDebit'VerificationMethod obj : GHC.Base.mempty)
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (("currency" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodyPaymentMethodOptions'AcssDebit'Currency obj) GHC.Base.<> (("mandate_options" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodyPaymentMethodOptions'AcssDebit'MandateOptions obj) GHC.Base.<> ("verification_method" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodyPaymentMethodOptions'AcssDebit'VerificationMethod obj)))

instance Data.Aeson.Types.FromJSON.FromJSON PostCheckoutSessionsRequestBodyPaymentMethodOptions'AcssDebit' where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostCheckoutSessionsRequestBodyPaymentMethodOptions'AcssDebit'" (\obj -> ((GHC.Base.pure PostCheckoutSessionsRequestBodyPaymentMethodOptions'AcssDebit' GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "currency")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "mandate_options")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "verification_method"))

-- | Create a new 'PostCheckoutSessionsRequestBodyPaymentMethodOptions'AcssDebit'' with all required fields.
mkPostCheckoutSessionsRequestBodyPaymentMethodOptions'AcssDebit' :: PostCheckoutSessionsRequestBodyPaymentMethodOptions'AcssDebit'
mkPostCheckoutSessionsRequestBodyPaymentMethodOptions'AcssDebit' =
  PostCheckoutSessionsRequestBodyPaymentMethodOptions'AcssDebit'
    { postCheckoutSessionsRequestBodyPaymentMethodOptions'AcssDebit'Currency = GHC.Maybe.Nothing,
      postCheckoutSessionsRequestBodyPaymentMethodOptions'AcssDebit'MandateOptions = GHC.Maybe.Nothing,
      postCheckoutSessionsRequestBodyPaymentMethodOptions'AcssDebit'VerificationMethod = GHC.Maybe.Nothing
    }

-- | Defines the enum schema located at @paths.\/v1\/checkout\/sessions.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.payment_method_options.properties.acss_debit.properties.currency@ in the specification.
data PostCheckoutSessionsRequestBodyPaymentMethodOptions'AcssDebit'Currency'
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    PostCheckoutSessionsRequestBodyPaymentMethodOptions'AcssDebit'Currency'Other Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    PostCheckoutSessionsRequestBodyPaymentMethodOptions'AcssDebit'Currency'Typed Data.Text.Internal.Text
  | -- | Represents the JSON value @"cad"@
    PostCheckoutSessionsRequestBodyPaymentMethodOptions'AcssDebit'Currency'EnumCad
  | -- | Represents the JSON value @"usd"@
    PostCheckoutSessionsRequestBodyPaymentMethodOptions'AcssDebit'Currency'EnumUsd
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PostCheckoutSessionsRequestBodyPaymentMethodOptions'AcssDebit'Currency' where
  toJSON (PostCheckoutSessionsRequestBodyPaymentMethodOptions'AcssDebit'Currency'Other val) = val
  toJSON (PostCheckoutSessionsRequestBodyPaymentMethodOptions'AcssDebit'Currency'Typed val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (PostCheckoutSessionsRequestBodyPaymentMethodOptions'AcssDebit'Currency'EnumCad) = "cad"
  toJSON (PostCheckoutSessionsRequestBodyPaymentMethodOptions'AcssDebit'Currency'EnumUsd) = "usd"

instance Data.Aeson.Types.FromJSON.FromJSON PostCheckoutSessionsRequestBodyPaymentMethodOptions'AcssDebit'Currency' where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "cad" -> PostCheckoutSessionsRequestBodyPaymentMethodOptions'AcssDebit'Currency'EnumCad
            | val GHC.Classes.== "usd" -> PostCheckoutSessionsRequestBodyPaymentMethodOptions'AcssDebit'Currency'EnumUsd
            | GHC.Base.otherwise -> PostCheckoutSessionsRequestBodyPaymentMethodOptions'AcssDebit'Currency'Other val
      )

-- | Defines the object schema located at @paths.\/v1\/checkout\/sessions.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.payment_method_options.properties.acss_debit.properties.mandate_options@ in the specification.
data PostCheckoutSessionsRequestBodyPaymentMethodOptions'AcssDebit'MandateOptions' = PostCheckoutSessionsRequestBodyPaymentMethodOptions'AcssDebit'MandateOptions'
  { -- | custom_mandate_url
    postCheckoutSessionsRequestBodyPaymentMethodOptions'AcssDebit'MandateOptions'CustomMandateUrl :: (GHC.Maybe.Maybe PostCheckoutSessionsRequestBodyPaymentMethodOptions'AcssDebit'MandateOptions'CustomMandateUrl'Variants),
    -- | interval_description
    --
    -- Constraints:
    --
    -- * Maximum length of 500
    postCheckoutSessionsRequestBodyPaymentMethodOptions'AcssDebit'MandateOptions'IntervalDescription :: (GHC.Maybe.Maybe Data.Text.Internal.Text),
    -- | payment_schedule
    postCheckoutSessionsRequestBodyPaymentMethodOptions'AcssDebit'MandateOptions'PaymentSchedule :: (GHC.Maybe.Maybe PostCheckoutSessionsRequestBodyPaymentMethodOptions'AcssDebit'MandateOptions'PaymentSchedule'),
    -- | transaction_type
    postCheckoutSessionsRequestBodyPaymentMethodOptions'AcssDebit'MandateOptions'TransactionType :: (GHC.Maybe.Maybe PostCheckoutSessionsRequestBodyPaymentMethodOptions'AcssDebit'MandateOptions'TransactionType')
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostCheckoutSessionsRequestBodyPaymentMethodOptions'AcssDebit'MandateOptions' where
  toJSON obj = Data.Aeson.Types.Internal.object ("custom_mandate_url" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodyPaymentMethodOptions'AcssDebit'MandateOptions'CustomMandateUrl obj : "interval_description" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodyPaymentMethodOptions'AcssDebit'MandateOptions'IntervalDescription obj : "payment_schedule" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodyPaymentMethodOptions'AcssDebit'MandateOptions'PaymentSchedule obj : "transaction_type" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodyPaymentMethodOptions'AcssDebit'MandateOptions'TransactionType obj : GHC.Base.mempty)
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (("custom_mandate_url" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodyPaymentMethodOptions'AcssDebit'MandateOptions'CustomMandateUrl obj) GHC.Base.<> (("interval_description" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodyPaymentMethodOptions'AcssDebit'MandateOptions'IntervalDescription obj) GHC.Base.<> (("payment_schedule" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodyPaymentMethodOptions'AcssDebit'MandateOptions'PaymentSchedule obj) GHC.Base.<> ("transaction_type" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodyPaymentMethodOptions'AcssDebit'MandateOptions'TransactionType obj))))

instance Data.Aeson.Types.FromJSON.FromJSON PostCheckoutSessionsRequestBodyPaymentMethodOptions'AcssDebit'MandateOptions' where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostCheckoutSessionsRequestBodyPaymentMethodOptions'AcssDebit'MandateOptions'" (\obj -> (((GHC.Base.pure PostCheckoutSessionsRequestBodyPaymentMethodOptions'AcssDebit'MandateOptions' GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "custom_mandate_url")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "interval_description")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "payment_schedule")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "transaction_type"))

-- | Create a new 'PostCheckoutSessionsRequestBodyPaymentMethodOptions'AcssDebit'MandateOptions'' with all required fields.
mkPostCheckoutSessionsRequestBodyPaymentMethodOptions'AcssDebit'MandateOptions' :: PostCheckoutSessionsRequestBodyPaymentMethodOptions'AcssDebit'MandateOptions'
mkPostCheckoutSessionsRequestBodyPaymentMethodOptions'AcssDebit'MandateOptions' =
  PostCheckoutSessionsRequestBodyPaymentMethodOptions'AcssDebit'MandateOptions'
    { postCheckoutSessionsRequestBodyPaymentMethodOptions'AcssDebit'MandateOptions'CustomMandateUrl = GHC.Maybe.Nothing,
      postCheckoutSessionsRequestBodyPaymentMethodOptions'AcssDebit'MandateOptions'IntervalDescription = GHC.Maybe.Nothing,
      postCheckoutSessionsRequestBodyPaymentMethodOptions'AcssDebit'MandateOptions'PaymentSchedule = GHC.Maybe.Nothing,
      postCheckoutSessionsRequestBodyPaymentMethodOptions'AcssDebit'MandateOptions'TransactionType = GHC.Maybe.Nothing
    }

-- | Defines the oneOf schema located at @paths.\/v1\/checkout\/sessions.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.payment_method_options.properties.acss_debit.properties.mandate_options.properties.custom_mandate_url.anyOf@ in the specification.
data PostCheckoutSessionsRequestBodyPaymentMethodOptions'AcssDebit'MandateOptions'CustomMandateUrl'Variants
  = -- | Represents the JSON value @""@
    PostCheckoutSessionsRequestBodyPaymentMethodOptions'AcssDebit'MandateOptions'CustomMandateUrl'EmptyString
  | PostCheckoutSessionsRequestBodyPaymentMethodOptions'AcssDebit'MandateOptions'CustomMandateUrl'Text Data.Text.Internal.Text
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PostCheckoutSessionsRequestBodyPaymentMethodOptions'AcssDebit'MandateOptions'CustomMandateUrl'Variants where
  toJSON (PostCheckoutSessionsRequestBodyPaymentMethodOptions'AcssDebit'MandateOptions'CustomMandateUrl'Text a) = Data.Aeson.Types.ToJSON.toJSON a
  toJSON (PostCheckoutSessionsRequestBodyPaymentMethodOptions'AcssDebit'MandateOptions'CustomMandateUrl'EmptyString) = ""

instance Data.Aeson.Types.FromJSON.FromJSON PostCheckoutSessionsRequestBodyPaymentMethodOptions'AcssDebit'MandateOptions'CustomMandateUrl'Variants where
  parseJSON val =
    if
        | val GHC.Classes.== "" -> GHC.Base.pure PostCheckoutSessionsRequestBodyPaymentMethodOptions'AcssDebit'MandateOptions'CustomMandateUrl'EmptyString
        | GHC.Base.otherwise -> case (PostCheckoutSessionsRequestBodyPaymentMethodOptions'AcssDebit'MandateOptions'CustomMandateUrl'Text Data.Functor.<$> Data.Aeson.Types.FromJSON.fromJSON val) GHC.Base.<|> Data.Aeson.Types.Internal.Error "No variant matched" of
          Data.Aeson.Types.Internal.Success a -> GHC.Base.pure a
          Data.Aeson.Types.Internal.Error a -> Control.Monad.Fail.fail a

-- | Defines the enum schema located at @paths.\/v1\/checkout\/sessions.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.payment_method_options.properties.acss_debit.properties.mandate_options.properties.payment_schedule@ in the specification.
data PostCheckoutSessionsRequestBodyPaymentMethodOptions'AcssDebit'MandateOptions'PaymentSchedule'
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    PostCheckoutSessionsRequestBodyPaymentMethodOptions'AcssDebit'MandateOptions'PaymentSchedule'Other Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    PostCheckoutSessionsRequestBodyPaymentMethodOptions'AcssDebit'MandateOptions'PaymentSchedule'Typed Data.Text.Internal.Text
  | -- | Represents the JSON value @"combined"@
    PostCheckoutSessionsRequestBodyPaymentMethodOptions'AcssDebit'MandateOptions'PaymentSchedule'EnumCombined
  | -- | Represents the JSON value @"interval"@
    PostCheckoutSessionsRequestBodyPaymentMethodOptions'AcssDebit'MandateOptions'PaymentSchedule'EnumInterval
  | -- | Represents the JSON value @"sporadic"@
    PostCheckoutSessionsRequestBodyPaymentMethodOptions'AcssDebit'MandateOptions'PaymentSchedule'EnumSporadic
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PostCheckoutSessionsRequestBodyPaymentMethodOptions'AcssDebit'MandateOptions'PaymentSchedule' where
  toJSON (PostCheckoutSessionsRequestBodyPaymentMethodOptions'AcssDebit'MandateOptions'PaymentSchedule'Other val) = val
  toJSON (PostCheckoutSessionsRequestBodyPaymentMethodOptions'AcssDebit'MandateOptions'PaymentSchedule'Typed val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (PostCheckoutSessionsRequestBodyPaymentMethodOptions'AcssDebit'MandateOptions'PaymentSchedule'EnumCombined) = "combined"
  toJSON (PostCheckoutSessionsRequestBodyPaymentMethodOptions'AcssDebit'MandateOptions'PaymentSchedule'EnumInterval) = "interval"
  toJSON (PostCheckoutSessionsRequestBodyPaymentMethodOptions'AcssDebit'MandateOptions'PaymentSchedule'EnumSporadic) = "sporadic"

instance Data.Aeson.Types.FromJSON.FromJSON PostCheckoutSessionsRequestBodyPaymentMethodOptions'AcssDebit'MandateOptions'PaymentSchedule' where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "combined" -> PostCheckoutSessionsRequestBodyPaymentMethodOptions'AcssDebit'MandateOptions'PaymentSchedule'EnumCombined
            | val GHC.Classes.== "interval" -> PostCheckoutSessionsRequestBodyPaymentMethodOptions'AcssDebit'MandateOptions'PaymentSchedule'EnumInterval
            | val GHC.Classes.== "sporadic" -> PostCheckoutSessionsRequestBodyPaymentMethodOptions'AcssDebit'MandateOptions'PaymentSchedule'EnumSporadic
            | GHC.Base.otherwise -> PostCheckoutSessionsRequestBodyPaymentMethodOptions'AcssDebit'MandateOptions'PaymentSchedule'Other val
      )

-- | Defines the enum schema located at @paths.\/v1\/checkout\/sessions.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.payment_method_options.properties.acss_debit.properties.mandate_options.properties.transaction_type@ in the specification.
data PostCheckoutSessionsRequestBodyPaymentMethodOptions'AcssDebit'MandateOptions'TransactionType'
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    PostCheckoutSessionsRequestBodyPaymentMethodOptions'AcssDebit'MandateOptions'TransactionType'Other Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    PostCheckoutSessionsRequestBodyPaymentMethodOptions'AcssDebit'MandateOptions'TransactionType'Typed Data.Text.Internal.Text
  | -- | Represents the JSON value @"business"@
    PostCheckoutSessionsRequestBodyPaymentMethodOptions'AcssDebit'MandateOptions'TransactionType'EnumBusiness
  | -- | Represents the JSON value @"personal"@
    PostCheckoutSessionsRequestBodyPaymentMethodOptions'AcssDebit'MandateOptions'TransactionType'EnumPersonal
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PostCheckoutSessionsRequestBodyPaymentMethodOptions'AcssDebit'MandateOptions'TransactionType' where
  toJSON (PostCheckoutSessionsRequestBodyPaymentMethodOptions'AcssDebit'MandateOptions'TransactionType'Other val) = val
  toJSON (PostCheckoutSessionsRequestBodyPaymentMethodOptions'AcssDebit'MandateOptions'TransactionType'Typed val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (PostCheckoutSessionsRequestBodyPaymentMethodOptions'AcssDebit'MandateOptions'TransactionType'EnumBusiness) = "business"
  toJSON (PostCheckoutSessionsRequestBodyPaymentMethodOptions'AcssDebit'MandateOptions'TransactionType'EnumPersonal) = "personal"

instance Data.Aeson.Types.FromJSON.FromJSON PostCheckoutSessionsRequestBodyPaymentMethodOptions'AcssDebit'MandateOptions'TransactionType' where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "business" -> PostCheckoutSessionsRequestBodyPaymentMethodOptions'AcssDebit'MandateOptions'TransactionType'EnumBusiness
            | val GHC.Classes.== "personal" -> PostCheckoutSessionsRequestBodyPaymentMethodOptions'AcssDebit'MandateOptions'TransactionType'EnumPersonal
            | GHC.Base.otherwise -> PostCheckoutSessionsRequestBodyPaymentMethodOptions'AcssDebit'MandateOptions'TransactionType'Other val
      )

-- | Defines the enum schema located at @paths.\/v1\/checkout\/sessions.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.payment_method_options.properties.acss_debit.properties.verification_method@ in the specification.
data PostCheckoutSessionsRequestBodyPaymentMethodOptions'AcssDebit'VerificationMethod'
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    PostCheckoutSessionsRequestBodyPaymentMethodOptions'AcssDebit'VerificationMethod'Other Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    PostCheckoutSessionsRequestBodyPaymentMethodOptions'AcssDebit'VerificationMethod'Typed Data.Text.Internal.Text
  | -- | Represents the JSON value @"automatic"@
    PostCheckoutSessionsRequestBodyPaymentMethodOptions'AcssDebit'VerificationMethod'EnumAutomatic
  | -- | Represents the JSON value @"instant"@
    PostCheckoutSessionsRequestBodyPaymentMethodOptions'AcssDebit'VerificationMethod'EnumInstant
  | -- | Represents the JSON value @"microdeposits"@
    PostCheckoutSessionsRequestBodyPaymentMethodOptions'AcssDebit'VerificationMethod'EnumMicrodeposits
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PostCheckoutSessionsRequestBodyPaymentMethodOptions'AcssDebit'VerificationMethod' where
  toJSON (PostCheckoutSessionsRequestBodyPaymentMethodOptions'AcssDebit'VerificationMethod'Other val) = val
  toJSON (PostCheckoutSessionsRequestBodyPaymentMethodOptions'AcssDebit'VerificationMethod'Typed val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (PostCheckoutSessionsRequestBodyPaymentMethodOptions'AcssDebit'VerificationMethod'EnumAutomatic) = "automatic"
  toJSON (PostCheckoutSessionsRequestBodyPaymentMethodOptions'AcssDebit'VerificationMethod'EnumInstant) = "instant"
  toJSON (PostCheckoutSessionsRequestBodyPaymentMethodOptions'AcssDebit'VerificationMethod'EnumMicrodeposits) = "microdeposits"

instance Data.Aeson.Types.FromJSON.FromJSON PostCheckoutSessionsRequestBodyPaymentMethodOptions'AcssDebit'VerificationMethod' where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "automatic" -> PostCheckoutSessionsRequestBodyPaymentMethodOptions'AcssDebit'VerificationMethod'EnumAutomatic
            | val GHC.Classes.== "instant" -> PostCheckoutSessionsRequestBodyPaymentMethodOptions'AcssDebit'VerificationMethod'EnumInstant
            | val GHC.Classes.== "microdeposits" -> PostCheckoutSessionsRequestBodyPaymentMethodOptions'AcssDebit'VerificationMethod'EnumMicrodeposits
            | GHC.Base.otherwise -> PostCheckoutSessionsRequestBodyPaymentMethodOptions'AcssDebit'VerificationMethod'Other val
      )

-- | Defines the enum schema located at @paths.\/v1\/checkout\/sessions.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.payment_method_types.items@ in the specification.
data PostCheckoutSessionsRequestBodyPaymentMethodTypes'
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    PostCheckoutSessionsRequestBodyPaymentMethodTypes'Other Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    PostCheckoutSessionsRequestBodyPaymentMethodTypes'Typed Data.Text.Internal.Text
  | -- | Represents the JSON value @"acss_debit"@
    PostCheckoutSessionsRequestBodyPaymentMethodTypes'EnumAcssDebit
  | -- | Represents the JSON value @"afterpay_clearpay"@
    PostCheckoutSessionsRequestBodyPaymentMethodTypes'EnumAfterpayClearpay
  | -- | Represents the JSON value @"alipay"@
    PostCheckoutSessionsRequestBodyPaymentMethodTypes'EnumAlipay
  | -- | Represents the JSON value @"bacs_debit"@
    PostCheckoutSessionsRequestBodyPaymentMethodTypes'EnumBacsDebit
  | -- | Represents the JSON value @"bancontact"@
    PostCheckoutSessionsRequestBodyPaymentMethodTypes'EnumBancontact
  | -- | Represents the JSON value @"card"@
    PostCheckoutSessionsRequestBodyPaymentMethodTypes'EnumCard
  | -- | Represents the JSON value @"eps"@
    PostCheckoutSessionsRequestBodyPaymentMethodTypes'EnumEps
  | -- | Represents the JSON value @"fpx"@
    PostCheckoutSessionsRequestBodyPaymentMethodTypes'EnumFpx
  | -- | Represents the JSON value @"giropay"@
    PostCheckoutSessionsRequestBodyPaymentMethodTypes'EnumGiropay
  | -- | Represents the JSON value @"grabpay"@
    PostCheckoutSessionsRequestBodyPaymentMethodTypes'EnumGrabpay
  | -- | Represents the JSON value @"ideal"@
    PostCheckoutSessionsRequestBodyPaymentMethodTypes'EnumIdeal
  | -- | Represents the JSON value @"p24"@
    PostCheckoutSessionsRequestBodyPaymentMethodTypes'EnumP24
  | -- | Represents the JSON value @"sepa_debit"@
    PostCheckoutSessionsRequestBodyPaymentMethodTypes'EnumSepaDebit
  | -- | Represents the JSON value @"sofort"@
    PostCheckoutSessionsRequestBodyPaymentMethodTypes'EnumSofort
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PostCheckoutSessionsRequestBodyPaymentMethodTypes' where
  toJSON (PostCheckoutSessionsRequestBodyPaymentMethodTypes'Other val) = val
  toJSON (PostCheckoutSessionsRequestBodyPaymentMethodTypes'Typed val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (PostCheckoutSessionsRequestBodyPaymentMethodTypes'EnumAcssDebit) = "acss_debit"
  toJSON (PostCheckoutSessionsRequestBodyPaymentMethodTypes'EnumAfterpayClearpay) = "afterpay_clearpay"
  toJSON (PostCheckoutSessionsRequestBodyPaymentMethodTypes'EnumAlipay) = "alipay"
  toJSON (PostCheckoutSessionsRequestBodyPaymentMethodTypes'EnumBacsDebit) = "bacs_debit"
  toJSON (PostCheckoutSessionsRequestBodyPaymentMethodTypes'EnumBancontact) = "bancontact"
  toJSON (PostCheckoutSessionsRequestBodyPaymentMethodTypes'EnumCard) = "card"
  toJSON (PostCheckoutSessionsRequestBodyPaymentMethodTypes'EnumEps) = "eps"
  toJSON (PostCheckoutSessionsRequestBodyPaymentMethodTypes'EnumFpx) = "fpx"
  toJSON (PostCheckoutSessionsRequestBodyPaymentMethodTypes'EnumGiropay) = "giropay"
  toJSON (PostCheckoutSessionsRequestBodyPaymentMethodTypes'EnumGrabpay) = "grabpay"
  toJSON (PostCheckoutSessionsRequestBodyPaymentMethodTypes'EnumIdeal) = "ideal"
  toJSON (PostCheckoutSessionsRequestBodyPaymentMethodTypes'EnumP24) = "p24"
  toJSON (PostCheckoutSessionsRequestBodyPaymentMethodTypes'EnumSepaDebit) = "sepa_debit"
  toJSON (PostCheckoutSessionsRequestBodyPaymentMethodTypes'EnumSofort) = "sofort"

instance Data.Aeson.Types.FromJSON.FromJSON PostCheckoutSessionsRequestBodyPaymentMethodTypes' where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "acss_debit" -> PostCheckoutSessionsRequestBodyPaymentMethodTypes'EnumAcssDebit
            | val GHC.Classes.== "afterpay_clearpay" -> PostCheckoutSessionsRequestBodyPaymentMethodTypes'EnumAfterpayClearpay
            | val GHC.Classes.== "alipay" -> PostCheckoutSessionsRequestBodyPaymentMethodTypes'EnumAlipay
            | val GHC.Classes.== "bacs_debit" -> PostCheckoutSessionsRequestBodyPaymentMethodTypes'EnumBacsDebit
            | val GHC.Classes.== "bancontact" -> PostCheckoutSessionsRequestBodyPaymentMethodTypes'EnumBancontact
            | val GHC.Classes.== "card" -> PostCheckoutSessionsRequestBodyPaymentMethodTypes'EnumCard
            | val GHC.Classes.== "eps" -> PostCheckoutSessionsRequestBodyPaymentMethodTypes'EnumEps
            | val GHC.Classes.== "fpx" -> PostCheckoutSessionsRequestBodyPaymentMethodTypes'EnumFpx
            | val GHC.Classes.== "giropay" -> PostCheckoutSessionsRequestBodyPaymentMethodTypes'EnumGiropay
            | val GHC.Classes.== "grabpay" -> PostCheckoutSessionsRequestBodyPaymentMethodTypes'EnumGrabpay
            | val GHC.Classes.== "ideal" -> PostCheckoutSessionsRequestBodyPaymentMethodTypes'EnumIdeal
            | val GHC.Classes.== "p24" -> PostCheckoutSessionsRequestBodyPaymentMethodTypes'EnumP24
            | val GHC.Classes.== "sepa_debit" -> PostCheckoutSessionsRequestBodyPaymentMethodTypes'EnumSepaDebit
            | val GHC.Classes.== "sofort" -> PostCheckoutSessionsRequestBodyPaymentMethodTypes'EnumSofort
            | GHC.Base.otherwise -> PostCheckoutSessionsRequestBodyPaymentMethodTypes'Other val
      )

-- | Defines the object schema located at @paths.\/v1\/checkout\/sessions.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.setup_intent_data@ in the specification.
--
-- A subset of parameters to be passed to SetupIntent creation for Checkout Sessions in \`setup\` mode.
data PostCheckoutSessionsRequestBodySetupIntentData' = PostCheckoutSessionsRequestBodySetupIntentData'
  { -- | description
    --
    -- Constraints:
    --
    -- * Maximum length of 1000
    postCheckoutSessionsRequestBodySetupIntentData'Description :: (GHC.Maybe.Maybe Data.Text.Internal.Text),
    -- | metadata
    postCheckoutSessionsRequestBodySetupIntentData'Metadata :: (GHC.Maybe.Maybe Data.Aeson.Types.Internal.Object),
    -- | on_behalf_of
    postCheckoutSessionsRequestBodySetupIntentData'OnBehalfOf :: (GHC.Maybe.Maybe Data.Text.Internal.Text)
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostCheckoutSessionsRequestBodySetupIntentData' where
  toJSON obj = Data.Aeson.Types.Internal.object ("description" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodySetupIntentData'Description obj : "metadata" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodySetupIntentData'Metadata obj : "on_behalf_of" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodySetupIntentData'OnBehalfOf obj : GHC.Base.mempty)
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (("description" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodySetupIntentData'Description obj) GHC.Base.<> (("metadata" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodySetupIntentData'Metadata obj) GHC.Base.<> ("on_behalf_of" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodySetupIntentData'OnBehalfOf obj)))

instance Data.Aeson.Types.FromJSON.FromJSON PostCheckoutSessionsRequestBodySetupIntentData' where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostCheckoutSessionsRequestBodySetupIntentData'" (\obj -> ((GHC.Base.pure PostCheckoutSessionsRequestBodySetupIntentData' GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "description")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "metadata")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "on_behalf_of"))

-- | Create a new 'PostCheckoutSessionsRequestBodySetupIntentData'' with all required fields.
mkPostCheckoutSessionsRequestBodySetupIntentData' :: PostCheckoutSessionsRequestBodySetupIntentData'
mkPostCheckoutSessionsRequestBodySetupIntentData' =
  PostCheckoutSessionsRequestBodySetupIntentData'
    { postCheckoutSessionsRequestBodySetupIntentData'Description = GHC.Maybe.Nothing,
      postCheckoutSessionsRequestBodySetupIntentData'Metadata = GHC.Maybe.Nothing,
      postCheckoutSessionsRequestBodySetupIntentData'OnBehalfOf = GHC.Maybe.Nothing
    }

-- | Defines the object schema located at @paths.\/v1\/checkout\/sessions.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.shipping_address_collection@ in the specification.
--
-- When set, provides configuration for Checkout to collect a shipping address from a customer.
data PostCheckoutSessionsRequestBodyShippingAddressCollection' = PostCheckoutSessionsRequestBodyShippingAddressCollection'
  { -- | allowed_countries
    postCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries :: ([PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'])
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostCheckoutSessionsRequestBodyShippingAddressCollection' where
  toJSON obj = Data.Aeson.Types.Internal.object ("allowed_countries" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries obj : GHC.Base.mempty)
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs ("allowed_countries" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries obj)

instance Data.Aeson.Types.FromJSON.FromJSON PostCheckoutSessionsRequestBodyShippingAddressCollection' where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostCheckoutSessionsRequestBodyShippingAddressCollection'" (\obj -> GHC.Base.pure PostCheckoutSessionsRequestBodyShippingAddressCollection' GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "allowed_countries"))

-- | Create a new 'PostCheckoutSessionsRequestBodyShippingAddressCollection'' with all required fields.
mkPostCheckoutSessionsRequestBodyShippingAddressCollection' ::
  -- | 'postCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'
  [PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'] ->
  PostCheckoutSessionsRequestBodyShippingAddressCollection'
mkPostCheckoutSessionsRequestBodyShippingAddressCollection' postCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries = PostCheckoutSessionsRequestBodyShippingAddressCollection' {postCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries = postCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries}

-- | Defines the enum schema located at @paths.\/v1\/checkout\/sessions.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.shipping_address_collection.properties.allowed_countries.items@ in the specification.
data PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'Other Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'Typed Data.Text.Internal.Text
  | -- | Represents the JSON value @"AC"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumAC
  | -- | Represents the JSON value @"AD"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumAD
  | -- | Represents the JSON value @"AE"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumAE
  | -- | Represents the JSON value @"AF"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumAF
  | -- | Represents the JSON value @"AG"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumAG
  | -- | Represents the JSON value @"AI"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumAI
  | -- | Represents the JSON value @"AL"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumAL
  | -- | Represents the JSON value @"AM"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumAM
  | -- | Represents the JSON value @"AO"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumAO
  | -- | Represents the JSON value @"AQ"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumAQ
  | -- | Represents the JSON value @"AR"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumAR
  | -- | Represents the JSON value @"AT"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumAT
  | -- | Represents the JSON value @"AU"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumAU
  | -- | Represents the JSON value @"AW"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumAW
  | -- | Represents the JSON value @"AX"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumAX
  | -- | Represents the JSON value @"AZ"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumAZ
  | -- | Represents the JSON value @"BA"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumBA
  | -- | Represents the JSON value @"BB"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumBB
  | -- | Represents the JSON value @"BD"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumBD
  | -- | Represents the JSON value @"BE"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumBE
  | -- | Represents the JSON value @"BF"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumBF
  | -- | Represents the JSON value @"BG"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumBG
  | -- | Represents the JSON value @"BH"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumBH
  | -- | Represents the JSON value @"BI"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumBI
  | -- | Represents the JSON value @"BJ"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumBJ
  | -- | Represents the JSON value @"BL"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumBL
  | -- | Represents the JSON value @"BM"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumBM
  | -- | Represents the JSON value @"BN"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumBN
  | -- | Represents the JSON value @"BO"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumBO
  | -- | Represents the JSON value @"BQ"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumBQ
  | -- | Represents the JSON value @"BR"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumBR
  | -- | Represents the JSON value @"BS"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumBS
  | -- | Represents the JSON value @"BT"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumBT
  | -- | Represents the JSON value @"BV"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumBV
  | -- | Represents the JSON value @"BW"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumBW
  | -- | Represents the JSON value @"BY"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumBY
  | -- | Represents the JSON value @"BZ"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumBZ
  | -- | Represents the JSON value @"CA"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumCA
  | -- | Represents the JSON value @"CD"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumCD
  | -- | Represents the JSON value @"CF"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumCF
  | -- | Represents the JSON value @"CG"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumCG
  | -- | Represents the JSON value @"CH"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumCH
  | -- | Represents the JSON value @"CI"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumCI
  | -- | Represents the JSON value @"CK"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumCK
  | -- | Represents the JSON value @"CL"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumCL
  | -- | Represents the JSON value @"CM"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumCM
  | -- | Represents the JSON value @"CN"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumCN
  | -- | Represents the JSON value @"CO"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumCO
  | -- | Represents the JSON value @"CR"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumCR
  | -- | Represents the JSON value @"CV"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumCV
  | -- | Represents the JSON value @"CW"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumCW
  | -- | Represents the JSON value @"CY"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumCY
  | -- | Represents the JSON value @"CZ"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumCZ
  | -- | Represents the JSON value @"DE"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumDE
  | -- | Represents the JSON value @"DJ"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumDJ
  | -- | Represents the JSON value @"DK"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumDK
  | -- | Represents the JSON value @"DM"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumDM
  | -- | Represents the JSON value @"DO"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumDO
  | -- | Represents the JSON value @"DZ"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumDZ
  | -- | Represents the JSON value @"EC"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumEC
  | -- | Represents the JSON value @"EE"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumEE
  | -- | Represents the JSON value @"EG"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumEG
  | -- | Represents the JSON value @"EH"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumEH
  | -- | Represents the JSON value @"ER"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumER
  | -- | Represents the JSON value @"ES"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumES
  | -- | Represents the JSON value @"ET"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumET
  | -- | Represents the JSON value @"FI"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumFI
  | -- | Represents the JSON value @"FJ"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumFJ
  | -- | Represents the JSON value @"FK"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumFK
  | -- | Represents the JSON value @"FO"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumFO
  | -- | Represents the JSON value @"FR"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumFR
  | -- | Represents the JSON value @"GA"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumGA
  | -- | Represents the JSON value @"GB"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumGB
  | -- | Represents the JSON value @"GD"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumGD
  | -- | Represents the JSON value @"GE"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumGE
  | -- | Represents the JSON value @"GF"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumGF
  | -- | Represents the JSON value @"GG"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumGG
  | -- | Represents the JSON value @"GH"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumGH
  | -- | Represents the JSON value @"GI"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumGI
  | -- | Represents the JSON value @"GL"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumGL
  | -- | Represents the JSON value @"GM"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumGM
  | -- | Represents the JSON value @"GN"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumGN
  | -- | Represents the JSON value @"GP"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumGP
  | -- | Represents the JSON value @"GQ"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumGQ
  | -- | Represents the JSON value @"GR"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumGR
  | -- | Represents the JSON value @"GS"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumGS
  | -- | Represents the JSON value @"GT"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumGT
  | -- | Represents the JSON value @"GU"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumGU
  | -- | Represents the JSON value @"GW"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumGW
  | -- | Represents the JSON value @"GY"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumGY
  | -- | Represents the JSON value @"HK"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumHK
  | -- | Represents the JSON value @"HN"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumHN
  | -- | Represents the JSON value @"HR"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumHR
  | -- | Represents the JSON value @"HT"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumHT
  | -- | Represents the JSON value @"HU"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumHU
  | -- | Represents the JSON value @"ID"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumID
  | -- | Represents the JSON value @"IE"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumIE
  | -- | Represents the JSON value @"IL"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumIL
  | -- | Represents the JSON value @"IM"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumIM
  | -- | Represents the JSON value @"IN"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumIN
  | -- | Represents the JSON value @"IO"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumIO
  | -- | Represents the JSON value @"IQ"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumIQ
  | -- | Represents the JSON value @"IS"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumIS
  | -- | Represents the JSON value @"IT"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumIT
  | -- | Represents the JSON value @"JE"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumJE
  | -- | Represents the JSON value @"JM"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumJM
  | -- | Represents the JSON value @"JO"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumJO
  | -- | Represents the JSON value @"JP"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumJP
  | -- | Represents the JSON value @"KE"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumKE
  | -- | Represents the JSON value @"KG"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumKG
  | -- | Represents the JSON value @"KH"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumKH
  | -- | Represents the JSON value @"KI"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumKI
  | -- | Represents the JSON value @"KM"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumKM
  | -- | Represents the JSON value @"KN"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumKN
  | -- | Represents the JSON value @"KR"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumKR
  | -- | Represents the JSON value @"KW"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumKW
  | -- | Represents the JSON value @"KY"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumKY
  | -- | Represents the JSON value @"KZ"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumKZ
  | -- | Represents the JSON value @"LA"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumLA
  | -- | Represents the JSON value @"LB"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumLB
  | -- | Represents the JSON value @"LC"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumLC
  | -- | Represents the JSON value @"LI"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumLI
  | -- | Represents the JSON value @"LK"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumLK
  | -- | Represents the JSON value @"LR"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumLR
  | -- | Represents the JSON value @"LS"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumLS
  | -- | Represents the JSON value @"LT"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumLT
  | -- | Represents the JSON value @"LU"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumLU
  | -- | Represents the JSON value @"LV"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumLV
  | -- | Represents the JSON value @"LY"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumLY
  | -- | Represents the JSON value @"MA"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumMA
  | -- | Represents the JSON value @"MC"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumMC
  | -- | Represents the JSON value @"MD"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumMD
  | -- | Represents the JSON value @"ME"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumME
  | -- | Represents the JSON value @"MF"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumMF
  | -- | Represents the JSON value @"MG"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumMG
  | -- | Represents the JSON value @"MK"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumMK
  | -- | Represents the JSON value @"ML"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumML
  | -- | Represents the JSON value @"MM"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumMM
  | -- | Represents the JSON value @"MN"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumMN
  | -- | Represents the JSON value @"MO"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumMO
  | -- | Represents the JSON value @"MQ"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumMQ
  | -- | Represents the JSON value @"MR"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumMR
  | -- | Represents the JSON value @"MS"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumMS
  | -- | Represents the JSON value @"MT"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumMT
  | -- | Represents the JSON value @"MU"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumMU
  | -- | Represents the JSON value @"MV"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumMV
  | -- | Represents the JSON value @"MW"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumMW
  | -- | Represents the JSON value @"MX"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumMX
  | -- | Represents the JSON value @"MY"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumMY
  | -- | Represents the JSON value @"MZ"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumMZ
  | -- | Represents the JSON value @"NA"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumNA
  | -- | Represents the JSON value @"NC"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumNC
  | -- | Represents the JSON value @"NE"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumNE
  | -- | Represents the JSON value @"NG"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumNG
  | -- | Represents the JSON value @"NI"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumNI
  | -- | Represents the JSON value @"NL"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumNL
  | -- | Represents the JSON value @"NO"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumNO
  | -- | Represents the JSON value @"NP"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumNP
  | -- | Represents the JSON value @"NR"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumNR
  | -- | Represents the JSON value @"NU"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumNU
  | -- | Represents the JSON value @"NZ"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumNZ
  | -- | Represents the JSON value @"OM"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumOM
  | -- | Represents the JSON value @"PA"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumPA
  | -- | Represents the JSON value @"PE"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumPE
  | -- | Represents the JSON value @"PF"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumPF
  | -- | Represents the JSON value @"PG"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumPG
  | -- | Represents the JSON value @"PH"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumPH
  | -- | Represents the JSON value @"PK"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumPK
  | -- | Represents the JSON value @"PL"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumPL
  | -- | Represents the JSON value @"PM"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumPM
  | -- | Represents the JSON value @"PN"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumPN
  | -- | Represents the JSON value @"PR"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumPR
  | -- | Represents the JSON value @"PS"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumPS
  | -- | Represents the JSON value @"PT"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumPT
  | -- | Represents the JSON value @"PY"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumPY
  | -- | Represents the JSON value @"QA"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumQA
  | -- | Represents the JSON value @"RE"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumRE
  | -- | Represents the JSON value @"RO"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumRO
  | -- | Represents the JSON value @"RS"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumRS
  | -- | Represents the JSON value @"RU"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumRU
  | -- | Represents the JSON value @"RW"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumRW
  | -- | Represents the JSON value @"SA"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumSA
  | -- | Represents the JSON value @"SB"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumSB
  | -- | Represents the JSON value @"SC"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumSC
  | -- | Represents the JSON value @"SE"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumSE
  | -- | Represents the JSON value @"SG"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumSG
  | -- | Represents the JSON value @"SH"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumSH
  | -- | Represents the JSON value @"SI"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumSI
  | -- | Represents the JSON value @"SJ"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumSJ
  | -- | Represents the JSON value @"SK"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumSK
  | -- | Represents the JSON value @"SL"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumSL
  | -- | Represents the JSON value @"SM"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumSM
  | -- | Represents the JSON value @"SN"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumSN
  | -- | Represents the JSON value @"SO"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumSO
  | -- | Represents the JSON value @"SR"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumSR
  | -- | Represents the JSON value @"SS"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumSS
  | -- | Represents the JSON value @"ST"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumST
  | -- | Represents the JSON value @"SV"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumSV
  | -- | Represents the JSON value @"SX"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumSX
  | -- | Represents the JSON value @"SZ"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumSZ
  | -- | Represents the JSON value @"TA"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumTA
  | -- | Represents the JSON value @"TC"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumTC
  | -- | Represents the JSON value @"TD"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumTD
  | -- | Represents the JSON value @"TF"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumTF
  | -- | Represents the JSON value @"TG"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumTG
  | -- | Represents the JSON value @"TH"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumTH
  | -- | Represents the JSON value @"TJ"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumTJ
  | -- | Represents the JSON value @"TK"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumTK
  | -- | Represents the JSON value @"TL"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumTL
  | -- | Represents the JSON value @"TM"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumTM
  | -- | Represents the JSON value @"TN"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumTN
  | -- | Represents the JSON value @"TO"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumTO
  | -- | Represents the JSON value @"TR"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumTR
  | -- | Represents the JSON value @"TT"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumTT
  | -- | Represents the JSON value @"TV"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumTV
  | -- | Represents the JSON value @"TW"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumTW
  | -- | Represents the JSON value @"TZ"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumTZ
  | -- | Represents the JSON value @"UA"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumUA
  | -- | Represents the JSON value @"UG"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumUG
  | -- | Represents the JSON value @"US"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumUS
  | -- | Represents the JSON value @"UY"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumUY
  | -- | Represents the JSON value @"UZ"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumUZ
  | -- | Represents the JSON value @"VA"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumVA
  | -- | Represents the JSON value @"VC"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumVC
  | -- | Represents the JSON value @"VE"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumVE
  | -- | Represents the JSON value @"VG"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumVG
  | -- | Represents the JSON value @"VN"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumVN
  | -- | Represents the JSON value @"VU"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumVU
  | -- | Represents the JSON value @"WF"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumWF
  | -- | Represents the JSON value @"WS"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumWS
  | -- | Represents the JSON value @"XK"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumXK
  | -- | Represents the JSON value @"YE"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumYE
  | -- | Represents the JSON value @"YT"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumYT
  | -- | Represents the JSON value @"ZA"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumZA
  | -- | Represents the JSON value @"ZM"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumZM
  | -- | Represents the JSON value @"ZW"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumZW
  | -- | Represents the JSON value @"ZZ"@
    PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumZZ
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries' where
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'Other val) = val
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'Typed val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumAC) = "AC"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumAD) = "AD"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumAE) = "AE"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumAF) = "AF"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumAG) = "AG"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumAI) = "AI"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumAL) = "AL"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumAM) = "AM"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumAO) = "AO"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumAQ) = "AQ"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumAR) = "AR"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumAT) = "AT"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumAU) = "AU"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumAW) = "AW"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumAX) = "AX"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumAZ) = "AZ"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumBA) = "BA"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumBB) = "BB"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumBD) = "BD"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumBE) = "BE"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumBF) = "BF"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumBG) = "BG"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumBH) = "BH"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumBI) = "BI"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumBJ) = "BJ"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumBL) = "BL"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumBM) = "BM"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumBN) = "BN"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumBO) = "BO"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumBQ) = "BQ"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumBR) = "BR"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumBS) = "BS"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumBT) = "BT"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumBV) = "BV"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumBW) = "BW"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumBY) = "BY"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumBZ) = "BZ"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumCA) = "CA"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumCD) = "CD"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumCF) = "CF"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumCG) = "CG"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumCH) = "CH"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumCI) = "CI"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumCK) = "CK"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumCL) = "CL"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumCM) = "CM"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumCN) = "CN"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumCO) = "CO"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumCR) = "CR"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumCV) = "CV"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumCW) = "CW"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumCY) = "CY"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumCZ) = "CZ"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumDE) = "DE"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumDJ) = "DJ"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumDK) = "DK"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumDM) = "DM"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumDO) = "DO"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumDZ) = "DZ"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumEC) = "EC"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumEE) = "EE"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumEG) = "EG"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumEH) = "EH"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumER) = "ER"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumES) = "ES"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumET) = "ET"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumFI) = "FI"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumFJ) = "FJ"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumFK) = "FK"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumFO) = "FO"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumFR) = "FR"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumGA) = "GA"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumGB) = "GB"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumGD) = "GD"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumGE) = "GE"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumGF) = "GF"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumGG) = "GG"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumGH) = "GH"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumGI) = "GI"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumGL) = "GL"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumGM) = "GM"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumGN) = "GN"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumGP) = "GP"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumGQ) = "GQ"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumGR) = "GR"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumGS) = "GS"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumGT) = "GT"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumGU) = "GU"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumGW) = "GW"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumGY) = "GY"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumHK) = "HK"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumHN) = "HN"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumHR) = "HR"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumHT) = "HT"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumHU) = "HU"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumID) = "ID"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumIE) = "IE"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumIL) = "IL"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumIM) = "IM"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumIN) = "IN"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumIO) = "IO"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumIQ) = "IQ"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumIS) = "IS"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumIT) = "IT"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumJE) = "JE"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumJM) = "JM"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumJO) = "JO"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumJP) = "JP"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumKE) = "KE"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumKG) = "KG"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumKH) = "KH"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumKI) = "KI"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumKM) = "KM"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumKN) = "KN"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumKR) = "KR"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumKW) = "KW"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumKY) = "KY"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumKZ) = "KZ"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumLA) = "LA"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumLB) = "LB"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumLC) = "LC"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumLI) = "LI"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumLK) = "LK"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumLR) = "LR"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumLS) = "LS"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumLT) = "LT"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumLU) = "LU"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumLV) = "LV"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumLY) = "LY"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumMA) = "MA"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumMC) = "MC"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumMD) = "MD"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumME) = "ME"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumMF) = "MF"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumMG) = "MG"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumMK) = "MK"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumML) = "ML"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumMM) = "MM"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumMN) = "MN"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumMO) = "MO"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumMQ) = "MQ"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumMR) = "MR"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumMS) = "MS"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumMT) = "MT"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumMU) = "MU"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumMV) = "MV"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumMW) = "MW"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumMX) = "MX"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumMY) = "MY"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumMZ) = "MZ"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumNA) = "NA"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumNC) = "NC"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumNE) = "NE"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumNG) = "NG"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumNI) = "NI"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumNL) = "NL"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumNO) = "NO"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumNP) = "NP"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumNR) = "NR"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumNU) = "NU"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumNZ) = "NZ"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumOM) = "OM"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumPA) = "PA"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumPE) = "PE"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumPF) = "PF"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumPG) = "PG"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumPH) = "PH"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumPK) = "PK"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumPL) = "PL"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumPM) = "PM"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumPN) = "PN"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumPR) = "PR"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumPS) = "PS"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumPT) = "PT"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumPY) = "PY"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumQA) = "QA"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumRE) = "RE"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumRO) = "RO"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumRS) = "RS"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumRU) = "RU"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumRW) = "RW"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumSA) = "SA"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumSB) = "SB"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumSC) = "SC"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumSE) = "SE"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumSG) = "SG"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumSH) = "SH"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumSI) = "SI"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumSJ) = "SJ"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumSK) = "SK"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumSL) = "SL"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumSM) = "SM"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumSN) = "SN"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumSO) = "SO"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumSR) = "SR"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumSS) = "SS"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumST) = "ST"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumSV) = "SV"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumSX) = "SX"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumSZ) = "SZ"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumTA) = "TA"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumTC) = "TC"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumTD) = "TD"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumTF) = "TF"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumTG) = "TG"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumTH) = "TH"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumTJ) = "TJ"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumTK) = "TK"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumTL) = "TL"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumTM) = "TM"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumTN) = "TN"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumTO) = "TO"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumTR) = "TR"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumTT) = "TT"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumTV) = "TV"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumTW) = "TW"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumTZ) = "TZ"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumUA) = "UA"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumUG) = "UG"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumUS) = "US"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumUY) = "UY"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumUZ) = "UZ"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumVA) = "VA"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumVC) = "VC"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumVE) = "VE"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumVG) = "VG"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumVN) = "VN"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumVU) = "VU"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumWF) = "WF"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumWS) = "WS"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumXK) = "XK"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumYE) = "YE"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumYT) = "YT"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumZA) = "ZA"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumZM) = "ZM"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumZW) = "ZW"
  toJSON (PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumZZ) = "ZZ"

instance Data.Aeson.Types.FromJSON.FromJSON PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries' where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "AC" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumAC
            | val GHC.Classes.== "AD" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumAD
            | val GHC.Classes.== "AE" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumAE
            | val GHC.Classes.== "AF" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumAF
            | val GHC.Classes.== "AG" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumAG
            | val GHC.Classes.== "AI" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumAI
            | val GHC.Classes.== "AL" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumAL
            | val GHC.Classes.== "AM" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumAM
            | val GHC.Classes.== "AO" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumAO
            | val GHC.Classes.== "AQ" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumAQ
            | val GHC.Classes.== "AR" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumAR
            | val GHC.Classes.== "AT" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumAT
            | val GHC.Classes.== "AU" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumAU
            | val GHC.Classes.== "AW" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumAW
            | val GHC.Classes.== "AX" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumAX
            | val GHC.Classes.== "AZ" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumAZ
            | val GHC.Classes.== "BA" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumBA
            | val GHC.Classes.== "BB" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumBB
            | val GHC.Classes.== "BD" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumBD
            | val GHC.Classes.== "BE" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumBE
            | val GHC.Classes.== "BF" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumBF
            | val GHC.Classes.== "BG" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumBG
            | val GHC.Classes.== "BH" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumBH
            | val GHC.Classes.== "BI" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumBI
            | val GHC.Classes.== "BJ" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumBJ
            | val GHC.Classes.== "BL" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumBL
            | val GHC.Classes.== "BM" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumBM
            | val GHC.Classes.== "BN" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumBN
            | val GHC.Classes.== "BO" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumBO
            | val GHC.Classes.== "BQ" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumBQ
            | val GHC.Classes.== "BR" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumBR
            | val GHC.Classes.== "BS" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumBS
            | val GHC.Classes.== "BT" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumBT
            | val GHC.Classes.== "BV" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumBV
            | val GHC.Classes.== "BW" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumBW
            | val GHC.Classes.== "BY" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumBY
            | val GHC.Classes.== "BZ" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumBZ
            | val GHC.Classes.== "CA" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumCA
            | val GHC.Classes.== "CD" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumCD
            | val GHC.Classes.== "CF" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumCF
            | val GHC.Classes.== "CG" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumCG
            | val GHC.Classes.== "CH" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumCH
            | val GHC.Classes.== "CI" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumCI
            | val GHC.Classes.== "CK" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumCK
            | val GHC.Classes.== "CL" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumCL
            | val GHC.Classes.== "CM" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumCM
            | val GHC.Classes.== "CN" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumCN
            | val GHC.Classes.== "CO" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumCO
            | val GHC.Classes.== "CR" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumCR
            | val GHC.Classes.== "CV" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumCV
            | val GHC.Classes.== "CW" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumCW
            | val GHC.Classes.== "CY" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumCY
            | val GHC.Classes.== "CZ" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumCZ
            | val GHC.Classes.== "DE" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumDE
            | val GHC.Classes.== "DJ" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumDJ
            | val GHC.Classes.== "DK" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumDK
            | val GHC.Classes.== "DM" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumDM
            | val GHC.Classes.== "DO" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumDO
            | val GHC.Classes.== "DZ" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumDZ
            | val GHC.Classes.== "EC" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumEC
            | val GHC.Classes.== "EE" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumEE
            | val GHC.Classes.== "EG" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumEG
            | val GHC.Classes.== "EH" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumEH
            | val GHC.Classes.== "ER" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumER
            | val GHC.Classes.== "ES" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumES
            | val GHC.Classes.== "ET" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumET
            | val GHC.Classes.== "FI" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumFI
            | val GHC.Classes.== "FJ" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumFJ
            | val GHC.Classes.== "FK" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumFK
            | val GHC.Classes.== "FO" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumFO
            | val GHC.Classes.== "FR" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumFR
            | val GHC.Classes.== "GA" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumGA
            | val GHC.Classes.== "GB" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumGB
            | val GHC.Classes.== "GD" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumGD
            | val GHC.Classes.== "GE" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumGE
            | val GHC.Classes.== "GF" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumGF
            | val GHC.Classes.== "GG" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumGG
            | val GHC.Classes.== "GH" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumGH
            | val GHC.Classes.== "GI" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumGI
            | val GHC.Classes.== "GL" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumGL
            | val GHC.Classes.== "GM" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumGM
            | val GHC.Classes.== "GN" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumGN
            | val GHC.Classes.== "GP" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumGP
            | val GHC.Classes.== "GQ" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumGQ
            | val GHC.Classes.== "GR" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumGR
            | val GHC.Classes.== "GS" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumGS
            | val GHC.Classes.== "GT" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumGT
            | val GHC.Classes.== "GU" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumGU
            | val GHC.Classes.== "GW" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumGW
            | val GHC.Classes.== "GY" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumGY
            | val GHC.Classes.== "HK" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumHK
            | val GHC.Classes.== "HN" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumHN
            | val GHC.Classes.== "HR" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumHR
            | val GHC.Classes.== "HT" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumHT
            | val GHC.Classes.== "HU" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumHU
            | val GHC.Classes.== "ID" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumID
            | val GHC.Classes.== "IE" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumIE
            | val GHC.Classes.== "IL" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumIL
            | val GHC.Classes.== "IM" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumIM
            | val GHC.Classes.== "IN" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumIN
            | val GHC.Classes.== "IO" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumIO
            | val GHC.Classes.== "IQ" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumIQ
            | val GHC.Classes.== "IS" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumIS
            | val GHC.Classes.== "IT" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumIT
            | val GHC.Classes.== "JE" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumJE
            | val GHC.Classes.== "JM" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumJM
            | val GHC.Classes.== "JO" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumJO
            | val GHC.Classes.== "JP" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumJP
            | val GHC.Classes.== "KE" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumKE
            | val GHC.Classes.== "KG" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumKG
            | val GHC.Classes.== "KH" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumKH
            | val GHC.Classes.== "KI" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumKI
            | val GHC.Classes.== "KM" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumKM
            | val GHC.Classes.== "KN" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumKN
            | val GHC.Classes.== "KR" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumKR
            | val GHC.Classes.== "KW" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumKW
            | val GHC.Classes.== "KY" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumKY
            | val GHC.Classes.== "KZ" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumKZ
            | val GHC.Classes.== "LA" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumLA
            | val GHC.Classes.== "LB" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumLB
            | val GHC.Classes.== "LC" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumLC
            | val GHC.Classes.== "LI" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumLI
            | val GHC.Classes.== "LK" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumLK
            | val GHC.Classes.== "LR" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumLR
            | val GHC.Classes.== "LS" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumLS
            | val GHC.Classes.== "LT" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumLT
            | val GHC.Classes.== "LU" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumLU
            | val GHC.Classes.== "LV" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumLV
            | val GHC.Classes.== "LY" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumLY
            | val GHC.Classes.== "MA" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumMA
            | val GHC.Classes.== "MC" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumMC
            | val GHC.Classes.== "MD" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumMD
            | val GHC.Classes.== "ME" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumME
            | val GHC.Classes.== "MF" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumMF
            | val GHC.Classes.== "MG" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumMG
            | val GHC.Classes.== "MK" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumMK
            | val GHC.Classes.== "ML" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumML
            | val GHC.Classes.== "MM" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumMM
            | val GHC.Classes.== "MN" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumMN
            | val GHC.Classes.== "MO" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumMO
            | val GHC.Classes.== "MQ" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumMQ
            | val GHC.Classes.== "MR" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumMR
            | val GHC.Classes.== "MS" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumMS
            | val GHC.Classes.== "MT" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumMT
            | val GHC.Classes.== "MU" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumMU
            | val GHC.Classes.== "MV" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumMV
            | val GHC.Classes.== "MW" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumMW
            | val GHC.Classes.== "MX" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumMX
            | val GHC.Classes.== "MY" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumMY
            | val GHC.Classes.== "MZ" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumMZ
            | val GHC.Classes.== "NA" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumNA
            | val GHC.Classes.== "NC" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumNC
            | val GHC.Classes.== "NE" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumNE
            | val GHC.Classes.== "NG" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumNG
            | val GHC.Classes.== "NI" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumNI
            | val GHC.Classes.== "NL" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumNL
            | val GHC.Classes.== "NO" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumNO
            | val GHC.Classes.== "NP" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumNP
            | val GHC.Classes.== "NR" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumNR
            | val GHC.Classes.== "NU" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumNU
            | val GHC.Classes.== "NZ" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumNZ
            | val GHC.Classes.== "OM" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumOM
            | val GHC.Classes.== "PA" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumPA
            | val GHC.Classes.== "PE" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumPE
            | val GHC.Classes.== "PF" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumPF
            | val GHC.Classes.== "PG" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumPG
            | val GHC.Classes.== "PH" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumPH
            | val GHC.Classes.== "PK" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumPK
            | val GHC.Classes.== "PL" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumPL
            | val GHC.Classes.== "PM" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumPM
            | val GHC.Classes.== "PN" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumPN
            | val GHC.Classes.== "PR" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumPR
            | val GHC.Classes.== "PS" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumPS
            | val GHC.Classes.== "PT" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumPT
            | val GHC.Classes.== "PY" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumPY
            | val GHC.Classes.== "QA" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumQA
            | val GHC.Classes.== "RE" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumRE
            | val GHC.Classes.== "RO" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumRO
            | val GHC.Classes.== "RS" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumRS
            | val GHC.Classes.== "RU" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumRU
            | val GHC.Classes.== "RW" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumRW
            | val GHC.Classes.== "SA" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumSA
            | val GHC.Classes.== "SB" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumSB
            | val GHC.Classes.== "SC" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumSC
            | val GHC.Classes.== "SE" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumSE
            | val GHC.Classes.== "SG" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumSG
            | val GHC.Classes.== "SH" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumSH
            | val GHC.Classes.== "SI" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumSI
            | val GHC.Classes.== "SJ" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumSJ
            | val GHC.Classes.== "SK" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumSK
            | val GHC.Classes.== "SL" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumSL
            | val GHC.Classes.== "SM" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumSM
            | val GHC.Classes.== "SN" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumSN
            | val GHC.Classes.== "SO" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumSO
            | val GHC.Classes.== "SR" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumSR
            | val GHC.Classes.== "SS" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumSS
            | val GHC.Classes.== "ST" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumST
            | val GHC.Classes.== "SV" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumSV
            | val GHC.Classes.== "SX" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumSX
            | val GHC.Classes.== "SZ" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumSZ
            | val GHC.Classes.== "TA" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumTA
            | val GHC.Classes.== "TC" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumTC
            | val GHC.Classes.== "TD" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumTD
            | val GHC.Classes.== "TF" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumTF
            | val GHC.Classes.== "TG" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumTG
            | val GHC.Classes.== "TH" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumTH
            | val GHC.Classes.== "TJ" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumTJ
            | val GHC.Classes.== "TK" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumTK
            | val GHC.Classes.== "TL" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumTL
            | val GHC.Classes.== "TM" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumTM
            | val GHC.Classes.== "TN" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumTN
            | val GHC.Classes.== "TO" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumTO
            | val GHC.Classes.== "TR" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumTR
            | val GHC.Classes.== "TT" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumTT
            | val GHC.Classes.== "TV" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumTV
            | val GHC.Classes.== "TW" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumTW
            | val GHC.Classes.== "TZ" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumTZ
            | val GHC.Classes.== "UA" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumUA
            | val GHC.Classes.== "UG" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumUG
            | val GHC.Classes.== "US" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumUS
            | val GHC.Classes.== "UY" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumUY
            | val GHC.Classes.== "UZ" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumUZ
            | val GHC.Classes.== "VA" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumVA
            | val GHC.Classes.== "VC" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumVC
            | val GHC.Classes.== "VE" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumVE
            | val GHC.Classes.== "VG" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumVG
            | val GHC.Classes.== "VN" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumVN
            | val GHC.Classes.== "VU" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumVU
            | val GHC.Classes.== "WF" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumWF
            | val GHC.Classes.== "WS" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumWS
            | val GHC.Classes.== "XK" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumXK
            | val GHC.Classes.== "YE" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumYE
            | val GHC.Classes.== "YT" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumYT
            | val GHC.Classes.== "ZA" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumZA
            | val GHC.Classes.== "ZM" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumZM
            | val GHC.Classes.== "ZW" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumZW
            | val GHC.Classes.== "ZZ" -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'EnumZZ
            | GHC.Base.otherwise -> PostCheckoutSessionsRequestBodyShippingAddressCollection'AllowedCountries'Other val
      )

-- | Defines the enum schema located at @paths.\/v1\/checkout\/sessions.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.submit_type@ in the specification.
--
-- Describes the type of transaction being performed by Checkout in order to customize
-- relevant text on the page, such as the submit button. \`submit_type\` can only be
-- specified on Checkout Sessions in \`payment\` mode, but not Checkout Sessions
-- in \`subscription\` or \`setup\` mode.
data PostCheckoutSessionsRequestBodySubmitType'
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    PostCheckoutSessionsRequestBodySubmitType'Other Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    PostCheckoutSessionsRequestBodySubmitType'Typed Data.Text.Internal.Text
  | -- | Represents the JSON value @"auto"@
    PostCheckoutSessionsRequestBodySubmitType'EnumAuto
  | -- | Represents the JSON value @"book"@
    PostCheckoutSessionsRequestBodySubmitType'EnumBook
  | -- | Represents the JSON value @"donate"@
    PostCheckoutSessionsRequestBodySubmitType'EnumDonate
  | -- | Represents the JSON value @"pay"@
    PostCheckoutSessionsRequestBodySubmitType'EnumPay
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PostCheckoutSessionsRequestBodySubmitType' where
  toJSON (PostCheckoutSessionsRequestBodySubmitType'Other val) = val
  toJSON (PostCheckoutSessionsRequestBodySubmitType'Typed val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (PostCheckoutSessionsRequestBodySubmitType'EnumAuto) = "auto"
  toJSON (PostCheckoutSessionsRequestBodySubmitType'EnumBook) = "book"
  toJSON (PostCheckoutSessionsRequestBodySubmitType'EnumDonate) = "donate"
  toJSON (PostCheckoutSessionsRequestBodySubmitType'EnumPay) = "pay"

instance Data.Aeson.Types.FromJSON.FromJSON PostCheckoutSessionsRequestBodySubmitType' where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "auto" -> PostCheckoutSessionsRequestBodySubmitType'EnumAuto
            | val GHC.Classes.== "book" -> PostCheckoutSessionsRequestBodySubmitType'EnumBook
            | val GHC.Classes.== "donate" -> PostCheckoutSessionsRequestBodySubmitType'EnumDonate
            | val GHC.Classes.== "pay" -> PostCheckoutSessionsRequestBodySubmitType'EnumPay
            | GHC.Base.otherwise -> PostCheckoutSessionsRequestBodySubmitType'Other val
      )

-- | Defines the object schema located at @paths.\/v1\/checkout\/sessions.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.subscription_data@ in the specification.
--
-- A subset of parameters to be passed to subscription creation for Checkout Sessions in \`subscription\` mode.
data PostCheckoutSessionsRequestBodySubscriptionData' = PostCheckoutSessionsRequestBodySubscriptionData'
  { -- | application_fee_percent
    postCheckoutSessionsRequestBodySubscriptionData'ApplicationFeePercent :: (GHC.Maybe.Maybe GHC.Types.Double),
    -- | default_tax_rates
    postCheckoutSessionsRequestBodySubscriptionData'DefaultTaxRates :: (GHC.Maybe.Maybe ([Data.Text.Internal.Text])),
    -- | items
    postCheckoutSessionsRequestBodySubscriptionData'Items :: (GHC.Maybe.Maybe ([PostCheckoutSessionsRequestBodySubscriptionData'Items'])),
    -- | metadata
    postCheckoutSessionsRequestBodySubscriptionData'Metadata :: (GHC.Maybe.Maybe Data.Aeson.Types.Internal.Object),
    -- | transfer_data
    postCheckoutSessionsRequestBodySubscriptionData'TransferData :: (GHC.Maybe.Maybe PostCheckoutSessionsRequestBodySubscriptionData'TransferData'),
    -- | trial_end
    postCheckoutSessionsRequestBodySubscriptionData'TrialEnd :: (GHC.Maybe.Maybe GHC.Types.Int),
    -- | trial_period_days
    postCheckoutSessionsRequestBodySubscriptionData'TrialPeriodDays :: (GHC.Maybe.Maybe GHC.Types.Int)
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostCheckoutSessionsRequestBodySubscriptionData' where
  toJSON obj = Data.Aeson.Types.Internal.object ("application_fee_percent" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodySubscriptionData'ApplicationFeePercent obj : "default_tax_rates" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodySubscriptionData'DefaultTaxRates obj : "items" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodySubscriptionData'Items obj : "metadata" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodySubscriptionData'Metadata obj : "transfer_data" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodySubscriptionData'TransferData obj : "trial_end" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodySubscriptionData'TrialEnd obj : "trial_period_days" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodySubscriptionData'TrialPeriodDays obj : GHC.Base.mempty)
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (("application_fee_percent" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodySubscriptionData'ApplicationFeePercent obj) GHC.Base.<> (("default_tax_rates" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodySubscriptionData'DefaultTaxRates obj) GHC.Base.<> (("items" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodySubscriptionData'Items obj) GHC.Base.<> (("metadata" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodySubscriptionData'Metadata obj) GHC.Base.<> (("transfer_data" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodySubscriptionData'TransferData obj) GHC.Base.<> (("trial_end" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodySubscriptionData'TrialEnd obj) GHC.Base.<> ("trial_period_days" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodySubscriptionData'TrialPeriodDays obj)))))))

instance Data.Aeson.Types.FromJSON.FromJSON PostCheckoutSessionsRequestBodySubscriptionData' where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostCheckoutSessionsRequestBodySubscriptionData'" (\obj -> ((((((GHC.Base.pure PostCheckoutSessionsRequestBodySubscriptionData' GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "application_fee_percent")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "default_tax_rates")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "items")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "metadata")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "transfer_data")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "trial_end")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "trial_period_days"))

-- | Create a new 'PostCheckoutSessionsRequestBodySubscriptionData'' with all required fields.
mkPostCheckoutSessionsRequestBodySubscriptionData' :: PostCheckoutSessionsRequestBodySubscriptionData'
mkPostCheckoutSessionsRequestBodySubscriptionData' =
  PostCheckoutSessionsRequestBodySubscriptionData'
    { postCheckoutSessionsRequestBodySubscriptionData'ApplicationFeePercent = GHC.Maybe.Nothing,
      postCheckoutSessionsRequestBodySubscriptionData'DefaultTaxRates = GHC.Maybe.Nothing,
      postCheckoutSessionsRequestBodySubscriptionData'Items = GHC.Maybe.Nothing,
      postCheckoutSessionsRequestBodySubscriptionData'Metadata = GHC.Maybe.Nothing,
      postCheckoutSessionsRequestBodySubscriptionData'TransferData = GHC.Maybe.Nothing,
      postCheckoutSessionsRequestBodySubscriptionData'TrialEnd = GHC.Maybe.Nothing,
      postCheckoutSessionsRequestBodySubscriptionData'TrialPeriodDays = GHC.Maybe.Nothing
    }

-- | Defines the object schema located at @paths.\/v1\/checkout\/sessions.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.subscription_data.properties.items.items@ in the specification.
data PostCheckoutSessionsRequestBodySubscriptionData'Items' = PostCheckoutSessionsRequestBodySubscriptionData'Items'
  { -- | plan
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    postCheckoutSessionsRequestBodySubscriptionData'Items'Plan :: Data.Text.Internal.Text,
    -- | quantity
    postCheckoutSessionsRequestBodySubscriptionData'Items'Quantity :: (GHC.Maybe.Maybe GHC.Types.Int),
    -- | tax_rates
    postCheckoutSessionsRequestBodySubscriptionData'Items'TaxRates :: (GHC.Maybe.Maybe ([Data.Text.Internal.Text]))
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostCheckoutSessionsRequestBodySubscriptionData'Items' where
  toJSON obj = Data.Aeson.Types.Internal.object ("plan" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodySubscriptionData'Items'Plan obj : "quantity" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodySubscriptionData'Items'Quantity obj : "tax_rates" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodySubscriptionData'Items'TaxRates obj : GHC.Base.mempty)
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (("plan" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodySubscriptionData'Items'Plan obj) GHC.Base.<> (("quantity" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodySubscriptionData'Items'Quantity obj) GHC.Base.<> ("tax_rates" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodySubscriptionData'Items'TaxRates obj)))

instance Data.Aeson.Types.FromJSON.FromJSON PostCheckoutSessionsRequestBodySubscriptionData'Items' where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostCheckoutSessionsRequestBodySubscriptionData'Items'" (\obj -> ((GHC.Base.pure PostCheckoutSessionsRequestBodySubscriptionData'Items' GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "plan")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "quantity")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "tax_rates"))

-- | Create a new 'PostCheckoutSessionsRequestBodySubscriptionData'Items'' with all required fields.
mkPostCheckoutSessionsRequestBodySubscriptionData'Items' ::
  -- | 'postCheckoutSessionsRequestBodySubscriptionData'Items'Plan'
  Data.Text.Internal.Text ->
  PostCheckoutSessionsRequestBodySubscriptionData'Items'
mkPostCheckoutSessionsRequestBodySubscriptionData'Items' postCheckoutSessionsRequestBodySubscriptionData'Items'Plan =
  PostCheckoutSessionsRequestBodySubscriptionData'Items'
    { postCheckoutSessionsRequestBodySubscriptionData'Items'Plan = postCheckoutSessionsRequestBodySubscriptionData'Items'Plan,
      postCheckoutSessionsRequestBodySubscriptionData'Items'Quantity = GHC.Maybe.Nothing,
      postCheckoutSessionsRequestBodySubscriptionData'Items'TaxRates = GHC.Maybe.Nothing
    }

-- | Defines the object schema located at @paths.\/v1\/checkout\/sessions.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.subscription_data.properties.transfer_data@ in the specification.
data PostCheckoutSessionsRequestBodySubscriptionData'TransferData' = PostCheckoutSessionsRequestBodySubscriptionData'TransferData'
  { -- | amount_percent
    postCheckoutSessionsRequestBodySubscriptionData'TransferData'AmountPercent :: (GHC.Maybe.Maybe GHC.Types.Double),
    -- | destination
    postCheckoutSessionsRequestBodySubscriptionData'TransferData'Destination :: Data.Text.Internal.Text
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostCheckoutSessionsRequestBodySubscriptionData'TransferData' where
  toJSON obj = Data.Aeson.Types.Internal.object ("amount_percent" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodySubscriptionData'TransferData'AmountPercent obj : "destination" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodySubscriptionData'TransferData'Destination obj : GHC.Base.mempty)
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (("amount_percent" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodySubscriptionData'TransferData'AmountPercent obj) GHC.Base.<> ("destination" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodySubscriptionData'TransferData'Destination obj))

instance Data.Aeson.Types.FromJSON.FromJSON PostCheckoutSessionsRequestBodySubscriptionData'TransferData' where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostCheckoutSessionsRequestBodySubscriptionData'TransferData'" (\obj -> (GHC.Base.pure PostCheckoutSessionsRequestBodySubscriptionData'TransferData' GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "amount_percent")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "destination"))

-- | Create a new 'PostCheckoutSessionsRequestBodySubscriptionData'TransferData'' with all required fields.
mkPostCheckoutSessionsRequestBodySubscriptionData'TransferData' ::
  -- | 'postCheckoutSessionsRequestBodySubscriptionData'TransferData'Destination'
  Data.Text.Internal.Text ->
  PostCheckoutSessionsRequestBodySubscriptionData'TransferData'
mkPostCheckoutSessionsRequestBodySubscriptionData'TransferData' postCheckoutSessionsRequestBodySubscriptionData'TransferData'Destination =
  PostCheckoutSessionsRequestBodySubscriptionData'TransferData'
    { postCheckoutSessionsRequestBodySubscriptionData'TransferData'AmountPercent = GHC.Maybe.Nothing,
      postCheckoutSessionsRequestBodySubscriptionData'TransferData'Destination = postCheckoutSessionsRequestBodySubscriptionData'TransferData'Destination
    }

-- | Defines the object schema located at @paths.\/v1\/checkout\/sessions.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.tax_id_collection@ in the specification.
--
-- Controls tax ID collection settings for the session.
data PostCheckoutSessionsRequestBodyTaxIdCollection' = PostCheckoutSessionsRequestBodyTaxIdCollection'
  { -- | enabled
    postCheckoutSessionsRequestBodyTaxIdCollection'Enabled :: GHC.Types.Bool
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostCheckoutSessionsRequestBodyTaxIdCollection' where
  toJSON obj = Data.Aeson.Types.Internal.object ("enabled" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodyTaxIdCollection'Enabled obj : GHC.Base.mempty)
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs ("enabled" Data.Aeson.Types.ToJSON..= postCheckoutSessionsRequestBodyTaxIdCollection'Enabled obj)

instance Data.Aeson.Types.FromJSON.FromJSON PostCheckoutSessionsRequestBodyTaxIdCollection' where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostCheckoutSessionsRequestBodyTaxIdCollection'" (\obj -> GHC.Base.pure PostCheckoutSessionsRequestBodyTaxIdCollection' GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "enabled"))

-- | Create a new 'PostCheckoutSessionsRequestBodyTaxIdCollection'' with all required fields.
mkPostCheckoutSessionsRequestBodyTaxIdCollection' ::
  -- | 'postCheckoutSessionsRequestBodyTaxIdCollection'Enabled'
  GHC.Types.Bool ->
  PostCheckoutSessionsRequestBodyTaxIdCollection'
mkPostCheckoutSessionsRequestBodyTaxIdCollection' postCheckoutSessionsRequestBodyTaxIdCollection'Enabled = PostCheckoutSessionsRequestBodyTaxIdCollection' {postCheckoutSessionsRequestBodyTaxIdCollection'Enabled = postCheckoutSessionsRequestBodyTaxIdCollection'Enabled}

-- | Represents a response of the operation 'postCheckoutSessions'.
--
-- The response constructor is chosen by the status code of the response. If no case matches (no specific case for the response code, no range case, no default case), 'PostCheckoutSessionsResponseError' is used.
data PostCheckoutSessionsResponse
  = -- | Means either no matching case available or a parse error
    PostCheckoutSessionsResponseError GHC.Base.String
  | -- | Successful response.
    PostCheckoutSessionsResponse200 Checkout'session
  | -- | Error response.
    PostCheckoutSessionsResponseDefault Error
  deriving (GHC.Show.Show, GHC.Classes.Eq)
