{-# LANGUAGE MultiWayIf #-}
-- CHANGE WITH CAUTION: This is a generated code file generated by https://github.com/Haskell-OpenAPI-Code-Generator/Haskell-OpenAPI-Client-Code-Generator.
{-# LANGUAGE OverloadedStrings #-}

-- | Contains the types generated from the schema Issuing_Cardholder
module StripeAPI.Types.Issuing_Cardholder where

import qualified Control.Monad.Fail
import qualified Data.Aeson
import qualified Data.Aeson as Data.Aeson.Encoding.Internal
import qualified Data.Aeson as Data.Aeson.Types
import qualified Data.Aeson as Data.Aeson.Types.FromJSON
import qualified Data.Aeson as Data.Aeson.Types.Internal
import qualified Data.Aeson as Data.Aeson.Types.ToJSON
import qualified Data.ByteString.Char8
import qualified Data.ByteString.Char8 as Data.ByteString.Internal
import qualified Data.Functor
import qualified Data.Scientific
import qualified Data.Text
import qualified Data.Text.Internal
import qualified Data.Time.Calendar as Data.Time.Calendar.Days
import qualified Data.Time.LocalTime as Data.Time.LocalTime.Internal.ZonedTime
import qualified GHC.Base
import qualified GHC.Classes
import qualified GHC.Int
import qualified GHC.Show
import qualified GHC.Types
import qualified StripeAPI.Common
import StripeAPI.TypeAlias
import {-# SOURCE #-} StripeAPI.Types.File
import {-# SOURCE #-} StripeAPI.Types.IssuingCardholderAddress
import {-# SOURCE #-} StripeAPI.Types.IssuingCardholderAuthorizationControls
import {-# SOURCE #-} StripeAPI.Types.IssuingCardholderCompany
import {-# SOURCE #-} StripeAPI.Types.IssuingCardholderIdDocument
import {-# SOURCE #-} StripeAPI.Types.IssuingCardholderIndividual
import {-# SOURCE #-} StripeAPI.Types.IssuingCardholderIndividualDob
import {-# SOURCE #-} StripeAPI.Types.IssuingCardholderRequirements
import {-# SOURCE #-} StripeAPI.Types.IssuingCardholderSpendingLimit
import {-# SOURCE #-} StripeAPI.Types.IssuingCardholderVerification
import qualified Prelude as GHC.Integer.Type
import qualified Prelude as GHC.Maybe

-- | Defines the object schema located at @components.schemas.issuing.cardholder@ in the specification.
--
-- An Issuing \`Cardholder\` object represents an individual or business entity who is [issued](https:\/\/stripe.com\/docs\/issuing) cards.
--
-- Related guide: [How to create a Cardholder](https:\/\/stripe.com\/docs\/issuing\/cards\#create-cardholder)
data Issuing'cardholder = Issuing'cardholder
  { -- | billing:
    issuing'cardholderBilling :: IssuingCardholderAddress,
    -- | company: Additional information about a \`company\` cardholder.
    issuing'cardholderCompany :: (GHC.Maybe.Maybe Issuing'cardholderCompany'),
    -- | created: Time at which the object was created. Measured in seconds since the Unix epoch.
    issuing'cardholderCreated :: GHC.Types.Int,
    -- | email: The cardholder\'s email address.
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    issuing'cardholderEmail :: (GHC.Maybe.Maybe Data.Text.Internal.Text),
    -- | id: Unique identifier for the object.
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    issuing'cardholderId :: Data.Text.Internal.Text,
    -- | individual: Additional information about an \`individual\` cardholder.
    issuing'cardholderIndividual :: (GHC.Maybe.Maybe Issuing'cardholderIndividual'),
    -- | livemode: Has the value \`true\` if the object exists in live mode or the value \`false\` if the object exists in test mode.
    issuing'cardholderLivemode :: GHC.Types.Bool,
    -- | metadata: Set of [key-value pairs](https:\/\/stripe.com\/docs\/api\/metadata) that you can attach to an object. This can be useful for storing additional information about the object in a structured format.
    issuing'cardholderMetadata :: Data.Aeson.Types.Internal.Object,
    -- | name: The cardholder\'s name. This will be printed on cards issued to them.
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    issuing'cardholderName :: Data.Text.Internal.Text,
    -- | phone_number: The cardholder\'s phone number.
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    issuing'cardholderPhoneNumber :: (GHC.Maybe.Maybe Data.Text.Internal.Text),
    -- | requirements:
    issuing'cardholderRequirements :: IssuingCardholderRequirements,
    -- | spending_controls: Rules that control spending across this cardholder\'s cards. Refer to our [documentation](https:\/\/stripe.com\/docs\/issuing\/controls\/spending-controls) for more details.
    issuing'cardholderSpendingControls :: (GHC.Maybe.Maybe Issuing'cardholderSpendingControls'),
    -- | status: Specifies whether to permit authorizations on this cardholder\'s cards.
    issuing'cardholderStatus :: Issuing'cardholderStatus',
    -- | type: One of \`individual\` or \`company\`.
    issuing'cardholderType :: Issuing'cardholderType'
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON Issuing'cardholder where
  toJSON obj = Data.Aeson.Types.Internal.object ("billing" Data.Aeson.Types.ToJSON..= issuing'cardholderBilling obj : "company" Data.Aeson.Types.ToJSON..= issuing'cardholderCompany obj : "created" Data.Aeson.Types.ToJSON..= issuing'cardholderCreated obj : "email" Data.Aeson.Types.ToJSON..= issuing'cardholderEmail obj : "id" Data.Aeson.Types.ToJSON..= issuing'cardholderId obj : "individual" Data.Aeson.Types.ToJSON..= issuing'cardholderIndividual obj : "livemode" Data.Aeson.Types.ToJSON..= issuing'cardholderLivemode obj : "metadata" Data.Aeson.Types.ToJSON..= issuing'cardholderMetadata obj : "name" Data.Aeson.Types.ToJSON..= issuing'cardholderName obj : "phone_number" Data.Aeson.Types.ToJSON..= issuing'cardholderPhoneNumber obj : "requirements" Data.Aeson.Types.ToJSON..= issuing'cardholderRequirements obj : "spending_controls" Data.Aeson.Types.ToJSON..= issuing'cardholderSpendingControls obj : "status" Data.Aeson.Types.ToJSON..= issuing'cardholderStatus obj : "type" Data.Aeson.Types.ToJSON..= issuing'cardholderType obj : "object" Data.Aeson.Types.ToJSON..= Data.Aeson.Types.Internal.String "issuing.cardholder" : GHC.Base.mempty)
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (("billing" Data.Aeson.Types.ToJSON..= issuing'cardholderBilling obj) GHC.Base.<> (("company" Data.Aeson.Types.ToJSON..= issuing'cardholderCompany obj) GHC.Base.<> (("created" Data.Aeson.Types.ToJSON..= issuing'cardholderCreated obj) GHC.Base.<> (("email" Data.Aeson.Types.ToJSON..= issuing'cardholderEmail obj) GHC.Base.<> (("id" Data.Aeson.Types.ToJSON..= issuing'cardholderId obj) GHC.Base.<> (("individual" Data.Aeson.Types.ToJSON..= issuing'cardholderIndividual obj) GHC.Base.<> (("livemode" Data.Aeson.Types.ToJSON..= issuing'cardholderLivemode obj) GHC.Base.<> (("metadata" Data.Aeson.Types.ToJSON..= issuing'cardholderMetadata obj) GHC.Base.<> (("name" Data.Aeson.Types.ToJSON..= issuing'cardholderName obj) GHC.Base.<> (("phone_number" Data.Aeson.Types.ToJSON..= issuing'cardholderPhoneNumber obj) GHC.Base.<> (("requirements" Data.Aeson.Types.ToJSON..= issuing'cardholderRequirements obj) GHC.Base.<> (("spending_controls" Data.Aeson.Types.ToJSON..= issuing'cardholderSpendingControls obj) GHC.Base.<> (("status" Data.Aeson.Types.ToJSON..= issuing'cardholderStatus obj) GHC.Base.<> (("type" Data.Aeson.Types.ToJSON..= issuing'cardholderType obj) GHC.Base.<> ("object" Data.Aeson.Types.ToJSON..= Data.Aeson.Types.Internal.String "issuing.cardholder")))))))))))))))

instance Data.Aeson.Types.FromJSON.FromJSON Issuing'cardholder where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "Issuing'cardholder" (\obj -> (((((((((((((GHC.Base.pure Issuing'cardholder GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "billing")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "company")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "created")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "email")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "id")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "individual")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "livemode")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "metadata")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "name")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "phone_number")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "requirements")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "spending_controls")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "status")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "type"))

-- | Create a new 'Issuing'cardholder' with all required fields.
mkIssuing'cardholder ::
  -- | 'issuing'cardholderBilling'
  IssuingCardholderAddress ->
  -- | 'issuing'cardholderCreated'
  GHC.Types.Int ->
  -- | 'issuing'cardholderId'
  Data.Text.Internal.Text ->
  -- | 'issuing'cardholderLivemode'
  GHC.Types.Bool ->
  -- | 'issuing'cardholderMetadata'
  Data.Aeson.Types.Internal.Object ->
  -- | 'issuing'cardholderName'
  Data.Text.Internal.Text ->
  -- | 'issuing'cardholderRequirements'
  IssuingCardholderRequirements ->
  -- | 'issuing'cardholderStatus'
  Issuing'cardholderStatus' ->
  -- | 'issuing'cardholderType'
  Issuing'cardholderType' ->
  Issuing'cardholder
mkIssuing'cardholder issuing'cardholderBilling issuing'cardholderCreated issuing'cardholderId issuing'cardholderLivemode issuing'cardholderMetadata issuing'cardholderName issuing'cardholderRequirements issuing'cardholderStatus issuing'cardholderType =
  Issuing'cardholder
    { issuing'cardholderBilling = issuing'cardholderBilling,
      issuing'cardholderCompany = GHC.Maybe.Nothing,
      issuing'cardholderCreated = issuing'cardholderCreated,
      issuing'cardholderEmail = GHC.Maybe.Nothing,
      issuing'cardholderId = issuing'cardholderId,
      issuing'cardholderIndividual = GHC.Maybe.Nothing,
      issuing'cardholderLivemode = issuing'cardholderLivemode,
      issuing'cardholderMetadata = issuing'cardholderMetadata,
      issuing'cardholderName = issuing'cardholderName,
      issuing'cardholderPhoneNumber = GHC.Maybe.Nothing,
      issuing'cardholderRequirements = issuing'cardholderRequirements,
      issuing'cardholderSpendingControls = GHC.Maybe.Nothing,
      issuing'cardholderStatus = issuing'cardholderStatus,
      issuing'cardholderType = issuing'cardholderType
    }

-- | Defines the object schema located at @components.schemas.issuing.cardholder.properties.company.anyOf@ in the specification.
--
-- Additional information about a \\\`company\\\` cardholder.
data Issuing'cardholderCompany' = Issuing'cardholderCompany'
  { -- | tax_id_provided: Whether the company\'s business ID number was provided.
    issuing'cardholderCompany'TaxIdProvided :: (GHC.Maybe.Maybe GHC.Types.Bool)
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON Issuing'cardholderCompany' where
  toJSON obj = Data.Aeson.Types.Internal.object ("tax_id_provided" Data.Aeson.Types.ToJSON..= issuing'cardholderCompany'TaxIdProvided obj : GHC.Base.mempty)
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs ("tax_id_provided" Data.Aeson.Types.ToJSON..= issuing'cardholderCompany'TaxIdProvided obj)

instance Data.Aeson.Types.FromJSON.FromJSON Issuing'cardholderCompany' where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "Issuing'cardholderCompany'" (\obj -> GHC.Base.pure Issuing'cardholderCompany' GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "tax_id_provided"))

-- | Create a new 'Issuing'cardholderCompany'' with all required fields.
mkIssuing'cardholderCompany' :: Issuing'cardholderCompany'
mkIssuing'cardholderCompany' = Issuing'cardholderCompany' {issuing'cardholderCompany'TaxIdProvided = GHC.Maybe.Nothing}

-- | Defines the object schema located at @components.schemas.issuing.cardholder.properties.individual.anyOf@ in the specification.
--
-- Additional information about an \\\`individual\\\` cardholder.
data Issuing'cardholderIndividual' = Issuing'cardholderIndividual'
  { -- | dob: The date of birth of this cardholder.
    issuing'cardholderIndividual'Dob :: (GHC.Maybe.Maybe Issuing'cardholderIndividual'Dob'),
    -- | first_name: The first name of this cardholder.
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    issuing'cardholderIndividual'FirstName :: (GHC.Maybe.Maybe Data.Text.Internal.Text),
    -- | last_name: The last name of this cardholder.
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    issuing'cardholderIndividual'LastName :: (GHC.Maybe.Maybe Data.Text.Internal.Text),
    -- | verification: Government-issued ID document for this cardholder.
    issuing'cardholderIndividual'Verification :: (GHC.Maybe.Maybe Issuing'cardholderIndividual'Verification')
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON Issuing'cardholderIndividual' where
  toJSON obj = Data.Aeson.Types.Internal.object ("dob" Data.Aeson.Types.ToJSON..= issuing'cardholderIndividual'Dob obj : "first_name" Data.Aeson.Types.ToJSON..= issuing'cardholderIndividual'FirstName obj : "last_name" Data.Aeson.Types.ToJSON..= issuing'cardholderIndividual'LastName obj : "verification" Data.Aeson.Types.ToJSON..= issuing'cardholderIndividual'Verification obj : GHC.Base.mempty)
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (("dob" Data.Aeson.Types.ToJSON..= issuing'cardholderIndividual'Dob obj) GHC.Base.<> (("first_name" Data.Aeson.Types.ToJSON..= issuing'cardholderIndividual'FirstName obj) GHC.Base.<> (("last_name" Data.Aeson.Types.ToJSON..= issuing'cardholderIndividual'LastName obj) GHC.Base.<> ("verification" Data.Aeson.Types.ToJSON..= issuing'cardholderIndividual'Verification obj))))

instance Data.Aeson.Types.FromJSON.FromJSON Issuing'cardholderIndividual' where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "Issuing'cardholderIndividual'" (\obj -> (((GHC.Base.pure Issuing'cardholderIndividual' GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "dob")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "first_name")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "last_name")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "verification"))

-- | Create a new 'Issuing'cardholderIndividual'' with all required fields.
mkIssuing'cardholderIndividual' :: Issuing'cardholderIndividual'
mkIssuing'cardholderIndividual' =
  Issuing'cardholderIndividual'
    { issuing'cardholderIndividual'Dob = GHC.Maybe.Nothing,
      issuing'cardholderIndividual'FirstName = GHC.Maybe.Nothing,
      issuing'cardholderIndividual'LastName = GHC.Maybe.Nothing,
      issuing'cardholderIndividual'Verification = GHC.Maybe.Nothing
    }

-- | Defines the object schema located at @components.schemas.issuing.cardholder.properties.individual.anyOf.properties.dob.anyOf@ in the specification.
--
-- The date of birth of this cardholder.
data Issuing'cardholderIndividual'Dob' = Issuing'cardholderIndividual'Dob'
  { -- | day: The day of birth, between 1 and 31.
    issuing'cardholderIndividual'Dob'Day :: (GHC.Maybe.Maybe GHC.Types.Int),
    -- | month: The month of birth, between 1 and 12.
    issuing'cardholderIndividual'Dob'Month :: (GHC.Maybe.Maybe GHC.Types.Int),
    -- | year: The four-digit year of birth.
    issuing'cardholderIndividual'Dob'Year :: (GHC.Maybe.Maybe GHC.Types.Int)
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON Issuing'cardholderIndividual'Dob' where
  toJSON obj = Data.Aeson.Types.Internal.object ("day" Data.Aeson.Types.ToJSON..= issuing'cardholderIndividual'Dob'Day obj : "month" Data.Aeson.Types.ToJSON..= issuing'cardholderIndividual'Dob'Month obj : "year" Data.Aeson.Types.ToJSON..= issuing'cardholderIndividual'Dob'Year obj : GHC.Base.mempty)
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (("day" Data.Aeson.Types.ToJSON..= issuing'cardholderIndividual'Dob'Day obj) GHC.Base.<> (("month" Data.Aeson.Types.ToJSON..= issuing'cardholderIndividual'Dob'Month obj) GHC.Base.<> ("year" Data.Aeson.Types.ToJSON..= issuing'cardholderIndividual'Dob'Year obj)))

instance Data.Aeson.Types.FromJSON.FromJSON Issuing'cardholderIndividual'Dob' where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "Issuing'cardholderIndividual'Dob'" (\obj -> ((GHC.Base.pure Issuing'cardholderIndividual'Dob' GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "day")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "month")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "year"))

-- | Create a new 'Issuing'cardholderIndividual'Dob'' with all required fields.
mkIssuing'cardholderIndividual'Dob' :: Issuing'cardholderIndividual'Dob'
mkIssuing'cardholderIndividual'Dob' =
  Issuing'cardholderIndividual'Dob'
    { issuing'cardholderIndividual'Dob'Day = GHC.Maybe.Nothing,
      issuing'cardholderIndividual'Dob'Month = GHC.Maybe.Nothing,
      issuing'cardholderIndividual'Dob'Year = GHC.Maybe.Nothing
    }

-- | Defines the object schema located at @components.schemas.issuing.cardholder.properties.individual.anyOf.properties.verification.anyOf@ in the specification.
--
-- Government-issued ID document for this cardholder.
data Issuing'cardholderIndividual'Verification' = Issuing'cardholderIndividual'Verification'
  { -- | document: An identifying document, either a passport or local ID card.
    issuing'cardholderIndividual'Verification'Document :: (GHC.Maybe.Maybe Issuing'cardholderIndividual'Verification'Document')
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON Issuing'cardholderIndividual'Verification' where
  toJSON obj = Data.Aeson.Types.Internal.object ("document" Data.Aeson.Types.ToJSON..= issuing'cardholderIndividual'Verification'Document obj : GHC.Base.mempty)
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs ("document" Data.Aeson.Types.ToJSON..= issuing'cardholderIndividual'Verification'Document obj)

instance Data.Aeson.Types.FromJSON.FromJSON Issuing'cardholderIndividual'Verification' where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "Issuing'cardholderIndividual'Verification'" (\obj -> GHC.Base.pure Issuing'cardholderIndividual'Verification' GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "document"))

-- | Create a new 'Issuing'cardholderIndividual'Verification'' with all required fields.
mkIssuing'cardholderIndividual'Verification' :: Issuing'cardholderIndividual'Verification'
mkIssuing'cardholderIndividual'Verification' = Issuing'cardholderIndividual'Verification' {issuing'cardholderIndividual'Verification'Document = GHC.Maybe.Nothing}

-- | Defines the object schema located at @components.schemas.issuing.cardholder.properties.individual.anyOf.properties.verification.anyOf.properties.document.anyOf@ in the specification.
--
-- An identifying document, either a passport or local ID card.
data Issuing'cardholderIndividual'Verification'Document' = Issuing'cardholderIndividual'Verification'Document'
  { -- | back: The back of a document returned by a [file upload](https:\/\/stripe.com\/docs\/api\#create_file) with a \`purpose\` value of \`identity_document\`.
    issuing'cardholderIndividual'Verification'Document'Back :: (GHC.Maybe.Maybe Issuing'cardholderIndividual'Verification'Document'Back'Variants),
    -- | front: The front of a document returned by a [file upload](https:\/\/stripe.com\/docs\/api\#create_file) with a \`purpose\` value of \`identity_document\`.
    issuing'cardholderIndividual'Verification'Document'Front :: (GHC.Maybe.Maybe Issuing'cardholderIndividual'Verification'Document'Front'Variants)
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON Issuing'cardholderIndividual'Verification'Document' where
  toJSON obj = Data.Aeson.Types.Internal.object ("back" Data.Aeson.Types.ToJSON..= issuing'cardholderIndividual'Verification'Document'Back obj : "front" Data.Aeson.Types.ToJSON..= issuing'cardholderIndividual'Verification'Document'Front obj : GHC.Base.mempty)
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (("back" Data.Aeson.Types.ToJSON..= issuing'cardholderIndividual'Verification'Document'Back obj) GHC.Base.<> ("front" Data.Aeson.Types.ToJSON..= issuing'cardholderIndividual'Verification'Document'Front obj))

instance Data.Aeson.Types.FromJSON.FromJSON Issuing'cardholderIndividual'Verification'Document' where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "Issuing'cardholderIndividual'Verification'Document'" (\obj -> (GHC.Base.pure Issuing'cardholderIndividual'Verification'Document' GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "back")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "front"))

-- | Create a new 'Issuing'cardholderIndividual'Verification'Document'' with all required fields.
mkIssuing'cardholderIndividual'Verification'Document' :: Issuing'cardholderIndividual'Verification'Document'
mkIssuing'cardholderIndividual'Verification'Document' =
  Issuing'cardholderIndividual'Verification'Document'
    { issuing'cardholderIndividual'Verification'Document'Back = GHC.Maybe.Nothing,
      issuing'cardholderIndividual'Verification'Document'Front = GHC.Maybe.Nothing
    }

-- | Defines the oneOf schema located at @components.schemas.issuing.cardholder.properties.individual.anyOf.properties.verification.anyOf.properties.document.anyOf.properties.back.anyOf@ in the specification.
--
-- The back of a document returned by a [file upload](https:\/\/stripe.com\/docs\/api\#create_file) with a \`purpose\` value of \`identity_document\`.
data Issuing'cardholderIndividual'Verification'Document'Back'Variants
  = Issuing'cardholderIndividual'Verification'Document'Back'Text Data.Text.Internal.Text
  | Issuing'cardholderIndividual'Verification'Document'Back'File File
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON Issuing'cardholderIndividual'Verification'Document'Back'Variants where
  toJSON (Issuing'cardholderIndividual'Verification'Document'Back'Text a) = Data.Aeson.Types.ToJSON.toJSON a
  toJSON (Issuing'cardholderIndividual'Verification'Document'Back'File a) = Data.Aeson.Types.ToJSON.toJSON a

instance Data.Aeson.Types.FromJSON.FromJSON Issuing'cardholderIndividual'Verification'Document'Back'Variants where
  parseJSON val = case (Issuing'cardholderIndividual'Verification'Document'Back'Text Data.Functor.<$> Data.Aeson.Types.FromJSON.fromJSON val) GHC.Base.<|> ((Issuing'cardholderIndividual'Verification'Document'Back'File Data.Functor.<$> Data.Aeson.Types.FromJSON.fromJSON val) GHC.Base.<|> Data.Aeson.Types.Internal.Error "No variant matched") of
    Data.Aeson.Types.Internal.Success a -> GHC.Base.pure a
    Data.Aeson.Types.Internal.Error a -> Control.Monad.Fail.fail a

-- | Defines the oneOf schema located at @components.schemas.issuing.cardholder.properties.individual.anyOf.properties.verification.anyOf.properties.document.anyOf.properties.front.anyOf@ in the specification.
--
-- The front of a document returned by a [file upload](https:\/\/stripe.com\/docs\/api\#create_file) with a \`purpose\` value of \`identity_document\`.
data Issuing'cardholderIndividual'Verification'Document'Front'Variants
  = Issuing'cardholderIndividual'Verification'Document'Front'Text Data.Text.Internal.Text
  | Issuing'cardholderIndividual'Verification'Document'Front'File File
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON Issuing'cardholderIndividual'Verification'Document'Front'Variants where
  toJSON (Issuing'cardholderIndividual'Verification'Document'Front'Text a) = Data.Aeson.Types.ToJSON.toJSON a
  toJSON (Issuing'cardholderIndividual'Verification'Document'Front'File a) = Data.Aeson.Types.ToJSON.toJSON a

instance Data.Aeson.Types.FromJSON.FromJSON Issuing'cardholderIndividual'Verification'Document'Front'Variants where
  parseJSON val = case (Issuing'cardholderIndividual'Verification'Document'Front'Text Data.Functor.<$> Data.Aeson.Types.FromJSON.fromJSON val) GHC.Base.<|> ((Issuing'cardholderIndividual'Verification'Document'Front'File Data.Functor.<$> Data.Aeson.Types.FromJSON.fromJSON val) GHC.Base.<|> Data.Aeson.Types.Internal.Error "No variant matched") of
    Data.Aeson.Types.Internal.Success a -> GHC.Base.pure a
    Data.Aeson.Types.Internal.Error a -> Control.Monad.Fail.fail a

-- | Defines the object schema located at @components.schemas.issuing.cardholder.properties.spending_controls.anyOf@ in the specification.
--
-- Rules that control spending across this cardholder\\\'s cards. Refer to our [documentation](https:\\\/\\\/stripe.com\\\/docs\\\/issuing\\\/controls\\\/spending-controls) for more details.
data Issuing'cardholderSpendingControls' = Issuing'cardholderSpendingControls'
  { -- | allowed_categories: Array of strings containing [categories](https:\/\/stripe.com\/docs\/api\#issuing_authorization_object-merchant_data-category) of authorizations to allow. All other categories will be blocked. Cannot be set with \`blocked_categories\`.
    issuing'cardholderSpendingControls'AllowedCategories :: (GHC.Maybe.Maybe ([Issuing'cardholderSpendingControls'AllowedCategories'])),
    -- | blocked_categories: Array of strings containing [categories](https:\/\/stripe.com\/docs\/api\#issuing_authorization_object-merchant_data-category) of authorizations to decline. All other categories will be allowed. Cannot be set with \`allowed_categories\`.
    issuing'cardholderSpendingControls'BlockedCategories :: (GHC.Maybe.Maybe ([Issuing'cardholderSpendingControls'BlockedCategories'])),
    -- | spending_limits: Limit spending with amount-based rules that apply across this cardholder\'s cards.
    issuing'cardholderSpendingControls'SpendingLimits :: (GHC.Maybe.Maybe ([IssuingCardholderSpendingLimit])),
    -- | spending_limits_currency: Currency of the amounts within \`spending_limits\`.
    issuing'cardholderSpendingControls'SpendingLimitsCurrency :: (GHC.Maybe.Maybe Data.Text.Internal.Text)
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON Issuing'cardholderSpendingControls' where
  toJSON obj = Data.Aeson.Types.Internal.object ("allowed_categories" Data.Aeson.Types.ToJSON..= issuing'cardholderSpendingControls'AllowedCategories obj : "blocked_categories" Data.Aeson.Types.ToJSON..= issuing'cardholderSpendingControls'BlockedCategories obj : "spending_limits" Data.Aeson.Types.ToJSON..= issuing'cardholderSpendingControls'SpendingLimits obj : "spending_limits_currency" Data.Aeson.Types.ToJSON..= issuing'cardholderSpendingControls'SpendingLimitsCurrency obj : GHC.Base.mempty)
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (("allowed_categories" Data.Aeson.Types.ToJSON..= issuing'cardholderSpendingControls'AllowedCategories obj) GHC.Base.<> (("blocked_categories" Data.Aeson.Types.ToJSON..= issuing'cardholderSpendingControls'BlockedCategories obj) GHC.Base.<> (("spending_limits" Data.Aeson.Types.ToJSON..= issuing'cardholderSpendingControls'SpendingLimits obj) GHC.Base.<> ("spending_limits_currency" Data.Aeson.Types.ToJSON..= issuing'cardholderSpendingControls'SpendingLimitsCurrency obj))))

instance Data.Aeson.Types.FromJSON.FromJSON Issuing'cardholderSpendingControls' where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "Issuing'cardholderSpendingControls'" (\obj -> (((GHC.Base.pure Issuing'cardholderSpendingControls' GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "allowed_categories")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "blocked_categories")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "spending_limits")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "spending_limits_currency"))

-- | Create a new 'Issuing'cardholderSpendingControls'' with all required fields.
mkIssuing'cardholderSpendingControls' :: Issuing'cardholderSpendingControls'
mkIssuing'cardholderSpendingControls' =
  Issuing'cardholderSpendingControls'
    { issuing'cardholderSpendingControls'AllowedCategories = GHC.Maybe.Nothing,
      issuing'cardholderSpendingControls'BlockedCategories = GHC.Maybe.Nothing,
      issuing'cardholderSpendingControls'SpendingLimits = GHC.Maybe.Nothing,
      issuing'cardholderSpendingControls'SpendingLimitsCurrency = GHC.Maybe.Nothing
    }

-- | Defines the enum schema located at @components.schemas.issuing.cardholder.properties.spending_controls.anyOf.properties.allowed_categories.items@ in the specification.
data Issuing'cardholderSpendingControls'AllowedCategories'
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    Issuing'cardholderSpendingControls'AllowedCategories'Other Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    Issuing'cardholderSpendingControls'AllowedCategories'Typed Data.Text.Internal.Text
  | -- | Represents the JSON value @"ac_refrigeration_repair"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumAcRefrigerationRepair
  | -- | Represents the JSON value @"accounting_bookkeeping_services"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumAccountingBookkeepingServices
  | -- | Represents the JSON value @"advertising_services"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumAdvertisingServices
  | -- | Represents the JSON value @"agricultural_cooperative"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumAgriculturalCooperative
  | -- | Represents the JSON value @"airlines_air_carriers"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumAirlinesAirCarriers
  | -- | Represents the JSON value @"airports_flying_fields"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumAirportsFlyingFields
  | -- | Represents the JSON value @"ambulance_services"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumAmbulanceServices
  | -- | Represents the JSON value @"amusement_parks_carnivals"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumAmusementParksCarnivals
  | -- | Represents the JSON value @"antique_reproductions"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumAntiqueReproductions
  | -- | Represents the JSON value @"antique_shops"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumAntiqueShops
  | -- | Represents the JSON value @"aquariums"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumAquariums
  | -- | Represents the JSON value @"architectural_surveying_services"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumArchitecturalSurveyingServices
  | -- | Represents the JSON value @"art_dealers_and_galleries"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumArtDealersAndGalleries
  | -- | Represents the JSON value @"artists_supply_and_craft_shops"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumArtistsSupplyAndCraftShops
  | -- | Represents the JSON value @"auto_and_home_supply_stores"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumAutoAndHomeSupplyStores
  | -- | Represents the JSON value @"auto_body_repair_shops"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumAutoBodyRepairShops
  | -- | Represents the JSON value @"auto_paint_shops"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumAutoPaintShops
  | -- | Represents the JSON value @"auto_service_shops"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumAutoServiceShops
  | -- | Represents the JSON value @"automated_cash_disburse"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumAutomatedCashDisburse
  | -- | Represents the JSON value @"automated_fuel_dispensers"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumAutomatedFuelDispensers
  | -- | Represents the JSON value @"automobile_associations"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumAutomobileAssociations
  | -- | Represents the JSON value @"automotive_parts_and_accessories_stores"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumAutomotivePartsAndAccessoriesStores
  | -- | Represents the JSON value @"automotive_tire_stores"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumAutomotiveTireStores
  | -- | Represents the JSON value @"bail_and_bond_payments"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumBailAndBondPayments
  | -- | Represents the JSON value @"bakeries"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumBakeries
  | -- | Represents the JSON value @"bands_orchestras"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumBandsOrchestras
  | -- | Represents the JSON value @"barber_and_beauty_shops"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumBarberAndBeautyShops
  | -- | Represents the JSON value @"betting_casino_gambling"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumBettingCasinoGambling
  | -- | Represents the JSON value @"bicycle_shops"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumBicycleShops
  | -- | Represents the JSON value @"billiard_pool_establishments"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumBilliardPoolEstablishments
  | -- | Represents the JSON value @"boat_dealers"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumBoatDealers
  | -- | Represents the JSON value @"boat_rentals_and_leases"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumBoatRentalsAndLeases
  | -- | Represents the JSON value @"book_stores"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumBookStores
  | -- | Represents the JSON value @"books_periodicals_and_newspapers"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumBooksPeriodicalsAndNewspapers
  | -- | Represents the JSON value @"bowling_alleys"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumBowlingAlleys
  | -- | Represents the JSON value @"bus_lines"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumBusLines
  | -- | Represents the JSON value @"business_secretarial_schools"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumBusinessSecretarialSchools
  | -- | Represents the JSON value @"buying_shopping_services"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumBuyingShoppingServices
  | -- | Represents the JSON value @"cable_satellite_and_other_pay_television_and_radio"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumCableSatelliteAndOtherPayTelevisionAndRadio
  | -- | Represents the JSON value @"camera_and_photographic_supply_stores"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumCameraAndPhotographicSupplyStores
  | -- | Represents the JSON value @"candy_nut_and_confectionery_stores"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumCandyNutAndConfectioneryStores
  | -- | Represents the JSON value @"car_and_truck_dealers_new_used"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumCarAndTruckDealersNewUsed
  | -- | Represents the JSON value @"car_and_truck_dealers_used_only"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumCarAndTruckDealersUsedOnly
  | -- | Represents the JSON value @"car_rental_agencies"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumCarRentalAgencies
  | -- | Represents the JSON value @"car_washes"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumCarWashes
  | -- | Represents the JSON value @"carpentry_services"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumCarpentryServices
  | -- | Represents the JSON value @"carpet_upholstery_cleaning"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumCarpetUpholsteryCleaning
  | -- | Represents the JSON value @"caterers"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumCaterers
  | -- | Represents the JSON value @"charitable_and_social_service_organizations_fundraising"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumCharitableAndSocialServiceOrganizationsFundraising
  | -- | Represents the JSON value @"chemicals_and_allied_products"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumChemicalsAndAlliedProducts
  | -- | Represents the JSON value @"child_care_services"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumChildCareServices
  | -- | Represents the JSON value @"childrens_and_infants_wear_stores"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumChildrensAndInfantsWearStores
  | -- | Represents the JSON value @"chiropodists_podiatrists"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumChiropodistsPodiatrists
  | -- | Represents the JSON value @"chiropractors"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumChiropractors
  | -- | Represents the JSON value @"cigar_stores_and_stands"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumCigarStoresAndStands
  | -- | Represents the JSON value @"civic_social_fraternal_associations"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumCivicSocialFraternalAssociations
  | -- | Represents the JSON value @"cleaning_and_maintenance"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumCleaningAndMaintenance
  | -- | Represents the JSON value @"clothing_rental"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumClothingRental
  | -- | Represents the JSON value @"colleges_universities"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumCollegesUniversities
  | -- | Represents the JSON value @"commercial_equipment"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumCommercialEquipment
  | -- | Represents the JSON value @"commercial_footwear"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumCommercialFootwear
  | -- | Represents the JSON value @"commercial_photography_art_and_graphics"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumCommercialPhotographyArtAndGraphics
  | -- | Represents the JSON value @"commuter_transport_and_ferries"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumCommuterTransportAndFerries
  | -- | Represents the JSON value @"computer_network_services"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumComputerNetworkServices
  | -- | Represents the JSON value @"computer_programming"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumComputerProgramming
  | -- | Represents the JSON value @"computer_repair"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumComputerRepair
  | -- | Represents the JSON value @"computer_software_stores"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumComputerSoftwareStores
  | -- | Represents the JSON value @"computers_peripherals_and_software"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumComputersPeripheralsAndSoftware
  | -- | Represents the JSON value @"concrete_work_services"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumConcreteWorkServices
  | -- | Represents the JSON value @"construction_materials"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumConstructionMaterials
  | -- | Represents the JSON value @"consulting_public_relations"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumConsultingPublicRelations
  | -- | Represents the JSON value @"correspondence_schools"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumCorrespondenceSchools
  | -- | Represents the JSON value @"cosmetic_stores"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumCosmeticStores
  | -- | Represents the JSON value @"counseling_services"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumCounselingServices
  | -- | Represents the JSON value @"country_clubs"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumCountryClubs
  | -- | Represents the JSON value @"courier_services"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumCourierServices
  | -- | Represents the JSON value @"court_costs"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumCourtCosts
  | -- | Represents the JSON value @"credit_reporting_agencies"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumCreditReportingAgencies
  | -- | Represents the JSON value @"cruise_lines"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumCruiseLines
  | -- | Represents the JSON value @"dairy_products_stores"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumDairyProductsStores
  | -- | Represents the JSON value @"dance_hall_studios_schools"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumDanceHallStudiosSchools
  | -- | Represents the JSON value @"dating_escort_services"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumDatingEscortServices
  | -- | Represents the JSON value @"dentists_orthodontists"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumDentistsOrthodontists
  | -- | Represents the JSON value @"department_stores"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumDepartmentStores
  | -- | Represents the JSON value @"detective_agencies"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumDetectiveAgencies
  | -- | Represents the JSON value @"digital_goods_applications"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumDigitalGoodsApplications
  | -- | Represents the JSON value @"digital_goods_games"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumDigitalGoodsGames
  | -- | Represents the JSON value @"digital_goods_large_volume"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumDigitalGoodsLargeVolume
  | -- | Represents the JSON value @"digital_goods_media"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumDigitalGoodsMedia
  | -- | Represents the JSON value @"direct_marketing_catalog_merchant"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumDirectMarketingCatalogMerchant
  | -- | Represents the JSON value @"direct_marketing_combination_catalog_and_retail_merchant"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumDirectMarketingCombinationCatalogAndRetailMerchant
  | -- | Represents the JSON value @"direct_marketing_inbound_telemarketing"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumDirectMarketingInboundTelemarketing
  | -- | Represents the JSON value @"direct_marketing_insurance_services"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumDirectMarketingInsuranceServices
  | -- | Represents the JSON value @"direct_marketing_other"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumDirectMarketingOther
  | -- | Represents the JSON value @"direct_marketing_outbound_telemarketing"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumDirectMarketingOutboundTelemarketing
  | -- | Represents the JSON value @"direct_marketing_subscription"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumDirectMarketingSubscription
  | -- | Represents the JSON value @"direct_marketing_travel"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumDirectMarketingTravel
  | -- | Represents the JSON value @"discount_stores"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumDiscountStores
  | -- | Represents the JSON value @"doctors"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumDoctors
  | -- | Represents the JSON value @"door_to_door_sales"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumDoorToDoorSales
  | -- | Represents the JSON value @"drapery_window_covering_and_upholstery_stores"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumDraperyWindowCoveringAndUpholsteryStores
  | -- | Represents the JSON value @"drinking_places"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumDrinkingPlaces
  | -- | Represents the JSON value @"drug_stores_and_pharmacies"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumDrugStoresAndPharmacies
  | -- | Represents the JSON value @"drugs_drug_proprietaries_and_druggist_sundries"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumDrugsDrugProprietariesAndDruggistSundries
  | -- | Represents the JSON value @"dry_cleaners"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumDryCleaners
  | -- | Represents the JSON value @"durable_goods"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumDurableGoods
  | -- | Represents the JSON value @"duty_free_stores"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumDutyFreeStores
  | -- | Represents the JSON value @"eating_places_restaurants"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumEatingPlacesRestaurants
  | -- | Represents the JSON value @"educational_services"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumEducationalServices
  | -- | Represents the JSON value @"electric_razor_stores"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumElectricRazorStores
  | -- | Represents the JSON value @"electrical_parts_and_equipment"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumElectricalPartsAndEquipment
  | -- | Represents the JSON value @"electrical_services"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumElectricalServices
  | -- | Represents the JSON value @"electronics_repair_shops"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumElectronicsRepairShops
  | -- | Represents the JSON value @"electronics_stores"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumElectronicsStores
  | -- | Represents the JSON value @"elementary_secondary_schools"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumElementarySecondarySchools
  | -- | Represents the JSON value @"employment_temp_agencies"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumEmploymentTempAgencies
  | -- | Represents the JSON value @"equipment_rental"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumEquipmentRental
  | -- | Represents the JSON value @"exterminating_services"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumExterminatingServices
  | -- | Represents the JSON value @"family_clothing_stores"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumFamilyClothingStores
  | -- | Represents the JSON value @"fast_food_restaurants"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumFastFoodRestaurants
  | -- | Represents the JSON value @"financial_institutions"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumFinancialInstitutions
  | -- | Represents the JSON value @"fines_government_administrative_entities"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumFinesGovernmentAdministrativeEntities
  | -- | Represents the JSON value @"fireplace_fireplace_screens_and_accessories_stores"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumFireplaceFireplaceScreensAndAccessoriesStores
  | -- | Represents the JSON value @"floor_covering_stores"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumFloorCoveringStores
  | -- | Represents the JSON value @"florists"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumFlorists
  | -- | Represents the JSON value @"florists_supplies_nursery_stock_and_flowers"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumFloristsSuppliesNurseryStockAndFlowers
  | -- | Represents the JSON value @"freezer_and_locker_meat_provisioners"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumFreezerAndLockerMeatProvisioners
  | -- | Represents the JSON value @"fuel_dealers_non_automotive"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumFuelDealersNonAutomotive
  | -- | Represents the JSON value @"funeral_services_crematories"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumFuneralServicesCrematories
  | -- | Represents the JSON value @"furniture_home_furnishings_and_equipment_stores_except_appliances"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumFurnitureHomeFurnishingsAndEquipmentStoresExceptAppliances
  | -- | Represents the JSON value @"furniture_repair_refinishing"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumFurnitureRepairRefinishing
  | -- | Represents the JSON value @"furriers_and_fur_shops"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumFurriersAndFurShops
  | -- | Represents the JSON value @"general_services"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumGeneralServices
  | -- | Represents the JSON value @"gift_card_novelty_and_souvenir_shops"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumGiftCardNoveltyAndSouvenirShops
  | -- | Represents the JSON value @"glass_paint_and_wallpaper_stores"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumGlassPaintAndWallpaperStores
  | -- | Represents the JSON value @"glassware_crystal_stores"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumGlasswareCrystalStores
  | -- | Represents the JSON value @"golf_courses_public"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumGolfCoursesPublic
  | -- | Represents the JSON value @"government_services"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumGovernmentServices
  | -- | Represents the JSON value @"grocery_stores_supermarkets"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumGroceryStoresSupermarkets
  | -- | Represents the JSON value @"hardware_equipment_and_supplies"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumHardwareEquipmentAndSupplies
  | -- | Represents the JSON value @"hardware_stores"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumHardwareStores
  | -- | Represents the JSON value @"health_and_beauty_spas"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumHealthAndBeautySpas
  | -- | Represents the JSON value @"hearing_aids_sales_and_supplies"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumHearingAidsSalesAndSupplies
  | -- | Represents the JSON value @"heating_plumbing_a_c"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumHeatingPlumbingAC
  | -- | Represents the JSON value @"hobby_toy_and_game_shops"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumHobbyToyAndGameShops
  | -- | Represents the JSON value @"home_supply_warehouse_stores"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumHomeSupplyWarehouseStores
  | -- | Represents the JSON value @"hospitals"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumHospitals
  | -- | Represents the JSON value @"hotels_motels_and_resorts"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumHotelsMotelsAndResorts
  | -- | Represents the JSON value @"household_appliance_stores"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumHouseholdApplianceStores
  | -- | Represents the JSON value @"industrial_supplies"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumIndustrialSupplies
  | -- | Represents the JSON value @"information_retrieval_services"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumInformationRetrievalServices
  | -- | Represents the JSON value @"insurance_default"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumInsuranceDefault
  | -- | Represents the JSON value @"insurance_underwriting_premiums"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumInsuranceUnderwritingPremiums
  | -- | Represents the JSON value @"intra_company_purchases"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumIntraCompanyPurchases
  | -- | Represents the JSON value @"jewelry_stores_watches_clocks_and_silverware_stores"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumJewelryStoresWatchesClocksAndSilverwareStores
  | -- | Represents the JSON value @"landscaping_services"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumLandscapingServices
  | -- | Represents the JSON value @"laundries"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumLaundries
  | -- | Represents the JSON value @"laundry_cleaning_services"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumLaundryCleaningServices
  | -- | Represents the JSON value @"legal_services_attorneys"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumLegalServicesAttorneys
  | -- | Represents the JSON value @"luggage_and_leather_goods_stores"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumLuggageAndLeatherGoodsStores
  | -- | Represents the JSON value @"lumber_building_materials_stores"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumLumberBuildingMaterialsStores
  | -- | Represents the JSON value @"manual_cash_disburse"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumManualCashDisburse
  | -- | Represents the JSON value @"marinas_service_and_supplies"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumMarinasServiceAndSupplies
  | -- | Represents the JSON value @"masonry_stonework_and_plaster"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumMasonryStoneworkAndPlaster
  | -- | Represents the JSON value @"massage_parlors"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumMassageParlors
  | -- | Represents the JSON value @"medical_and_dental_labs"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumMedicalAndDentalLabs
  | -- | Represents the JSON value @"medical_dental_ophthalmic_and_hospital_equipment_and_supplies"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumMedicalDentalOphthalmicAndHospitalEquipmentAndSupplies
  | -- | Represents the JSON value @"medical_services"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumMedicalServices
  | -- | Represents the JSON value @"membership_organizations"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumMembershipOrganizations
  | -- | Represents the JSON value @"mens_and_boys_clothing_and_accessories_stores"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumMensAndBoysClothingAndAccessoriesStores
  | -- | Represents the JSON value @"mens_womens_clothing_stores"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumMensWomensClothingStores
  | -- | Represents the JSON value @"metal_service_centers"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumMetalServiceCenters
  | -- | Represents the JSON value @"miscellaneous"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumMiscellaneous
  | -- | Represents the JSON value @"miscellaneous_apparel_and_accessory_shops"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumMiscellaneousApparelAndAccessoryShops
  | -- | Represents the JSON value @"miscellaneous_auto_dealers"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumMiscellaneousAutoDealers
  | -- | Represents the JSON value @"miscellaneous_business_services"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumMiscellaneousBusinessServices
  | -- | Represents the JSON value @"miscellaneous_food_stores"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumMiscellaneousFoodStores
  | -- | Represents the JSON value @"miscellaneous_general_merchandise"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumMiscellaneousGeneralMerchandise
  | -- | Represents the JSON value @"miscellaneous_general_services"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumMiscellaneousGeneralServices
  | -- | Represents the JSON value @"miscellaneous_home_furnishing_specialty_stores"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumMiscellaneousHomeFurnishingSpecialtyStores
  | -- | Represents the JSON value @"miscellaneous_publishing_and_printing"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumMiscellaneousPublishingAndPrinting
  | -- | Represents the JSON value @"miscellaneous_recreation_services"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumMiscellaneousRecreationServices
  | -- | Represents the JSON value @"miscellaneous_repair_shops"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumMiscellaneousRepairShops
  | -- | Represents the JSON value @"miscellaneous_specialty_retail"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumMiscellaneousSpecialtyRetail
  | -- | Represents the JSON value @"mobile_home_dealers"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumMobileHomeDealers
  | -- | Represents the JSON value @"motion_picture_theaters"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumMotionPictureTheaters
  | -- | Represents the JSON value @"motor_freight_carriers_and_trucking"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumMotorFreightCarriersAndTrucking
  | -- | Represents the JSON value @"motor_homes_dealers"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumMotorHomesDealers
  | -- | Represents the JSON value @"motor_vehicle_supplies_and_new_parts"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumMotorVehicleSuppliesAndNewParts
  | -- | Represents the JSON value @"motorcycle_shops_and_dealers"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumMotorcycleShopsAndDealers
  | -- | Represents the JSON value @"motorcycle_shops_dealers"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumMotorcycleShopsDealers
  | -- | Represents the JSON value @"music_stores_musical_instruments_pianos_and_sheet_music"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumMusicStoresMusicalInstrumentsPianosAndSheetMusic
  | -- | Represents the JSON value @"news_dealers_and_newsstands"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumNewsDealersAndNewsstands
  | -- | Represents the JSON value @"non_fi_money_orders"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumNonFiMoneyOrders
  | -- | Represents the JSON value @"non_fi_stored_value_card_purchase_load"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumNonFiStoredValueCardPurchaseLoad
  | -- | Represents the JSON value @"nondurable_goods"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumNondurableGoods
  | -- | Represents the JSON value @"nurseries_lawn_and_garden_supply_stores"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumNurseriesLawnAndGardenSupplyStores
  | -- | Represents the JSON value @"nursing_personal_care"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumNursingPersonalCare
  | -- | Represents the JSON value @"office_and_commercial_furniture"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumOfficeAndCommercialFurniture
  | -- | Represents the JSON value @"opticians_eyeglasses"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumOpticiansEyeglasses
  | -- | Represents the JSON value @"optometrists_ophthalmologist"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumOptometristsOphthalmologist
  | -- | Represents the JSON value @"orthopedic_goods_prosthetic_devices"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumOrthopedicGoodsProstheticDevices
  | -- | Represents the JSON value @"osteopaths"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumOsteopaths
  | -- | Represents the JSON value @"package_stores_beer_wine_and_liquor"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumPackageStoresBeerWineAndLiquor
  | -- | Represents the JSON value @"paints_varnishes_and_supplies"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumPaintsVarnishesAndSupplies
  | -- | Represents the JSON value @"parking_lots_garages"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumParkingLotsGarages
  | -- | Represents the JSON value @"passenger_railways"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumPassengerRailways
  | -- | Represents the JSON value @"pawn_shops"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumPawnShops
  | -- | Represents the JSON value @"pet_shops_pet_food_and_supplies"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumPetShopsPetFoodAndSupplies
  | -- | Represents the JSON value @"petroleum_and_petroleum_products"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumPetroleumAndPetroleumProducts
  | -- | Represents the JSON value @"photo_developing"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumPhotoDeveloping
  | -- | Represents the JSON value @"photographic_photocopy_microfilm_equipment_and_supplies"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumPhotographicPhotocopyMicrofilmEquipmentAndSupplies
  | -- | Represents the JSON value @"photographic_studios"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumPhotographicStudios
  | -- | Represents the JSON value @"picture_video_production"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumPictureVideoProduction
  | -- | Represents the JSON value @"piece_goods_notions_and_other_dry_goods"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumPieceGoodsNotionsAndOtherDryGoods
  | -- | Represents the JSON value @"plumbing_heating_equipment_and_supplies"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumPlumbingHeatingEquipmentAndSupplies
  | -- | Represents the JSON value @"political_organizations"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumPoliticalOrganizations
  | -- | Represents the JSON value @"postal_services_government_only"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumPostalServicesGovernmentOnly
  | -- | Represents the JSON value @"precious_stones_and_metals_watches_and_jewelry"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumPreciousStonesAndMetalsWatchesAndJewelry
  | -- | Represents the JSON value @"professional_services"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumProfessionalServices
  | -- | Represents the JSON value @"public_warehousing_and_storage"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumPublicWarehousingAndStorage
  | -- | Represents the JSON value @"quick_copy_repro_and_blueprint"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumQuickCopyReproAndBlueprint
  | -- | Represents the JSON value @"railroads"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumRailroads
  | -- | Represents the JSON value @"real_estate_agents_and_managers_rentals"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumRealEstateAgentsAndManagersRentals
  | -- | Represents the JSON value @"record_stores"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumRecordStores
  | -- | Represents the JSON value @"recreational_vehicle_rentals"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumRecreationalVehicleRentals
  | -- | Represents the JSON value @"religious_goods_stores"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumReligiousGoodsStores
  | -- | Represents the JSON value @"religious_organizations"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumReligiousOrganizations
  | -- | Represents the JSON value @"roofing_siding_sheet_metal"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumRoofingSidingSheetMetal
  | -- | Represents the JSON value @"secretarial_support_services"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumSecretarialSupportServices
  | -- | Represents the JSON value @"security_brokers_dealers"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumSecurityBrokersDealers
  | -- | Represents the JSON value @"service_stations"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumServiceStations
  | -- | Represents the JSON value @"sewing_needlework_fabric_and_piece_goods_stores"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumSewingNeedleworkFabricAndPieceGoodsStores
  | -- | Represents the JSON value @"shoe_repair_hat_cleaning"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumShoeRepairHatCleaning
  | -- | Represents the JSON value @"shoe_stores"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumShoeStores
  | -- | Represents the JSON value @"small_appliance_repair"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumSmallApplianceRepair
  | -- | Represents the JSON value @"snowmobile_dealers"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumSnowmobileDealers
  | -- | Represents the JSON value @"special_trade_services"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumSpecialTradeServices
  | -- | Represents the JSON value @"specialty_cleaning"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumSpecialtyCleaning
  | -- | Represents the JSON value @"sporting_goods_stores"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumSportingGoodsStores
  | -- | Represents the JSON value @"sporting_recreation_camps"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumSportingRecreationCamps
  | -- | Represents the JSON value @"sports_and_riding_apparel_stores"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumSportsAndRidingApparelStores
  | -- | Represents the JSON value @"sports_clubs_fields"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumSportsClubsFields
  | -- | Represents the JSON value @"stamp_and_coin_stores"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumStampAndCoinStores
  | -- | Represents the JSON value @"stationary_office_supplies_printing_and_writing_paper"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumStationaryOfficeSuppliesPrintingAndWritingPaper
  | -- | Represents the JSON value @"stationery_stores_office_and_school_supply_stores"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumStationeryStoresOfficeAndSchoolSupplyStores
  | -- | Represents the JSON value @"swimming_pools_sales"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumSwimmingPoolsSales
  | -- | Represents the JSON value @"t_ui_travel_germany"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumTUiTravelGermany
  | -- | Represents the JSON value @"tailors_alterations"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumTailorsAlterations
  | -- | Represents the JSON value @"tax_payments_government_agencies"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumTaxPaymentsGovernmentAgencies
  | -- | Represents the JSON value @"tax_preparation_services"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumTaxPreparationServices
  | -- | Represents the JSON value @"taxicabs_limousines"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumTaxicabsLimousines
  | -- | Represents the JSON value @"telecommunication_equipment_and_telephone_sales"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumTelecommunicationEquipmentAndTelephoneSales
  | -- | Represents the JSON value @"telecommunication_services"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumTelecommunicationServices
  | -- | Represents the JSON value @"telegraph_services"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumTelegraphServices
  | -- | Represents the JSON value @"tent_and_awning_shops"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumTentAndAwningShops
  | -- | Represents the JSON value @"testing_laboratories"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumTestingLaboratories
  | -- | Represents the JSON value @"theatrical_ticket_agencies"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumTheatricalTicketAgencies
  | -- | Represents the JSON value @"timeshares"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumTimeshares
  | -- | Represents the JSON value @"tire_retreading_and_repair"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumTireRetreadingAndRepair
  | -- | Represents the JSON value @"tolls_bridge_fees"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumTollsBridgeFees
  | -- | Represents the JSON value @"tourist_attractions_and_exhibits"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumTouristAttractionsAndExhibits
  | -- | Represents the JSON value @"towing_services"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumTowingServices
  | -- | Represents the JSON value @"trailer_parks_campgrounds"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumTrailerParksCampgrounds
  | -- | Represents the JSON value @"transportation_services"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumTransportationServices
  | -- | Represents the JSON value @"travel_agencies_tour_operators"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumTravelAgenciesTourOperators
  | -- | Represents the JSON value @"truck_stop_iteration"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumTruckStopIteration
  | -- | Represents the JSON value @"truck_utility_trailer_rentals"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumTruckUtilityTrailerRentals
  | -- | Represents the JSON value @"typesetting_plate_making_and_related_services"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumTypesettingPlateMakingAndRelatedServices
  | -- | Represents the JSON value @"typewriter_stores"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumTypewriterStores
  | -- | Represents the JSON value @"u_s_federal_government_agencies_or_departments"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumUSFederalGovernmentAgenciesOrDepartments
  | -- | Represents the JSON value @"uniforms_commercial_clothing"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumUniformsCommercialClothing
  | -- | Represents the JSON value @"used_merchandise_and_secondhand_stores"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumUsedMerchandiseAndSecondhandStores
  | -- | Represents the JSON value @"utilities"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumUtilities
  | -- | Represents the JSON value @"variety_stores"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumVarietyStores
  | -- | Represents the JSON value @"veterinary_services"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumVeterinaryServices
  | -- | Represents the JSON value @"video_amusement_game_supplies"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumVideoAmusementGameSupplies
  | -- | Represents the JSON value @"video_game_arcades"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumVideoGameArcades
  | -- | Represents the JSON value @"video_tape_rental_stores"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumVideoTapeRentalStores
  | -- | Represents the JSON value @"vocational_trade_schools"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumVocationalTradeSchools
  | -- | Represents the JSON value @"watch_jewelry_repair"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumWatchJewelryRepair
  | -- | Represents the JSON value @"welding_repair"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumWeldingRepair
  | -- | Represents the JSON value @"wholesale_clubs"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumWholesaleClubs
  | -- | Represents the JSON value @"wig_and_toupee_stores"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumWigAndToupeeStores
  | -- | Represents the JSON value @"wires_money_orders"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumWiresMoneyOrders
  | -- | Represents the JSON value @"womens_accessory_and_specialty_shops"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumWomensAccessoryAndSpecialtyShops
  | -- | Represents the JSON value @"womens_ready_to_wear_stores"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumWomensReadyToWearStores
  | -- | Represents the JSON value @"wrecking_and_salvage_yards"@
    Issuing'cardholderSpendingControls'AllowedCategories'EnumWreckingAndSalvageYards
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON Issuing'cardholderSpendingControls'AllowedCategories' where
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'Other val) = val
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'Typed val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumAcRefrigerationRepair) = "ac_refrigeration_repair"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumAccountingBookkeepingServices) = "accounting_bookkeeping_services"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumAdvertisingServices) = "advertising_services"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumAgriculturalCooperative) = "agricultural_cooperative"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumAirlinesAirCarriers) = "airlines_air_carriers"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumAirportsFlyingFields) = "airports_flying_fields"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumAmbulanceServices) = "ambulance_services"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumAmusementParksCarnivals) = "amusement_parks_carnivals"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumAntiqueReproductions) = "antique_reproductions"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumAntiqueShops) = "antique_shops"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumAquariums) = "aquariums"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumArchitecturalSurveyingServices) = "architectural_surveying_services"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumArtDealersAndGalleries) = "art_dealers_and_galleries"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumArtistsSupplyAndCraftShops) = "artists_supply_and_craft_shops"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumAutoAndHomeSupplyStores) = "auto_and_home_supply_stores"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumAutoBodyRepairShops) = "auto_body_repair_shops"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumAutoPaintShops) = "auto_paint_shops"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumAutoServiceShops) = "auto_service_shops"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumAutomatedCashDisburse) = "automated_cash_disburse"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumAutomatedFuelDispensers) = "automated_fuel_dispensers"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumAutomobileAssociations) = "automobile_associations"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumAutomotivePartsAndAccessoriesStores) = "automotive_parts_and_accessories_stores"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumAutomotiveTireStores) = "automotive_tire_stores"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumBailAndBondPayments) = "bail_and_bond_payments"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumBakeries) = "bakeries"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumBandsOrchestras) = "bands_orchestras"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumBarberAndBeautyShops) = "barber_and_beauty_shops"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumBettingCasinoGambling) = "betting_casino_gambling"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumBicycleShops) = "bicycle_shops"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumBilliardPoolEstablishments) = "billiard_pool_establishments"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumBoatDealers) = "boat_dealers"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumBoatRentalsAndLeases) = "boat_rentals_and_leases"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumBookStores) = "book_stores"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumBooksPeriodicalsAndNewspapers) = "books_periodicals_and_newspapers"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumBowlingAlleys) = "bowling_alleys"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumBusLines) = "bus_lines"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumBusinessSecretarialSchools) = "business_secretarial_schools"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumBuyingShoppingServices) = "buying_shopping_services"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumCableSatelliteAndOtherPayTelevisionAndRadio) = "cable_satellite_and_other_pay_television_and_radio"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumCameraAndPhotographicSupplyStores) = "camera_and_photographic_supply_stores"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumCandyNutAndConfectioneryStores) = "candy_nut_and_confectionery_stores"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumCarAndTruckDealersNewUsed) = "car_and_truck_dealers_new_used"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumCarAndTruckDealersUsedOnly) = "car_and_truck_dealers_used_only"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumCarRentalAgencies) = "car_rental_agencies"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumCarWashes) = "car_washes"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumCarpentryServices) = "carpentry_services"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumCarpetUpholsteryCleaning) = "carpet_upholstery_cleaning"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumCaterers) = "caterers"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumCharitableAndSocialServiceOrganizationsFundraising) = "charitable_and_social_service_organizations_fundraising"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumChemicalsAndAlliedProducts) = "chemicals_and_allied_products"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumChildCareServices) = "child_care_services"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumChildrensAndInfantsWearStores) = "childrens_and_infants_wear_stores"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumChiropodistsPodiatrists) = "chiropodists_podiatrists"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumChiropractors) = "chiropractors"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumCigarStoresAndStands) = "cigar_stores_and_stands"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumCivicSocialFraternalAssociations) = "civic_social_fraternal_associations"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumCleaningAndMaintenance) = "cleaning_and_maintenance"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumClothingRental) = "clothing_rental"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumCollegesUniversities) = "colleges_universities"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumCommercialEquipment) = "commercial_equipment"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumCommercialFootwear) = "commercial_footwear"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumCommercialPhotographyArtAndGraphics) = "commercial_photography_art_and_graphics"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumCommuterTransportAndFerries) = "commuter_transport_and_ferries"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumComputerNetworkServices) = "computer_network_services"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumComputerProgramming) = "computer_programming"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumComputerRepair) = "computer_repair"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumComputerSoftwareStores) = "computer_software_stores"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumComputersPeripheralsAndSoftware) = "computers_peripherals_and_software"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumConcreteWorkServices) = "concrete_work_services"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumConstructionMaterials) = "construction_materials"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumConsultingPublicRelations) = "consulting_public_relations"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumCorrespondenceSchools) = "correspondence_schools"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumCosmeticStores) = "cosmetic_stores"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumCounselingServices) = "counseling_services"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumCountryClubs) = "country_clubs"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumCourierServices) = "courier_services"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumCourtCosts) = "court_costs"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumCreditReportingAgencies) = "credit_reporting_agencies"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumCruiseLines) = "cruise_lines"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumDairyProductsStores) = "dairy_products_stores"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumDanceHallStudiosSchools) = "dance_hall_studios_schools"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumDatingEscortServices) = "dating_escort_services"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumDentistsOrthodontists) = "dentists_orthodontists"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumDepartmentStores) = "department_stores"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumDetectiveAgencies) = "detective_agencies"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumDigitalGoodsApplications) = "digital_goods_applications"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumDigitalGoodsGames) = "digital_goods_games"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumDigitalGoodsLargeVolume) = "digital_goods_large_volume"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumDigitalGoodsMedia) = "digital_goods_media"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumDirectMarketingCatalogMerchant) = "direct_marketing_catalog_merchant"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumDirectMarketingCombinationCatalogAndRetailMerchant) = "direct_marketing_combination_catalog_and_retail_merchant"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumDirectMarketingInboundTelemarketing) = "direct_marketing_inbound_telemarketing"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumDirectMarketingInsuranceServices) = "direct_marketing_insurance_services"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumDirectMarketingOther) = "direct_marketing_other"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumDirectMarketingOutboundTelemarketing) = "direct_marketing_outbound_telemarketing"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumDirectMarketingSubscription) = "direct_marketing_subscription"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumDirectMarketingTravel) = "direct_marketing_travel"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumDiscountStores) = "discount_stores"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumDoctors) = "doctors"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumDoorToDoorSales) = "door_to_door_sales"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumDraperyWindowCoveringAndUpholsteryStores) = "drapery_window_covering_and_upholstery_stores"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumDrinkingPlaces) = "drinking_places"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumDrugStoresAndPharmacies) = "drug_stores_and_pharmacies"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumDrugsDrugProprietariesAndDruggistSundries) = "drugs_drug_proprietaries_and_druggist_sundries"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumDryCleaners) = "dry_cleaners"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumDurableGoods) = "durable_goods"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumDutyFreeStores) = "duty_free_stores"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumEatingPlacesRestaurants) = "eating_places_restaurants"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumEducationalServices) = "educational_services"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumElectricRazorStores) = "electric_razor_stores"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumElectricalPartsAndEquipment) = "electrical_parts_and_equipment"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumElectricalServices) = "electrical_services"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumElectronicsRepairShops) = "electronics_repair_shops"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumElectronicsStores) = "electronics_stores"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumElementarySecondarySchools) = "elementary_secondary_schools"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumEmploymentTempAgencies) = "employment_temp_agencies"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumEquipmentRental) = "equipment_rental"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumExterminatingServices) = "exterminating_services"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumFamilyClothingStores) = "family_clothing_stores"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumFastFoodRestaurants) = "fast_food_restaurants"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumFinancialInstitutions) = "financial_institutions"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumFinesGovernmentAdministrativeEntities) = "fines_government_administrative_entities"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumFireplaceFireplaceScreensAndAccessoriesStores) = "fireplace_fireplace_screens_and_accessories_stores"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumFloorCoveringStores) = "floor_covering_stores"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumFlorists) = "florists"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumFloristsSuppliesNurseryStockAndFlowers) = "florists_supplies_nursery_stock_and_flowers"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumFreezerAndLockerMeatProvisioners) = "freezer_and_locker_meat_provisioners"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumFuelDealersNonAutomotive) = "fuel_dealers_non_automotive"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumFuneralServicesCrematories) = "funeral_services_crematories"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumFurnitureHomeFurnishingsAndEquipmentStoresExceptAppliances) = "furniture_home_furnishings_and_equipment_stores_except_appliances"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumFurnitureRepairRefinishing) = "furniture_repair_refinishing"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumFurriersAndFurShops) = "furriers_and_fur_shops"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumGeneralServices) = "general_services"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumGiftCardNoveltyAndSouvenirShops) = "gift_card_novelty_and_souvenir_shops"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumGlassPaintAndWallpaperStores) = "glass_paint_and_wallpaper_stores"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumGlasswareCrystalStores) = "glassware_crystal_stores"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumGolfCoursesPublic) = "golf_courses_public"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumGovernmentServices) = "government_services"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumGroceryStoresSupermarkets) = "grocery_stores_supermarkets"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumHardwareEquipmentAndSupplies) = "hardware_equipment_and_supplies"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumHardwareStores) = "hardware_stores"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumHealthAndBeautySpas) = "health_and_beauty_spas"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumHearingAidsSalesAndSupplies) = "hearing_aids_sales_and_supplies"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumHeatingPlumbingAC) = "heating_plumbing_a_c"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumHobbyToyAndGameShops) = "hobby_toy_and_game_shops"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumHomeSupplyWarehouseStores) = "home_supply_warehouse_stores"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumHospitals) = "hospitals"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumHotelsMotelsAndResorts) = "hotels_motels_and_resorts"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumHouseholdApplianceStores) = "household_appliance_stores"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumIndustrialSupplies) = "industrial_supplies"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumInformationRetrievalServices) = "information_retrieval_services"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumInsuranceDefault) = "insurance_default"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumInsuranceUnderwritingPremiums) = "insurance_underwriting_premiums"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumIntraCompanyPurchases) = "intra_company_purchases"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumJewelryStoresWatchesClocksAndSilverwareStores) = "jewelry_stores_watches_clocks_and_silverware_stores"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumLandscapingServices) = "landscaping_services"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumLaundries) = "laundries"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumLaundryCleaningServices) = "laundry_cleaning_services"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumLegalServicesAttorneys) = "legal_services_attorneys"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumLuggageAndLeatherGoodsStores) = "luggage_and_leather_goods_stores"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumLumberBuildingMaterialsStores) = "lumber_building_materials_stores"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumManualCashDisburse) = "manual_cash_disburse"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumMarinasServiceAndSupplies) = "marinas_service_and_supplies"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumMasonryStoneworkAndPlaster) = "masonry_stonework_and_plaster"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumMassageParlors) = "massage_parlors"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumMedicalAndDentalLabs) = "medical_and_dental_labs"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumMedicalDentalOphthalmicAndHospitalEquipmentAndSupplies) = "medical_dental_ophthalmic_and_hospital_equipment_and_supplies"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumMedicalServices) = "medical_services"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumMembershipOrganizations) = "membership_organizations"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumMensAndBoysClothingAndAccessoriesStores) = "mens_and_boys_clothing_and_accessories_stores"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumMensWomensClothingStores) = "mens_womens_clothing_stores"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumMetalServiceCenters) = "metal_service_centers"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumMiscellaneous) = "miscellaneous"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumMiscellaneousApparelAndAccessoryShops) = "miscellaneous_apparel_and_accessory_shops"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumMiscellaneousAutoDealers) = "miscellaneous_auto_dealers"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumMiscellaneousBusinessServices) = "miscellaneous_business_services"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumMiscellaneousFoodStores) = "miscellaneous_food_stores"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumMiscellaneousGeneralMerchandise) = "miscellaneous_general_merchandise"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumMiscellaneousGeneralServices) = "miscellaneous_general_services"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumMiscellaneousHomeFurnishingSpecialtyStores) = "miscellaneous_home_furnishing_specialty_stores"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumMiscellaneousPublishingAndPrinting) = "miscellaneous_publishing_and_printing"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumMiscellaneousRecreationServices) = "miscellaneous_recreation_services"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumMiscellaneousRepairShops) = "miscellaneous_repair_shops"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumMiscellaneousSpecialtyRetail) = "miscellaneous_specialty_retail"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumMobileHomeDealers) = "mobile_home_dealers"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumMotionPictureTheaters) = "motion_picture_theaters"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumMotorFreightCarriersAndTrucking) = "motor_freight_carriers_and_trucking"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumMotorHomesDealers) = "motor_homes_dealers"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumMotorVehicleSuppliesAndNewParts) = "motor_vehicle_supplies_and_new_parts"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumMotorcycleShopsAndDealers) = "motorcycle_shops_and_dealers"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumMotorcycleShopsDealers) = "motorcycle_shops_dealers"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumMusicStoresMusicalInstrumentsPianosAndSheetMusic) = "music_stores_musical_instruments_pianos_and_sheet_music"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumNewsDealersAndNewsstands) = "news_dealers_and_newsstands"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumNonFiMoneyOrders) = "non_fi_money_orders"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumNonFiStoredValueCardPurchaseLoad) = "non_fi_stored_value_card_purchase_load"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumNondurableGoods) = "nondurable_goods"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumNurseriesLawnAndGardenSupplyStores) = "nurseries_lawn_and_garden_supply_stores"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumNursingPersonalCare) = "nursing_personal_care"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumOfficeAndCommercialFurniture) = "office_and_commercial_furniture"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumOpticiansEyeglasses) = "opticians_eyeglasses"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumOptometristsOphthalmologist) = "optometrists_ophthalmologist"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumOrthopedicGoodsProstheticDevices) = "orthopedic_goods_prosthetic_devices"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumOsteopaths) = "osteopaths"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumPackageStoresBeerWineAndLiquor) = "package_stores_beer_wine_and_liquor"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumPaintsVarnishesAndSupplies) = "paints_varnishes_and_supplies"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumParkingLotsGarages) = "parking_lots_garages"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumPassengerRailways) = "passenger_railways"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumPawnShops) = "pawn_shops"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumPetShopsPetFoodAndSupplies) = "pet_shops_pet_food_and_supplies"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumPetroleumAndPetroleumProducts) = "petroleum_and_petroleum_products"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumPhotoDeveloping) = "photo_developing"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumPhotographicPhotocopyMicrofilmEquipmentAndSupplies) = "photographic_photocopy_microfilm_equipment_and_supplies"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumPhotographicStudios) = "photographic_studios"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumPictureVideoProduction) = "picture_video_production"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumPieceGoodsNotionsAndOtherDryGoods) = "piece_goods_notions_and_other_dry_goods"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumPlumbingHeatingEquipmentAndSupplies) = "plumbing_heating_equipment_and_supplies"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumPoliticalOrganizations) = "political_organizations"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumPostalServicesGovernmentOnly) = "postal_services_government_only"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumPreciousStonesAndMetalsWatchesAndJewelry) = "precious_stones_and_metals_watches_and_jewelry"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumProfessionalServices) = "professional_services"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumPublicWarehousingAndStorage) = "public_warehousing_and_storage"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumQuickCopyReproAndBlueprint) = "quick_copy_repro_and_blueprint"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumRailroads) = "railroads"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumRealEstateAgentsAndManagersRentals) = "real_estate_agents_and_managers_rentals"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumRecordStores) = "record_stores"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumRecreationalVehicleRentals) = "recreational_vehicle_rentals"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumReligiousGoodsStores) = "religious_goods_stores"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumReligiousOrganizations) = "religious_organizations"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumRoofingSidingSheetMetal) = "roofing_siding_sheet_metal"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumSecretarialSupportServices) = "secretarial_support_services"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumSecurityBrokersDealers) = "security_brokers_dealers"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumServiceStations) = "service_stations"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumSewingNeedleworkFabricAndPieceGoodsStores) = "sewing_needlework_fabric_and_piece_goods_stores"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumShoeRepairHatCleaning) = "shoe_repair_hat_cleaning"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumShoeStores) = "shoe_stores"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumSmallApplianceRepair) = "small_appliance_repair"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumSnowmobileDealers) = "snowmobile_dealers"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumSpecialTradeServices) = "special_trade_services"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumSpecialtyCleaning) = "specialty_cleaning"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumSportingGoodsStores) = "sporting_goods_stores"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumSportingRecreationCamps) = "sporting_recreation_camps"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumSportsAndRidingApparelStores) = "sports_and_riding_apparel_stores"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumSportsClubsFields) = "sports_clubs_fields"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumStampAndCoinStores) = "stamp_and_coin_stores"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumStationaryOfficeSuppliesPrintingAndWritingPaper) = "stationary_office_supplies_printing_and_writing_paper"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumStationeryStoresOfficeAndSchoolSupplyStores) = "stationery_stores_office_and_school_supply_stores"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumSwimmingPoolsSales) = "swimming_pools_sales"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumTUiTravelGermany) = "t_ui_travel_germany"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumTailorsAlterations) = "tailors_alterations"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumTaxPaymentsGovernmentAgencies) = "tax_payments_government_agencies"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumTaxPreparationServices) = "tax_preparation_services"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumTaxicabsLimousines) = "taxicabs_limousines"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumTelecommunicationEquipmentAndTelephoneSales) = "telecommunication_equipment_and_telephone_sales"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumTelecommunicationServices) = "telecommunication_services"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumTelegraphServices) = "telegraph_services"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumTentAndAwningShops) = "tent_and_awning_shops"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumTestingLaboratories) = "testing_laboratories"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumTheatricalTicketAgencies) = "theatrical_ticket_agencies"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumTimeshares) = "timeshares"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumTireRetreadingAndRepair) = "tire_retreading_and_repair"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumTollsBridgeFees) = "tolls_bridge_fees"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumTouristAttractionsAndExhibits) = "tourist_attractions_and_exhibits"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumTowingServices) = "towing_services"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumTrailerParksCampgrounds) = "trailer_parks_campgrounds"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumTransportationServices) = "transportation_services"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumTravelAgenciesTourOperators) = "travel_agencies_tour_operators"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumTruckStopIteration) = "truck_stop_iteration"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumTruckUtilityTrailerRentals) = "truck_utility_trailer_rentals"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumTypesettingPlateMakingAndRelatedServices) = "typesetting_plate_making_and_related_services"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumTypewriterStores) = "typewriter_stores"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumUSFederalGovernmentAgenciesOrDepartments) = "u_s_federal_government_agencies_or_departments"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumUniformsCommercialClothing) = "uniforms_commercial_clothing"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumUsedMerchandiseAndSecondhandStores) = "used_merchandise_and_secondhand_stores"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumUtilities) = "utilities"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumVarietyStores) = "variety_stores"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumVeterinaryServices) = "veterinary_services"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumVideoAmusementGameSupplies) = "video_amusement_game_supplies"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumVideoGameArcades) = "video_game_arcades"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumVideoTapeRentalStores) = "video_tape_rental_stores"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumVocationalTradeSchools) = "vocational_trade_schools"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumWatchJewelryRepair) = "watch_jewelry_repair"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumWeldingRepair) = "welding_repair"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumWholesaleClubs) = "wholesale_clubs"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumWigAndToupeeStores) = "wig_and_toupee_stores"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumWiresMoneyOrders) = "wires_money_orders"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumWomensAccessoryAndSpecialtyShops) = "womens_accessory_and_specialty_shops"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumWomensReadyToWearStores) = "womens_ready_to_wear_stores"
  toJSON (Issuing'cardholderSpendingControls'AllowedCategories'EnumWreckingAndSalvageYards) = "wrecking_and_salvage_yards"

instance Data.Aeson.Types.FromJSON.FromJSON Issuing'cardholderSpendingControls'AllowedCategories' where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "ac_refrigeration_repair" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumAcRefrigerationRepair
            | val GHC.Classes.== "accounting_bookkeeping_services" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumAccountingBookkeepingServices
            | val GHC.Classes.== "advertising_services" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumAdvertisingServices
            | val GHC.Classes.== "agricultural_cooperative" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumAgriculturalCooperative
            | val GHC.Classes.== "airlines_air_carriers" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumAirlinesAirCarriers
            | val GHC.Classes.== "airports_flying_fields" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumAirportsFlyingFields
            | val GHC.Classes.== "ambulance_services" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumAmbulanceServices
            | val GHC.Classes.== "amusement_parks_carnivals" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumAmusementParksCarnivals
            | val GHC.Classes.== "antique_reproductions" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumAntiqueReproductions
            | val GHC.Classes.== "antique_shops" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumAntiqueShops
            | val GHC.Classes.== "aquariums" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumAquariums
            | val GHC.Classes.== "architectural_surveying_services" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumArchitecturalSurveyingServices
            | val GHC.Classes.== "art_dealers_and_galleries" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumArtDealersAndGalleries
            | val GHC.Classes.== "artists_supply_and_craft_shops" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumArtistsSupplyAndCraftShops
            | val GHC.Classes.== "auto_and_home_supply_stores" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumAutoAndHomeSupplyStores
            | val GHC.Classes.== "auto_body_repair_shops" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumAutoBodyRepairShops
            | val GHC.Classes.== "auto_paint_shops" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumAutoPaintShops
            | val GHC.Classes.== "auto_service_shops" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumAutoServiceShops
            | val GHC.Classes.== "automated_cash_disburse" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumAutomatedCashDisburse
            | val GHC.Classes.== "automated_fuel_dispensers" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumAutomatedFuelDispensers
            | val GHC.Classes.== "automobile_associations" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumAutomobileAssociations
            | val GHC.Classes.== "automotive_parts_and_accessories_stores" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumAutomotivePartsAndAccessoriesStores
            | val GHC.Classes.== "automotive_tire_stores" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumAutomotiveTireStores
            | val GHC.Classes.== "bail_and_bond_payments" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumBailAndBondPayments
            | val GHC.Classes.== "bakeries" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumBakeries
            | val GHC.Classes.== "bands_orchestras" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumBandsOrchestras
            | val GHC.Classes.== "barber_and_beauty_shops" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumBarberAndBeautyShops
            | val GHC.Classes.== "betting_casino_gambling" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumBettingCasinoGambling
            | val GHC.Classes.== "bicycle_shops" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumBicycleShops
            | val GHC.Classes.== "billiard_pool_establishments" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumBilliardPoolEstablishments
            | val GHC.Classes.== "boat_dealers" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumBoatDealers
            | val GHC.Classes.== "boat_rentals_and_leases" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumBoatRentalsAndLeases
            | val GHC.Classes.== "book_stores" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumBookStores
            | val GHC.Classes.== "books_periodicals_and_newspapers" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumBooksPeriodicalsAndNewspapers
            | val GHC.Classes.== "bowling_alleys" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumBowlingAlleys
            | val GHC.Classes.== "bus_lines" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumBusLines
            | val GHC.Classes.== "business_secretarial_schools" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumBusinessSecretarialSchools
            | val GHC.Classes.== "buying_shopping_services" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumBuyingShoppingServices
            | val GHC.Classes.== "cable_satellite_and_other_pay_television_and_radio" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumCableSatelliteAndOtherPayTelevisionAndRadio
            | val GHC.Classes.== "camera_and_photographic_supply_stores" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumCameraAndPhotographicSupplyStores
            | val GHC.Classes.== "candy_nut_and_confectionery_stores" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumCandyNutAndConfectioneryStores
            | val GHC.Classes.== "car_and_truck_dealers_new_used" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumCarAndTruckDealersNewUsed
            | val GHC.Classes.== "car_and_truck_dealers_used_only" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumCarAndTruckDealersUsedOnly
            | val GHC.Classes.== "car_rental_agencies" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumCarRentalAgencies
            | val GHC.Classes.== "car_washes" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumCarWashes
            | val GHC.Classes.== "carpentry_services" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumCarpentryServices
            | val GHC.Classes.== "carpet_upholstery_cleaning" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumCarpetUpholsteryCleaning
            | val GHC.Classes.== "caterers" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumCaterers
            | val GHC.Classes.== "charitable_and_social_service_organizations_fundraising" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumCharitableAndSocialServiceOrganizationsFundraising
            | val GHC.Classes.== "chemicals_and_allied_products" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumChemicalsAndAlliedProducts
            | val GHC.Classes.== "child_care_services" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumChildCareServices
            | val GHC.Classes.== "childrens_and_infants_wear_stores" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumChildrensAndInfantsWearStores
            | val GHC.Classes.== "chiropodists_podiatrists" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumChiropodistsPodiatrists
            | val GHC.Classes.== "chiropractors" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumChiropractors
            | val GHC.Classes.== "cigar_stores_and_stands" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumCigarStoresAndStands
            | val GHC.Classes.== "civic_social_fraternal_associations" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumCivicSocialFraternalAssociations
            | val GHC.Classes.== "cleaning_and_maintenance" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumCleaningAndMaintenance
            | val GHC.Classes.== "clothing_rental" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumClothingRental
            | val GHC.Classes.== "colleges_universities" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumCollegesUniversities
            | val GHC.Classes.== "commercial_equipment" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumCommercialEquipment
            | val GHC.Classes.== "commercial_footwear" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumCommercialFootwear
            | val GHC.Classes.== "commercial_photography_art_and_graphics" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumCommercialPhotographyArtAndGraphics
            | val GHC.Classes.== "commuter_transport_and_ferries" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumCommuterTransportAndFerries
            | val GHC.Classes.== "computer_network_services" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumComputerNetworkServices
            | val GHC.Classes.== "computer_programming" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumComputerProgramming
            | val GHC.Classes.== "computer_repair" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumComputerRepair
            | val GHC.Classes.== "computer_software_stores" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumComputerSoftwareStores
            | val GHC.Classes.== "computers_peripherals_and_software" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumComputersPeripheralsAndSoftware
            | val GHC.Classes.== "concrete_work_services" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumConcreteWorkServices
            | val GHC.Classes.== "construction_materials" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumConstructionMaterials
            | val GHC.Classes.== "consulting_public_relations" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumConsultingPublicRelations
            | val GHC.Classes.== "correspondence_schools" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumCorrespondenceSchools
            | val GHC.Classes.== "cosmetic_stores" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumCosmeticStores
            | val GHC.Classes.== "counseling_services" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumCounselingServices
            | val GHC.Classes.== "country_clubs" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumCountryClubs
            | val GHC.Classes.== "courier_services" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumCourierServices
            | val GHC.Classes.== "court_costs" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumCourtCosts
            | val GHC.Classes.== "credit_reporting_agencies" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumCreditReportingAgencies
            | val GHC.Classes.== "cruise_lines" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumCruiseLines
            | val GHC.Classes.== "dairy_products_stores" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumDairyProductsStores
            | val GHC.Classes.== "dance_hall_studios_schools" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumDanceHallStudiosSchools
            | val GHC.Classes.== "dating_escort_services" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumDatingEscortServices
            | val GHC.Classes.== "dentists_orthodontists" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumDentistsOrthodontists
            | val GHC.Classes.== "department_stores" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumDepartmentStores
            | val GHC.Classes.== "detective_agencies" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumDetectiveAgencies
            | val GHC.Classes.== "digital_goods_applications" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumDigitalGoodsApplications
            | val GHC.Classes.== "digital_goods_games" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumDigitalGoodsGames
            | val GHC.Classes.== "digital_goods_large_volume" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumDigitalGoodsLargeVolume
            | val GHC.Classes.== "digital_goods_media" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumDigitalGoodsMedia
            | val GHC.Classes.== "direct_marketing_catalog_merchant" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumDirectMarketingCatalogMerchant
            | val GHC.Classes.== "direct_marketing_combination_catalog_and_retail_merchant" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumDirectMarketingCombinationCatalogAndRetailMerchant
            | val GHC.Classes.== "direct_marketing_inbound_telemarketing" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumDirectMarketingInboundTelemarketing
            | val GHC.Classes.== "direct_marketing_insurance_services" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumDirectMarketingInsuranceServices
            | val GHC.Classes.== "direct_marketing_other" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumDirectMarketingOther
            | val GHC.Classes.== "direct_marketing_outbound_telemarketing" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumDirectMarketingOutboundTelemarketing
            | val GHC.Classes.== "direct_marketing_subscription" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumDirectMarketingSubscription
            | val GHC.Classes.== "direct_marketing_travel" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumDirectMarketingTravel
            | val GHC.Classes.== "discount_stores" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumDiscountStores
            | val GHC.Classes.== "doctors" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumDoctors
            | val GHC.Classes.== "door_to_door_sales" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumDoorToDoorSales
            | val GHC.Classes.== "drapery_window_covering_and_upholstery_stores" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumDraperyWindowCoveringAndUpholsteryStores
            | val GHC.Classes.== "drinking_places" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumDrinkingPlaces
            | val GHC.Classes.== "drug_stores_and_pharmacies" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumDrugStoresAndPharmacies
            | val GHC.Classes.== "drugs_drug_proprietaries_and_druggist_sundries" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumDrugsDrugProprietariesAndDruggistSundries
            | val GHC.Classes.== "dry_cleaners" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumDryCleaners
            | val GHC.Classes.== "durable_goods" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumDurableGoods
            | val GHC.Classes.== "duty_free_stores" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumDutyFreeStores
            | val GHC.Classes.== "eating_places_restaurants" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumEatingPlacesRestaurants
            | val GHC.Classes.== "educational_services" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumEducationalServices
            | val GHC.Classes.== "electric_razor_stores" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumElectricRazorStores
            | val GHC.Classes.== "electrical_parts_and_equipment" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumElectricalPartsAndEquipment
            | val GHC.Classes.== "electrical_services" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumElectricalServices
            | val GHC.Classes.== "electronics_repair_shops" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumElectronicsRepairShops
            | val GHC.Classes.== "electronics_stores" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumElectronicsStores
            | val GHC.Classes.== "elementary_secondary_schools" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumElementarySecondarySchools
            | val GHC.Classes.== "employment_temp_agencies" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumEmploymentTempAgencies
            | val GHC.Classes.== "equipment_rental" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumEquipmentRental
            | val GHC.Classes.== "exterminating_services" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumExterminatingServices
            | val GHC.Classes.== "family_clothing_stores" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumFamilyClothingStores
            | val GHC.Classes.== "fast_food_restaurants" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumFastFoodRestaurants
            | val GHC.Classes.== "financial_institutions" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumFinancialInstitutions
            | val GHC.Classes.== "fines_government_administrative_entities" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumFinesGovernmentAdministrativeEntities
            | val GHC.Classes.== "fireplace_fireplace_screens_and_accessories_stores" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumFireplaceFireplaceScreensAndAccessoriesStores
            | val GHC.Classes.== "floor_covering_stores" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumFloorCoveringStores
            | val GHC.Classes.== "florists" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumFlorists
            | val GHC.Classes.== "florists_supplies_nursery_stock_and_flowers" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumFloristsSuppliesNurseryStockAndFlowers
            | val GHC.Classes.== "freezer_and_locker_meat_provisioners" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumFreezerAndLockerMeatProvisioners
            | val GHC.Classes.== "fuel_dealers_non_automotive" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumFuelDealersNonAutomotive
            | val GHC.Classes.== "funeral_services_crematories" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumFuneralServicesCrematories
            | val GHC.Classes.== "furniture_home_furnishings_and_equipment_stores_except_appliances" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumFurnitureHomeFurnishingsAndEquipmentStoresExceptAppliances
            | val GHC.Classes.== "furniture_repair_refinishing" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumFurnitureRepairRefinishing
            | val GHC.Classes.== "furriers_and_fur_shops" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumFurriersAndFurShops
            | val GHC.Classes.== "general_services" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumGeneralServices
            | val GHC.Classes.== "gift_card_novelty_and_souvenir_shops" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumGiftCardNoveltyAndSouvenirShops
            | val GHC.Classes.== "glass_paint_and_wallpaper_stores" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumGlassPaintAndWallpaperStores
            | val GHC.Classes.== "glassware_crystal_stores" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumGlasswareCrystalStores
            | val GHC.Classes.== "golf_courses_public" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumGolfCoursesPublic
            | val GHC.Classes.== "government_services" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumGovernmentServices
            | val GHC.Classes.== "grocery_stores_supermarkets" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumGroceryStoresSupermarkets
            | val GHC.Classes.== "hardware_equipment_and_supplies" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumHardwareEquipmentAndSupplies
            | val GHC.Classes.== "hardware_stores" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumHardwareStores
            | val GHC.Classes.== "health_and_beauty_spas" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumHealthAndBeautySpas
            | val GHC.Classes.== "hearing_aids_sales_and_supplies" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumHearingAidsSalesAndSupplies
            | val GHC.Classes.== "heating_plumbing_a_c" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumHeatingPlumbingAC
            | val GHC.Classes.== "hobby_toy_and_game_shops" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumHobbyToyAndGameShops
            | val GHC.Classes.== "home_supply_warehouse_stores" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumHomeSupplyWarehouseStores
            | val GHC.Classes.== "hospitals" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumHospitals
            | val GHC.Classes.== "hotels_motels_and_resorts" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumHotelsMotelsAndResorts
            | val GHC.Classes.== "household_appliance_stores" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumHouseholdApplianceStores
            | val GHC.Classes.== "industrial_supplies" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumIndustrialSupplies
            | val GHC.Classes.== "information_retrieval_services" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumInformationRetrievalServices
            | val GHC.Classes.== "insurance_default" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumInsuranceDefault
            | val GHC.Classes.== "insurance_underwriting_premiums" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumInsuranceUnderwritingPremiums
            | val GHC.Classes.== "intra_company_purchases" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumIntraCompanyPurchases
            | val GHC.Classes.== "jewelry_stores_watches_clocks_and_silverware_stores" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumJewelryStoresWatchesClocksAndSilverwareStores
            | val GHC.Classes.== "landscaping_services" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumLandscapingServices
            | val GHC.Classes.== "laundries" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumLaundries
            | val GHC.Classes.== "laundry_cleaning_services" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumLaundryCleaningServices
            | val GHC.Classes.== "legal_services_attorneys" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumLegalServicesAttorneys
            | val GHC.Classes.== "luggage_and_leather_goods_stores" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumLuggageAndLeatherGoodsStores
            | val GHC.Classes.== "lumber_building_materials_stores" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumLumberBuildingMaterialsStores
            | val GHC.Classes.== "manual_cash_disburse" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumManualCashDisburse
            | val GHC.Classes.== "marinas_service_and_supplies" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumMarinasServiceAndSupplies
            | val GHC.Classes.== "masonry_stonework_and_plaster" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumMasonryStoneworkAndPlaster
            | val GHC.Classes.== "massage_parlors" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumMassageParlors
            | val GHC.Classes.== "medical_and_dental_labs" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumMedicalAndDentalLabs
            | val GHC.Classes.== "medical_dental_ophthalmic_and_hospital_equipment_and_supplies" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumMedicalDentalOphthalmicAndHospitalEquipmentAndSupplies
            | val GHC.Classes.== "medical_services" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumMedicalServices
            | val GHC.Classes.== "membership_organizations" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumMembershipOrganizations
            | val GHC.Classes.== "mens_and_boys_clothing_and_accessories_stores" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumMensAndBoysClothingAndAccessoriesStores
            | val GHC.Classes.== "mens_womens_clothing_stores" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumMensWomensClothingStores
            | val GHC.Classes.== "metal_service_centers" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumMetalServiceCenters
            | val GHC.Classes.== "miscellaneous" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumMiscellaneous
            | val GHC.Classes.== "miscellaneous_apparel_and_accessory_shops" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumMiscellaneousApparelAndAccessoryShops
            | val GHC.Classes.== "miscellaneous_auto_dealers" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumMiscellaneousAutoDealers
            | val GHC.Classes.== "miscellaneous_business_services" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumMiscellaneousBusinessServices
            | val GHC.Classes.== "miscellaneous_food_stores" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumMiscellaneousFoodStores
            | val GHC.Classes.== "miscellaneous_general_merchandise" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumMiscellaneousGeneralMerchandise
            | val GHC.Classes.== "miscellaneous_general_services" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumMiscellaneousGeneralServices
            | val GHC.Classes.== "miscellaneous_home_furnishing_specialty_stores" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumMiscellaneousHomeFurnishingSpecialtyStores
            | val GHC.Classes.== "miscellaneous_publishing_and_printing" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumMiscellaneousPublishingAndPrinting
            | val GHC.Classes.== "miscellaneous_recreation_services" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumMiscellaneousRecreationServices
            | val GHC.Classes.== "miscellaneous_repair_shops" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumMiscellaneousRepairShops
            | val GHC.Classes.== "miscellaneous_specialty_retail" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumMiscellaneousSpecialtyRetail
            | val GHC.Classes.== "mobile_home_dealers" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumMobileHomeDealers
            | val GHC.Classes.== "motion_picture_theaters" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumMotionPictureTheaters
            | val GHC.Classes.== "motor_freight_carriers_and_trucking" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumMotorFreightCarriersAndTrucking
            | val GHC.Classes.== "motor_homes_dealers" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumMotorHomesDealers
            | val GHC.Classes.== "motor_vehicle_supplies_and_new_parts" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumMotorVehicleSuppliesAndNewParts
            | val GHC.Classes.== "motorcycle_shops_and_dealers" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumMotorcycleShopsAndDealers
            | val GHC.Classes.== "motorcycle_shops_dealers" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumMotorcycleShopsDealers
            | val GHC.Classes.== "music_stores_musical_instruments_pianos_and_sheet_music" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumMusicStoresMusicalInstrumentsPianosAndSheetMusic
            | val GHC.Classes.== "news_dealers_and_newsstands" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumNewsDealersAndNewsstands
            | val GHC.Classes.== "non_fi_money_orders" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumNonFiMoneyOrders
            | val GHC.Classes.== "non_fi_stored_value_card_purchase_load" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumNonFiStoredValueCardPurchaseLoad
            | val GHC.Classes.== "nondurable_goods" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumNondurableGoods
            | val GHC.Classes.== "nurseries_lawn_and_garden_supply_stores" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumNurseriesLawnAndGardenSupplyStores
            | val GHC.Classes.== "nursing_personal_care" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumNursingPersonalCare
            | val GHC.Classes.== "office_and_commercial_furniture" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumOfficeAndCommercialFurniture
            | val GHC.Classes.== "opticians_eyeglasses" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumOpticiansEyeglasses
            | val GHC.Classes.== "optometrists_ophthalmologist" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumOptometristsOphthalmologist
            | val GHC.Classes.== "orthopedic_goods_prosthetic_devices" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumOrthopedicGoodsProstheticDevices
            | val GHC.Classes.== "osteopaths" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumOsteopaths
            | val GHC.Classes.== "package_stores_beer_wine_and_liquor" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumPackageStoresBeerWineAndLiquor
            | val GHC.Classes.== "paints_varnishes_and_supplies" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumPaintsVarnishesAndSupplies
            | val GHC.Classes.== "parking_lots_garages" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumParkingLotsGarages
            | val GHC.Classes.== "passenger_railways" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumPassengerRailways
            | val GHC.Classes.== "pawn_shops" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumPawnShops
            | val GHC.Classes.== "pet_shops_pet_food_and_supplies" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumPetShopsPetFoodAndSupplies
            | val GHC.Classes.== "petroleum_and_petroleum_products" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumPetroleumAndPetroleumProducts
            | val GHC.Classes.== "photo_developing" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumPhotoDeveloping
            | val GHC.Classes.== "photographic_photocopy_microfilm_equipment_and_supplies" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumPhotographicPhotocopyMicrofilmEquipmentAndSupplies
            | val GHC.Classes.== "photographic_studios" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumPhotographicStudios
            | val GHC.Classes.== "picture_video_production" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumPictureVideoProduction
            | val GHC.Classes.== "piece_goods_notions_and_other_dry_goods" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumPieceGoodsNotionsAndOtherDryGoods
            | val GHC.Classes.== "plumbing_heating_equipment_and_supplies" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumPlumbingHeatingEquipmentAndSupplies
            | val GHC.Classes.== "political_organizations" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumPoliticalOrganizations
            | val GHC.Classes.== "postal_services_government_only" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumPostalServicesGovernmentOnly
            | val GHC.Classes.== "precious_stones_and_metals_watches_and_jewelry" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumPreciousStonesAndMetalsWatchesAndJewelry
            | val GHC.Classes.== "professional_services" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumProfessionalServices
            | val GHC.Classes.== "public_warehousing_and_storage" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumPublicWarehousingAndStorage
            | val GHC.Classes.== "quick_copy_repro_and_blueprint" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumQuickCopyReproAndBlueprint
            | val GHC.Classes.== "railroads" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumRailroads
            | val GHC.Classes.== "real_estate_agents_and_managers_rentals" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumRealEstateAgentsAndManagersRentals
            | val GHC.Classes.== "record_stores" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumRecordStores
            | val GHC.Classes.== "recreational_vehicle_rentals" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumRecreationalVehicleRentals
            | val GHC.Classes.== "religious_goods_stores" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumReligiousGoodsStores
            | val GHC.Classes.== "religious_organizations" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumReligiousOrganizations
            | val GHC.Classes.== "roofing_siding_sheet_metal" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumRoofingSidingSheetMetal
            | val GHC.Classes.== "secretarial_support_services" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumSecretarialSupportServices
            | val GHC.Classes.== "security_brokers_dealers" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumSecurityBrokersDealers
            | val GHC.Classes.== "service_stations" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumServiceStations
            | val GHC.Classes.== "sewing_needlework_fabric_and_piece_goods_stores" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumSewingNeedleworkFabricAndPieceGoodsStores
            | val GHC.Classes.== "shoe_repair_hat_cleaning" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumShoeRepairHatCleaning
            | val GHC.Classes.== "shoe_stores" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumShoeStores
            | val GHC.Classes.== "small_appliance_repair" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumSmallApplianceRepair
            | val GHC.Classes.== "snowmobile_dealers" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumSnowmobileDealers
            | val GHC.Classes.== "special_trade_services" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumSpecialTradeServices
            | val GHC.Classes.== "specialty_cleaning" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumSpecialtyCleaning
            | val GHC.Classes.== "sporting_goods_stores" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumSportingGoodsStores
            | val GHC.Classes.== "sporting_recreation_camps" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumSportingRecreationCamps
            | val GHC.Classes.== "sports_and_riding_apparel_stores" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumSportsAndRidingApparelStores
            | val GHC.Classes.== "sports_clubs_fields" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumSportsClubsFields
            | val GHC.Classes.== "stamp_and_coin_stores" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumStampAndCoinStores
            | val GHC.Classes.== "stationary_office_supplies_printing_and_writing_paper" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumStationaryOfficeSuppliesPrintingAndWritingPaper
            | val GHC.Classes.== "stationery_stores_office_and_school_supply_stores" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumStationeryStoresOfficeAndSchoolSupplyStores
            | val GHC.Classes.== "swimming_pools_sales" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumSwimmingPoolsSales
            | val GHC.Classes.== "t_ui_travel_germany" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumTUiTravelGermany
            | val GHC.Classes.== "tailors_alterations" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumTailorsAlterations
            | val GHC.Classes.== "tax_payments_government_agencies" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumTaxPaymentsGovernmentAgencies
            | val GHC.Classes.== "tax_preparation_services" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumTaxPreparationServices
            | val GHC.Classes.== "taxicabs_limousines" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumTaxicabsLimousines
            | val GHC.Classes.== "telecommunication_equipment_and_telephone_sales" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumTelecommunicationEquipmentAndTelephoneSales
            | val GHC.Classes.== "telecommunication_services" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumTelecommunicationServices
            | val GHC.Classes.== "telegraph_services" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumTelegraphServices
            | val GHC.Classes.== "tent_and_awning_shops" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumTentAndAwningShops
            | val GHC.Classes.== "testing_laboratories" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumTestingLaboratories
            | val GHC.Classes.== "theatrical_ticket_agencies" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumTheatricalTicketAgencies
            | val GHC.Classes.== "timeshares" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumTimeshares
            | val GHC.Classes.== "tire_retreading_and_repair" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumTireRetreadingAndRepair
            | val GHC.Classes.== "tolls_bridge_fees" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumTollsBridgeFees
            | val GHC.Classes.== "tourist_attractions_and_exhibits" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumTouristAttractionsAndExhibits
            | val GHC.Classes.== "towing_services" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumTowingServices
            | val GHC.Classes.== "trailer_parks_campgrounds" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumTrailerParksCampgrounds
            | val GHC.Classes.== "transportation_services" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumTransportationServices
            | val GHC.Classes.== "travel_agencies_tour_operators" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumTravelAgenciesTourOperators
            | val GHC.Classes.== "truck_stop_iteration" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumTruckStopIteration
            | val GHC.Classes.== "truck_utility_trailer_rentals" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumTruckUtilityTrailerRentals
            | val GHC.Classes.== "typesetting_plate_making_and_related_services" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumTypesettingPlateMakingAndRelatedServices
            | val GHC.Classes.== "typewriter_stores" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumTypewriterStores
            | val GHC.Classes.== "u_s_federal_government_agencies_or_departments" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumUSFederalGovernmentAgenciesOrDepartments
            | val GHC.Classes.== "uniforms_commercial_clothing" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumUniformsCommercialClothing
            | val GHC.Classes.== "used_merchandise_and_secondhand_stores" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumUsedMerchandiseAndSecondhandStores
            | val GHC.Classes.== "utilities" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumUtilities
            | val GHC.Classes.== "variety_stores" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumVarietyStores
            | val GHC.Classes.== "veterinary_services" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumVeterinaryServices
            | val GHC.Classes.== "video_amusement_game_supplies" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumVideoAmusementGameSupplies
            | val GHC.Classes.== "video_game_arcades" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumVideoGameArcades
            | val GHC.Classes.== "video_tape_rental_stores" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumVideoTapeRentalStores
            | val GHC.Classes.== "vocational_trade_schools" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumVocationalTradeSchools
            | val GHC.Classes.== "watch_jewelry_repair" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumWatchJewelryRepair
            | val GHC.Classes.== "welding_repair" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumWeldingRepair
            | val GHC.Classes.== "wholesale_clubs" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumWholesaleClubs
            | val GHC.Classes.== "wig_and_toupee_stores" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumWigAndToupeeStores
            | val GHC.Classes.== "wires_money_orders" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumWiresMoneyOrders
            | val GHC.Classes.== "womens_accessory_and_specialty_shops" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumWomensAccessoryAndSpecialtyShops
            | val GHC.Classes.== "womens_ready_to_wear_stores" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumWomensReadyToWearStores
            | val GHC.Classes.== "wrecking_and_salvage_yards" -> Issuing'cardholderSpendingControls'AllowedCategories'EnumWreckingAndSalvageYards
            | GHC.Base.otherwise -> Issuing'cardholderSpendingControls'AllowedCategories'Other val
      )

-- | Defines the enum schema located at @components.schemas.issuing.cardholder.properties.spending_controls.anyOf.properties.blocked_categories.items@ in the specification.
data Issuing'cardholderSpendingControls'BlockedCategories'
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    Issuing'cardholderSpendingControls'BlockedCategories'Other Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    Issuing'cardholderSpendingControls'BlockedCategories'Typed Data.Text.Internal.Text
  | -- | Represents the JSON value @"ac_refrigeration_repair"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumAcRefrigerationRepair
  | -- | Represents the JSON value @"accounting_bookkeeping_services"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumAccountingBookkeepingServices
  | -- | Represents the JSON value @"advertising_services"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumAdvertisingServices
  | -- | Represents the JSON value @"agricultural_cooperative"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumAgriculturalCooperative
  | -- | Represents the JSON value @"airlines_air_carriers"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumAirlinesAirCarriers
  | -- | Represents the JSON value @"airports_flying_fields"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumAirportsFlyingFields
  | -- | Represents the JSON value @"ambulance_services"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumAmbulanceServices
  | -- | Represents the JSON value @"amusement_parks_carnivals"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumAmusementParksCarnivals
  | -- | Represents the JSON value @"antique_reproductions"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumAntiqueReproductions
  | -- | Represents the JSON value @"antique_shops"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumAntiqueShops
  | -- | Represents the JSON value @"aquariums"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumAquariums
  | -- | Represents the JSON value @"architectural_surveying_services"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumArchitecturalSurveyingServices
  | -- | Represents the JSON value @"art_dealers_and_galleries"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumArtDealersAndGalleries
  | -- | Represents the JSON value @"artists_supply_and_craft_shops"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumArtistsSupplyAndCraftShops
  | -- | Represents the JSON value @"auto_and_home_supply_stores"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumAutoAndHomeSupplyStores
  | -- | Represents the JSON value @"auto_body_repair_shops"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumAutoBodyRepairShops
  | -- | Represents the JSON value @"auto_paint_shops"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumAutoPaintShops
  | -- | Represents the JSON value @"auto_service_shops"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumAutoServiceShops
  | -- | Represents the JSON value @"automated_cash_disburse"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumAutomatedCashDisburse
  | -- | Represents the JSON value @"automated_fuel_dispensers"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumAutomatedFuelDispensers
  | -- | Represents the JSON value @"automobile_associations"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumAutomobileAssociations
  | -- | Represents the JSON value @"automotive_parts_and_accessories_stores"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumAutomotivePartsAndAccessoriesStores
  | -- | Represents the JSON value @"automotive_tire_stores"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumAutomotiveTireStores
  | -- | Represents the JSON value @"bail_and_bond_payments"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumBailAndBondPayments
  | -- | Represents the JSON value @"bakeries"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumBakeries
  | -- | Represents the JSON value @"bands_orchestras"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumBandsOrchestras
  | -- | Represents the JSON value @"barber_and_beauty_shops"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumBarberAndBeautyShops
  | -- | Represents the JSON value @"betting_casino_gambling"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumBettingCasinoGambling
  | -- | Represents the JSON value @"bicycle_shops"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumBicycleShops
  | -- | Represents the JSON value @"billiard_pool_establishments"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumBilliardPoolEstablishments
  | -- | Represents the JSON value @"boat_dealers"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumBoatDealers
  | -- | Represents the JSON value @"boat_rentals_and_leases"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumBoatRentalsAndLeases
  | -- | Represents the JSON value @"book_stores"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumBookStores
  | -- | Represents the JSON value @"books_periodicals_and_newspapers"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumBooksPeriodicalsAndNewspapers
  | -- | Represents the JSON value @"bowling_alleys"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumBowlingAlleys
  | -- | Represents the JSON value @"bus_lines"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumBusLines
  | -- | Represents the JSON value @"business_secretarial_schools"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumBusinessSecretarialSchools
  | -- | Represents the JSON value @"buying_shopping_services"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumBuyingShoppingServices
  | -- | Represents the JSON value @"cable_satellite_and_other_pay_television_and_radio"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumCableSatelliteAndOtherPayTelevisionAndRadio
  | -- | Represents the JSON value @"camera_and_photographic_supply_stores"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumCameraAndPhotographicSupplyStores
  | -- | Represents the JSON value @"candy_nut_and_confectionery_stores"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumCandyNutAndConfectioneryStores
  | -- | Represents the JSON value @"car_and_truck_dealers_new_used"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumCarAndTruckDealersNewUsed
  | -- | Represents the JSON value @"car_and_truck_dealers_used_only"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumCarAndTruckDealersUsedOnly
  | -- | Represents the JSON value @"car_rental_agencies"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumCarRentalAgencies
  | -- | Represents the JSON value @"car_washes"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumCarWashes
  | -- | Represents the JSON value @"carpentry_services"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumCarpentryServices
  | -- | Represents the JSON value @"carpet_upholstery_cleaning"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumCarpetUpholsteryCleaning
  | -- | Represents the JSON value @"caterers"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumCaterers
  | -- | Represents the JSON value @"charitable_and_social_service_organizations_fundraising"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumCharitableAndSocialServiceOrganizationsFundraising
  | -- | Represents the JSON value @"chemicals_and_allied_products"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumChemicalsAndAlliedProducts
  | -- | Represents the JSON value @"child_care_services"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumChildCareServices
  | -- | Represents the JSON value @"childrens_and_infants_wear_stores"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumChildrensAndInfantsWearStores
  | -- | Represents the JSON value @"chiropodists_podiatrists"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumChiropodistsPodiatrists
  | -- | Represents the JSON value @"chiropractors"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumChiropractors
  | -- | Represents the JSON value @"cigar_stores_and_stands"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumCigarStoresAndStands
  | -- | Represents the JSON value @"civic_social_fraternal_associations"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumCivicSocialFraternalAssociations
  | -- | Represents the JSON value @"cleaning_and_maintenance"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumCleaningAndMaintenance
  | -- | Represents the JSON value @"clothing_rental"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumClothingRental
  | -- | Represents the JSON value @"colleges_universities"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumCollegesUniversities
  | -- | Represents the JSON value @"commercial_equipment"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumCommercialEquipment
  | -- | Represents the JSON value @"commercial_footwear"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumCommercialFootwear
  | -- | Represents the JSON value @"commercial_photography_art_and_graphics"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumCommercialPhotographyArtAndGraphics
  | -- | Represents the JSON value @"commuter_transport_and_ferries"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumCommuterTransportAndFerries
  | -- | Represents the JSON value @"computer_network_services"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumComputerNetworkServices
  | -- | Represents the JSON value @"computer_programming"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumComputerProgramming
  | -- | Represents the JSON value @"computer_repair"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumComputerRepair
  | -- | Represents the JSON value @"computer_software_stores"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumComputerSoftwareStores
  | -- | Represents the JSON value @"computers_peripherals_and_software"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumComputersPeripheralsAndSoftware
  | -- | Represents the JSON value @"concrete_work_services"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumConcreteWorkServices
  | -- | Represents the JSON value @"construction_materials"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumConstructionMaterials
  | -- | Represents the JSON value @"consulting_public_relations"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumConsultingPublicRelations
  | -- | Represents the JSON value @"correspondence_schools"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumCorrespondenceSchools
  | -- | Represents the JSON value @"cosmetic_stores"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumCosmeticStores
  | -- | Represents the JSON value @"counseling_services"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumCounselingServices
  | -- | Represents the JSON value @"country_clubs"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumCountryClubs
  | -- | Represents the JSON value @"courier_services"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumCourierServices
  | -- | Represents the JSON value @"court_costs"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumCourtCosts
  | -- | Represents the JSON value @"credit_reporting_agencies"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumCreditReportingAgencies
  | -- | Represents the JSON value @"cruise_lines"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumCruiseLines
  | -- | Represents the JSON value @"dairy_products_stores"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumDairyProductsStores
  | -- | Represents the JSON value @"dance_hall_studios_schools"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumDanceHallStudiosSchools
  | -- | Represents the JSON value @"dating_escort_services"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumDatingEscortServices
  | -- | Represents the JSON value @"dentists_orthodontists"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumDentistsOrthodontists
  | -- | Represents the JSON value @"department_stores"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumDepartmentStores
  | -- | Represents the JSON value @"detective_agencies"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumDetectiveAgencies
  | -- | Represents the JSON value @"digital_goods_applications"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumDigitalGoodsApplications
  | -- | Represents the JSON value @"digital_goods_games"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumDigitalGoodsGames
  | -- | Represents the JSON value @"digital_goods_large_volume"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumDigitalGoodsLargeVolume
  | -- | Represents the JSON value @"digital_goods_media"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumDigitalGoodsMedia
  | -- | Represents the JSON value @"direct_marketing_catalog_merchant"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumDirectMarketingCatalogMerchant
  | -- | Represents the JSON value @"direct_marketing_combination_catalog_and_retail_merchant"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumDirectMarketingCombinationCatalogAndRetailMerchant
  | -- | Represents the JSON value @"direct_marketing_inbound_telemarketing"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumDirectMarketingInboundTelemarketing
  | -- | Represents the JSON value @"direct_marketing_insurance_services"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumDirectMarketingInsuranceServices
  | -- | Represents the JSON value @"direct_marketing_other"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumDirectMarketingOther
  | -- | Represents the JSON value @"direct_marketing_outbound_telemarketing"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumDirectMarketingOutboundTelemarketing
  | -- | Represents the JSON value @"direct_marketing_subscription"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumDirectMarketingSubscription
  | -- | Represents the JSON value @"direct_marketing_travel"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumDirectMarketingTravel
  | -- | Represents the JSON value @"discount_stores"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumDiscountStores
  | -- | Represents the JSON value @"doctors"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumDoctors
  | -- | Represents the JSON value @"door_to_door_sales"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumDoorToDoorSales
  | -- | Represents the JSON value @"drapery_window_covering_and_upholstery_stores"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumDraperyWindowCoveringAndUpholsteryStores
  | -- | Represents the JSON value @"drinking_places"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumDrinkingPlaces
  | -- | Represents the JSON value @"drug_stores_and_pharmacies"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumDrugStoresAndPharmacies
  | -- | Represents the JSON value @"drugs_drug_proprietaries_and_druggist_sundries"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumDrugsDrugProprietariesAndDruggistSundries
  | -- | Represents the JSON value @"dry_cleaners"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumDryCleaners
  | -- | Represents the JSON value @"durable_goods"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumDurableGoods
  | -- | Represents the JSON value @"duty_free_stores"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumDutyFreeStores
  | -- | Represents the JSON value @"eating_places_restaurants"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumEatingPlacesRestaurants
  | -- | Represents the JSON value @"educational_services"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumEducationalServices
  | -- | Represents the JSON value @"electric_razor_stores"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumElectricRazorStores
  | -- | Represents the JSON value @"electrical_parts_and_equipment"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumElectricalPartsAndEquipment
  | -- | Represents the JSON value @"electrical_services"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumElectricalServices
  | -- | Represents the JSON value @"electronics_repair_shops"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumElectronicsRepairShops
  | -- | Represents the JSON value @"electronics_stores"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumElectronicsStores
  | -- | Represents the JSON value @"elementary_secondary_schools"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumElementarySecondarySchools
  | -- | Represents the JSON value @"employment_temp_agencies"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumEmploymentTempAgencies
  | -- | Represents the JSON value @"equipment_rental"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumEquipmentRental
  | -- | Represents the JSON value @"exterminating_services"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumExterminatingServices
  | -- | Represents the JSON value @"family_clothing_stores"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumFamilyClothingStores
  | -- | Represents the JSON value @"fast_food_restaurants"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumFastFoodRestaurants
  | -- | Represents the JSON value @"financial_institutions"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumFinancialInstitutions
  | -- | Represents the JSON value @"fines_government_administrative_entities"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumFinesGovernmentAdministrativeEntities
  | -- | Represents the JSON value @"fireplace_fireplace_screens_and_accessories_stores"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumFireplaceFireplaceScreensAndAccessoriesStores
  | -- | Represents the JSON value @"floor_covering_stores"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumFloorCoveringStores
  | -- | Represents the JSON value @"florists"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumFlorists
  | -- | Represents the JSON value @"florists_supplies_nursery_stock_and_flowers"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumFloristsSuppliesNurseryStockAndFlowers
  | -- | Represents the JSON value @"freezer_and_locker_meat_provisioners"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumFreezerAndLockerMeatProvisioners
  | -- | Represents the JSON value @"fuel_dealers_non_automotive"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumFuelDealersNonAutomotive
  | -- | Represents the JSON value @"funeral_services_crematories"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumFuneralServicesCrematories
  | -- | Represents the JSON value @"furniture_home_furnishings_and_equipment_stores_except_appliances"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumFurnitureHomeFurnishingsAndEquipmentStoresExceptAppliances
  | -- | Represents the JSON value @"furniture_repair_refinishing"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumFurnitureRepairRefinishing
  | -- | Represents the JSON value @"furriers_and_fur_shops"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumFurriersAndFurShops
  | -- | Represents the JSON value @"general_services"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumGeneralServices
  | -- | Represents the JSON value @"gift_card_novelty_and_souvenir_shops"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumGiftCardNoveltyAndSouvenirShops
  | -- | Represents the JSON value @"glass_paint_and_wallpaper_stores"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumGlassPaintAndWallpaperStores
  | -- | Represents the JSON value @"glassware_crystal_stores"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumGlasswareCrystalStores
  | -- | Represents the JSON value @"golf_courses_public"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumGolfCoursesPublic
  | -- | Represents the JSON value @"government_services"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumGovernmentServices
  | -- | Represents the JSON value @"grocery_stores_supermarkets"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumGroceryStoresSupermarkets
  | -- | Represents the JSON value @"hardware_equipment_and_supplies"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumHardwareEquipmentAndSupplies
  | -- | Represents the JSON value @"hardware_stores"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumHardwareStores
  | -- | Represents the JSON value @"health_and_beauty_spas"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumHealthAndBeautySpas
  | -- | Represents the JSON value @"hearing_aids_sales_and_supplies"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumHearingAidsSalesAndSupplies
  | -- | Represents the JSON value @"heating_plumbing_a_c"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumHeatingPlumbingAC
  | -- | Represents the JSON value @"hobby_toy_and_game_shops"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumHobbyToyAndGameShops
  | -- | Represents the JSON value @"home_supply_warehouse_stores"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumHomeSupplyWarehouseStores
  | -- | Represents the JSON value @"hospitals"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumHospitals
  | -- | Represents the JSON value @"hotels_motels_and_resorts"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumHotelsMotelsAndResorts
  | -- | Represents the JSON value @"household_appliance_stores"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumHouseholdApplianceStores
  | -- | Represents the JSON value @"industrial_supplies"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumIndustrialSupplies
  | -- | Represents the JSON value @"information_retrieval_services"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumInformationRetrievalServices
  | -- | Represents the JSON value @"insurance_default"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumInsuranceDefault
  | -- | Represents the JSON value @"insurance_underwriting_premiums"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumInsuranceUnderwritingPremiums
  | -- | Represents the JSON value @"intra_company_purchases"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumIntraCompanyPurchases
  | -- | Represents the JSON value @"jewelry_stores_watches_clocks_and_silverware_stores"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumJewelryStoresWatchesClocksAndSilverwareStores
  | -- | Represents the JSON value @"landscaping_services"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumLandscapingServices
  | -- | Represents the JSON value @"laundries"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumLaundries
  | -- | Represents the JSON value @"laundry_cleaning_services"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumLaundryCleaningServices
  | -- | Represents the JSON value @"legal_services_attorneys"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumLegalServicesAttorneys
  | -- | Represents the JSON value @"luggage_and_leather_goods_stores"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumLuggageAndLeatherGoodsStores
  | -- | Represents the JSON value @"lumber_building_materials_stores"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumLumberBuildingMaterialsStores
  | -- | Represents the JSON value @"manual_cash_disburse"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumManualCashDisburse
  | -- | Represents the JSON value @"marinas_service_and_supplies"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumMarinasServiceAndSupplies
  | -- | Represents the JSON value @"masonry_stonework_and_plaster"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumMasonryStoneworkAndPlaster
  | -- | Represents the JSON value @"massage_parlors"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumMassageParlors
  | -- | Represents the JSON value @"medical_and_dental_labs"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumMedicalAndDentalLabs
  | -- | Represents the JSON value @"medical_dental_ophthalmic_and_hospital_equipment_and_supplies"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumMedicalDentalOphthalmicAndHospitalEquipmentAndSupplies
  | -- | Represents the JSON value @"medical_services"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumMedicalServices
  | -- | Represents the JSON value @"membership_organizations"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumMembershipOrganizations
  | -- | Represents the JSON value @"mens_and_boys_clothing_and_accessories_stores"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumMensAndBoysClothingAndAccessoriesStores
  | -- | Represents the JSON value @"mens_womens_clothing_stores"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumMensWomensClothingStores
  | -- | Represents the JSON value @"metal_service_centers"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumMetalServiceCenters
  | -- | Represents the JSON value @"miscellaneous"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumMiscellaneous
  | -- | Represents the JSON value @"miscellaneous_apparel_and_accessory_shops"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumMiscellaneousApparelAndAccessoryShops
  | -- | Represents the JSON value @"miscellaneous_auto_dealers"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumMiscellaneousAutoDealers
  | -- | Represents the JSON value @"miscellaneous_business_services"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumMiscellaneousBusinessServices
  | -- | Represents the JSON value @"miscellaneous_food_stores"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumMiscellaneousFoodStores
  | -- | Represents the JSON value @"miscellaneous_general_merchandise"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumMiscellaneousGeneralMerchandise
  | -- | Represents the JSON value @"miscellaneous_general_services"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumMiscellaneousGeneralServices
  | -- | Represents the JSON value @"miscellaneous_home_furnishing_specialty_stores"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumMiscellaneousHomeFurnishingSpecialtyStores
  | -- | Represents the JSON value @"miscellaneous_publishing_and_printing"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumMiscellaneousPublishingAndPrinting
  | -- | Represents the JSON value @"miscellaneous_recreation_services"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumMiscellaneousRecreationServices
  | -- | Represents the JSON value @"miscellaneous_repair_shops"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumMiscellaneousRepairShops
  | -- | Represents the JSON value @"miscellaneous_specialty_retail"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumMiscellaneousSpecialtyRetail
  | -- | Represents the JSON value @"mobile_home_dealers"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumMobileHomeDealers
  | -- | Represents the JSON value @"motion_picture_theaters"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumMotionPictureTheaters
  | -- | Represents the JSON value @"motor_freight_carriers_and_trucking"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumMotorFreightCarriersAndTrucking
  | -- | Represents the JSON value @"motor_homes_dealers"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumMotorHomesDealers
  | -- | Represents the JSON value @"motor_vehicle_supplies_and_new_parts"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumMotorVehicleSuppliesAndNewParts
  | -- | Represents the JSON value @"motorcycle_shops_and_dealers"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumMotorcycleShopsAndDealers
  | -- | Represents the JSON value @"motorcycle_shops_dealers"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumMotorcycleShopsDealers
  | -- | Represents the JSON value @"music_stores_musical_instruments_pianos_and_sheet_music"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumMusicStoresMusicalInstrumentsPianosAndSheetMusic
  | -- | Represents the JSON value @"news_dealers_and_newsstands"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumNewsDealersAndNewsstands
  | -- | Represents the JSON value @"non_fi_money_orders"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumNonFiMoneyOrders
  | -- | Represents the JSON value @"non_fi_stored_value_card_purchase_load"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumNonFiStoredValueCardPurchaseLoad
  | -- | Represents the JSON value @"nondurable_goods"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumNondurableGoods
  | -- | Represents the JSON value @"nurseries_lawn_and_garden_supply_stores"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumNurseriesLawnAndGardenSupplyStores
  | -- | Represents the JSON value @"nursing_personal_care"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumNursingPersonalCare
  | -- | Represents the JSON value @"office_and_commercial_furniture"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumOfficeAndCommercialFurniture
  | -- | Represents the JSON value @"opticians_eyeglasses"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumOpticiansEyeglasses
  | -- | Represents the JSON value @"optometrists_ophthalmologist"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumOptometristsOphthalmologist
  | -- | Represents the JSON value @"orthopedic_goods_prosthetic_devices"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumOrthopedicGoodsProstheticDevices
  | -- | Represents the JSON value @"osteopaths"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumOsteopaths
  | -- | Represents the JSON value @"package_stores_beer_wine_and_liquor"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumPackageStoresBeerWineAndLiquor
  | -- | Represents the JSON value @"paints_varnishes_and_supplies"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumPaintsVarnishesAndSupplies
  | -- | Represents the JSON value @"parking_lots_garages"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumParkingLotsGarages
  | -- | Represents the JSON value @"passenger_railways"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumPassengerRailways
  | -- | Represents the JSON value @"pawn_shops"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumPawnShops
  | -- | Represents the JSON value @"pet_shops_pet_food_and_supplies"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumPetShopsPetFoodAndSupplies
  | -- | Represents the JSON value @"petroleum_and_petroleum_products"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumPetroleumAndPetroleumProducts
  | -- | Represents the JSON value @"photo_developing"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumPhotoDeveloping
  | -- | Represents the JSON value @"photographic_photocopy_microfilm_equipment_and_supplies"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumPhotographicPhotocopyMicrofilmEquipmentAndSupplies
  | -- | Represents the JSON value @"photographic_studios"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumPhotographicStudios
  | -- | Represents the JSON value @"picture_video_production"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumPictureVideoProduction
  | -- | Represents the JSON value @"piece_goods_notions_and_other_dry_goods"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumPieceGoodsNotionsAndOtherDryGoods
  | -- | Represents the JSON value @"plumbing_heating_equipment_and_supplies"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumPlumbingHeatingEquipmentAndSupplies
  | -- | Represents the JSON value @"political_organizations"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumPoliticalOrganizations
  | -- | Represents the JSON value @"postal_services_government_only"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumPostalServicesGovernmentOnly
  | -- | Represents the JSON value @"precious_stones_and_metals_watches_and_jewelry"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumPreciousStonesAndMetalsWatchesAndJewelry
  | -- | Represents the JSON value @"professional_services"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumProfessionalServices
  | -- | Represents the JSON value @"public_warehousing_and_storage"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumPublicWarehousingAndStorage
  | -- | Represents the JSON value @"quick_copy_repro_and_blueprint"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumQuickCopyReproAndBlueprint
  | -- | Represents the JSON value @"railroads"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumRailroads
  | -- | Represents the JSON value @"real_estate_agents_and_managers_rentals"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumRealEstateAgentsAndManagersRentals
  | -- | Represents the JSON value @"record_stores"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumRecordStores
  | -- | Represents the JSON value @"recreational_vehicle_rentals"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumRecreationalVehicleRentals
  | -- | Represents the JSON value @"religious_goods_stores"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumReligiousGoodsStores
  | -- | Represents the JSON value @"religious_organizations"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumReligiousOrganizations
  | -- | Represents the JSON value @"roofing_siding_sheet_metal"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumRoofingSidingSheetMetal
  | -- | Represents the JSON value @"secretarial_support_services"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumSecretarialSupportServices
  | -- | Represents the JSON value @"security_brokers_dealers"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumSecurityBrokersDealers
  | -- | Represents the JSON value @"service_stations"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumServiceStations
  | -- | Represents the JSON value @"sewing_needlework_fabric_and_piece_goods_stores"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumSewingNeedleworkFabricAndPieceGoodsStores
  | -- | Represents the JSON value @"shoe_repair_hat_cleaning"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumShoeRepairHatCleaning
  | -- | Represents the JSON value @"shoe_stores"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumShoeStores
  | -- | Represents the JSON value @"small_appliance_repair"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumSmallApplianceRepair
  | -- | Represents the JSON value @"snowmobile_dealers"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumSnowmobileDealers
  | -- | Represents the JSON value @"special_trade_services"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumSpecialTradeServices
  | -- | Represents the JSON value @"specialty_cleaning"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumSpecialtyCleaning
  | -- | Represents the JSON value @"sporting_goods_stores"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumSportingGoodsStores
  | -- | Represents the JSON value @"sporting_recreation_camps"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumSportingRecreationCamps
  | -- | Represents the JSON value @"sports_and_riding_apparel_stores"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumSportsAndRidingApparelStores
  | -- | Represents the JSON value @"sports_clubs_fields"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumSportsClubsFields
  | -- | Represents the JSON value @"stamp_and_coin_stores"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumStampAndCoinStores
  | -- | Represents the JSON value @"stationary_office_supplies_printing_and_writing_paper"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumStationaryOfficeSuppliesPrintingAndWritingPaper
  | -- | Represents the JSON value @"stationery_stores_office_and_school_supply_stores"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumStationeryStoresOfficeAndSchoolSupplyStores
  | -- | Represents the JSON value @"swimming_pools_sales"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumSwimmingPoolsSales
  | -- | Represents the JSON value @"t_ui_travel_germany"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumTUiTravelGermany
  | -- | Represents the JSON value @"tailors_alterations"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumTailorsAlterations
  | -- | Represents the JSON value @"tax_payments_government_agencies"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumTaxPaymentsGovernmentAgencies
  | -- | Represents the JSON value @"tax_preparation_services"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumTaxPreparationServices
  | -- | Represents the JSON value @"taxicabs_limousines"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumTaxicabsLimousines
  | -- | Represents the JSON value @"telecommunication_equipment_and_telephone_sales"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumTelecommunicationEquipmentAndTelephoneSales
  | -- | Represents the JSON value @"telecommunication_services"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumTelecommunicationServices
  | -- | Represents the JSON value @"telegraph_services"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumTelegraphServices
  | -- | Represents the JSON value @"tent_and_awning_shops"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumTentAndAwningShops
  | -- | Represents the JSON value @"testing_laboratories"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumTestingLaboratories
  | -- | Represents the JSON value @"theatrical_ticket_agencies"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumTheatricalTicketAgencies
  | -- | Represents the JSON value @"timeshares"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumTimeshares
  | -- | Represents the JSON value @"tire_retreading_and_repair"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumTireRetreadingAndRepair
  | -- | Represents the JSON value @"tolls_bridge_fees"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumTollsBridgeFees
  | -- | Represents the JSON value @"tourist_attractions_and_exhibits"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumTouristAttractionsAndExhibits
  | -- | Represents the JSON value @"towing_services"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumTowingServices
  | -- | Represents the JSON value @"trailer_parks_campgrounds"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumTrailerParksCampgrounds
  | -- | Represents the JSON value @"transportation_services"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumTransportationServices
  | -- | Represents the JSON value @"travel_agencies_tour_operators"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumTravelAgenciesTourOperators
  | -- | Represents the JSON value @"truck_stop_iteration"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumTruckStopIteration
  | -- | Represents the JSON value @"truck_utility_trailer_rentals"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumTruckUtilityTrailerRentals
  | -- | Represents the JSON value @"typesetting_plate_making_and_related_services"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumTypesettingPlateMakingAndRelatedServices
  | -- | Represents the JSON value @"typewriter_stores"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumTypewriterStores
  | -- | Represents the JSON value @"u_s_federal_government_agencies_or_departments"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumUSFederalGovernmentAgenciesOrDepartments
  | -- | Represents the JSON value @"uniforms_commercial_clothing"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumUniformsCommercialClothing
  | -- | Represents the JSON value @"used_merchandise_and_secondhand_stores"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumUsedMerchandiseAndSecondhandStores
  | -- | Represents the JSON value @"utilities"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumUtilities
  | -- | Represents the JSON value @"variety_stores"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumVarietyStores
  | -- | Represents the JSON value @"veterinary_services"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumVeterinaryServices
  | -- | Represents the JSON value @"video_amusement_game_supplies"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumVideoAmusementGameSupplies
  | -- | Represents the JSON value @"video_game_arcades"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumVideoGameArcades
  | -- | Represents the JSON value @"video_tape_rental_stores"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumVideoTapeRentalStores
  | -- | Represents the JSON value @"vocational_trade_schools"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumVocationalTradeSchools
  | -- | Represents the JSON value @"watch_jewelry_repair"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumWatchJewelryRepair
  | -- | Represents the JSON value @"welding_repair"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumWeldingRepair
  | -- | Represents the JSON value @"wholesale_clubs"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumWholesaleClubs
  | -- | Represents the JSON value @"wig_and_toupee_stores"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumWigAndToupeeStores
  | -- | Represents the JSON value @"wires_money_orders"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumWiresMoneyOrders
  | -- | Represents the JSON value @"womens_accessory_and_specialty_shops"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumWomensAccessoryAndSpecialtyShops
  | -- | Represents the JSON value @"womens_ready_to_wear_stores"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumWomensReadyToWearStores
  | -- | Represents the JSON value @"wrecking_and_salvage_yards"@
    Issuing'cardholderSpendingControls'BlockedCategories'EnumWreckingAndSalvageYards
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON Issuing'cardholderSpendingControls'BlockedCategories' where
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'Other val) = val
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'Typed val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumAcRefrigerationRepair) = "ac_refrigeration_repair"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumAccountingBookkeepingServices) = "accounting_bookkeeping_services"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumAdvertisingServices) = "advertising_services"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumAgriculturalCooperative) = "agricultural_cooperative"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumAirlinesAirCarriers) = "airlines_air_carriers"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumAirportsFlyingFields) = "airports_flying_fields"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumAmbulanceServices) = "ambulance_services"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumAmusementParksCarnivals) = "amusement_parks_carnivals"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumAntiqueReproductions) = "antique_reproductions"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumAntiqueShops) = "antique_shops"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumAquariums) = "aquariums"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumArchitecturalSurveyingServices) = "architectural_surveying_services"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumArtDealersAndGalleries) = "art_dealers_and_galleries"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumArtistsSupplyAndCraftShops) = "artists_supply_and_craft_shops"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumAutoAndHomeSupplyStores) = "auto_and_home_supply_stores"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumAutoBodyRepairShops) = "auto_body_repair_shops"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumAutoPaintShops) = "auto_paint_shops"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumAutoServiceShops) = "auto_service_shops"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumAutomatedCashDisburse) = "automated_cash_disburse"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumAutomatedFuelDispensers) = "automated_fuel_dispensers"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumAutomobileAssociations) = "automobile_associations"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumAutomotivePartsAndAccessoriesStores) = "automotive_parts_and_accessories_stores"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumAutomotiveTireStores) = "automotive_tire_stores"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumBailAndBondPayments) = "bail_and_bond_payments"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumBakeries) = "bakeries"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumBandsOrchestras) = "bands_orchestras"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumBarberAndBeautyShops) = "barber_and_beauty_shops"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumBettingCasinoGambling) = "betting_casino_gambling"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumBicycleShops) = "bicycle_shops"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumBilliardPoolEstablishments) = "billiard_pool_establishments"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumBoatDealers) = "boat_dealers"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumBoatRentalsAndLeases) = "boat_rentals_and_leases"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumBookStores) = "book_stores"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumBooksPeriodicalsAndNewspapers) = "books_periodicals_and_newspapers"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumBowlingAlleys) = "bowling_alleys"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumBusLines) = "bus_lines"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumBusinessSecretarialSchools) = "business_secretarial_schools"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumBuyingShoppingServices) = "buying_shopping_services"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumCableSatelliteAndOtherPayTelevisionAndRadio) = "cable_satellite_and_other_pay_television_and_radio"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumCameraAndPhotographicSupplyStores) = "camera_and_photographic_supply_stores"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumCandyNutAndConfectioneryStores) = "candy_nut_and_confectionery_stores"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumCarAndTruckDealersNewUsed) = "car_and_truck_dealers_new_used"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumCarAndTruckDealersUsedOnly) = "car_and_truck_dealers_used_only"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumCarRentalAgencies) = "car_rental_agencies"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumCarWashes) = "car_washes"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumCarpentryServices) = "carpentry_services"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumCarpetUpholsteryCleaning) = "carpet_upholstery_cleaning"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumCaterers) = "caterers"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumCharitableAndSocialServiceOrganizationsFundraising) = "charitable_and_social_service_organizations_fundraising"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumChemicalsAndAlliedProducts) = "chemicals_and_allied_products"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumChildCareServices) = "child_care_services"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumChildrensAndInfantsWearStores) = "childrens_and_infants_wear_stores"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumChiropodistsPodiatrists) = "chiropodists_podiatrists"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumChiropractors) = "chiropractors"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumCigarStoresAndStands) = "cigar_stores_and_stands"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumCivicSocialFraternalAssociations) = "civic_social_fraternal_associations"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumCleaningAndMaintenance) = "cleaning_and_maintenance"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumClothingRental) = "clothing_rental"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumCollegesUniversities) = "colleges_universities"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumCommercialEquipment) = "commercial_equipment"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumCommercialFootwear) = "commercial_footwear"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumCommercialPhotographyArtAndGraphics) = "commercial_photography_art_and_graphics"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumCommuterTransportAndFerries) = "commuter_transport_and_ferries"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumComputerNetworkServices) = "computer_network_services"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumComputerProgramming) = "computer_programming"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumComputerRepair) = "computer_repair"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumComputerSoftwareStores) = "computer_software_stores"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumComputersPeripheralsAndSoftware) = "computers_peripherals_and_software"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumConcreteWorkServices) = "concrete_work_services"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumConstructionMaterials) = "construction_materials"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumConsultingPublicRelations) = "consulting_public_relations"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumCorrespondenceSchools) = "correspondence_schools"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumCosmeticStores) = "cosmetic_stores"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumCounselingServices) = "counseling_services"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumCountryClubs) = "country_clubs"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumCourierServices) = "courier_services"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumCourtCosts) = "court_costs"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumCreditReportingAgencies) = "credit_reporting_agencies"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumCruiseLines) = "cruise_lines"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumDairyProductsStores) = "dairy_products_stores"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumDanceHallStudiosSchools) = "dance_hall_studios_schools"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumDatingEscortServices) = "dating_escort_services"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumDentistsOrthodontists) = "dentists_orthodontists"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumDepartmentStores) = "department_stores"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumDetectiveAgencies) = "detective_agencies"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumDigitalGoodsApplications) = "digital_goods_applications"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumDigitalGoodsGames) = "digital_goods_games"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumDigitalGoodsLargeVolume) = "digital_goods_large_volume"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumDigitalGoodsMedia) = "digital_goods_media"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumDirectMarketingCatalogMerchant) = "direct_marketing_catalog_merchant"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumDirectMarketingCombinationCatalogAndRetailMerchant) = "direct_marketing_combination_catalog_and_retail_merchant"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumDirectMarketingInboundTelemarketing) = "direct_marketing_inbound_telemarketing"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumDirectMarketingInsuranceServices) = "direct_marketing_insurance_services"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumDirectMarketingOther) = "direct_marketing_other"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumDirectMarketingOutboundTelemarketing) = "direct_marketing_outbound_telemarketing"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumDirectMarketingSubscription) = "direct_marketing_subscription"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumDirectMarketingTravel) = "direct_marketing_travel"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumDiscountStores) = "discount_stores"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumDoctors) = "doctors"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumDoorToDoorSales) = "door_to_door_sales"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumDraperyWindowCoveringAndUpholsteryStores) = "drapery_window_covering_and_upholstery_stores"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumDrinkingPlaces) = "drinking_places"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumDrugStoresAndPharmacies) = "drug_stores_and_pharmacies"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumDrugsDrugProprietariesAndDruggistSundries) = "drugs_drug_proprietaries_and_druggist_sundries"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumDryCleaners) = "dry_cleaners"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumDurableGoods) = "durable_goods"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumDutyFreeStores) = "duty_free_stores"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumEatingPlacesRestaurants) = "eating_places_restaurants"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumEducationalServices) = "educational_services"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumElectricRazorStores) = "electric_razor_stores"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumElectricalPartsAndEquipment) = "electrical_parts_and_equipment"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumElectricalServices) = "electrical_services"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumElectronicsRepairShops) = "electronics_repair_shops"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumElectronicsStores) = "electronics_stores"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumElementarySecondarySchools) = "elementary_secondary_schools"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumEmploymentTempAgencies) = "employment_temp_agencies"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumEquipmentRental) = "equipment_rental"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumExterminatingServices) = "exterminating_services"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumFamilyClothingStores) = "family_clothing_stores"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumFastFoodRestaurants) = "fast_food_restaurants"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumFinancialInstitutions) = "financial_institutions"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumFinesGovernmentAdministrativeEntities) = "fines_government_administrative_entities"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumFireplaceFireplaceScreensAndAccessoriesStores) = "fireplace_fireplace_screens_and_accessories_stores"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumFloorCoveringStores) = "floor_covering_stores"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumFlorists) = "florists"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumFloristsSuppliesNurseryStockAndFlowers) = "florists_supplies_nursery_stock_and_flowers"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumFreezerAndLockerMeatProvisioners) = "freezer_and_locker_meat_provisioners"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumFuelDealersNonAutomotive) = "fuel_dealers_non_automotive"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumFuneralServicesCrematories) = "funeral_services_crematories"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumFurnitureHomeFurnishingsAndEquipmentStoresExceptAppliances) = "furniture_home_furnishings_and_equipment_stores_except_appliances"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumFurnitureRepairRefinishing) = "furniture_repair_refinishing"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumFurriersAndFurShops) = "furriers_and_fur_shops"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumGeneralServices) = "general_services"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumGiftCardNoveltyAndSouvenirShops) = "gift_card_novelty_and_souvenir_shops"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumGlassPaintAndWallpaperStores) = "glass_paint_and_wallpaper_stores"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumGlasswareCrystalStores) = "glassware_crystal_stores"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumGolfCoursesPublic) = "golf_courses_public"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumGovernmentServices) = "government_services"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumGroceryStoresSupermarkets) = "grocery_stores_supermarkets"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumHardwareEquipmentAndSupplies) = "hardware_equipment_and_supplies"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumHardwareStores) = "hardware_stores"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumHealthAndBeautySpas) = "health_and_beauty_spas"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumHearingAidsSalesAndSupplies) = "hearing_aids_sales_and_supplies"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumHeatingPlumbingAC) = "heating_plumbing_a_c"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumHobbyToyAndGameShops) = "hobby_toy_and_game_shops"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumHomeSupplyWarehouseStores) = "home_supply_warehouse_stores"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumHospitals) = "hospitals"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumHotelsMotelsAndResorts) = "hotels_motels_and_resorts"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumHouseholdApplianceStores) = "household_appliance_stores"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumIndustrialSupplies) = "industrial_supplies"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumInformationRetrievalServices) = "information_retrieval_services"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumInsuranceDefault) = "insurance_default"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumInsuranceUnderwritingPremiums) = "insurance_underwriting_premiums"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumIntraCompanyPurchases) = "intra_company_purchases"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumJewelryStoresWatchesClocksAndSilverwareStores) = "jewelry_stores_watches_clocks_and_silverware_stores"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumLandscapingServices) = "landscaping_services"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumLaundries) = "laundries"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumLaundryCleaningServices) = "laundry_cleaning_services"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumLegalServicesAttorneys) = "legal_services_attorneys"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumLuggageAndLeatherGoodsStores) = "luggage_and_leather_goods_stores"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumLumberBuildingMaterialsStores) = "lumber_building_materials_stores"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumManualCashDisburse) = "manual_cash_disburse"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumMarinasServiceAndSupplies) = "marinas_service_and_supplies"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumMasonryStoneworkAndPlaster) = "masonry_stonework_and_plaster"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumMassageParlors) = "massage_parlors"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumMedicalAndDentalLabs) = "medical_and_dental_labs"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumMedicalDentalOphthalmicAndHospitalEquipmentAndSupplies) = "medical_dental_ophthalmic_and_hospital_equipment_and_supplies"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumMedicalServices) = "medical_services"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumMembershipOrganizations) = "membership_organizations"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumMensAndBoysClothingAndAccessoriesStores) = "mens_and_boys_clothing_and_accessories_stores"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumMensWomensClothingStores) = "mens_womens_clothing_stores"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumMetalServiceCenters) = "metal_service_centers"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumMiscellaneous) = "miscellaneous"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumMiscellaneousApparelAndAccessoryShops) = "miscellaneous_apparel_and_accessory_shops"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumMiscellaneousAutoDealers) = "miscellaneous_auto_dealers"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumMiscellaneousBusinessServices) = "miscellaneous_business_services"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumMiscellaneousFoodStores) = "miscellaneous_food_stores"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumMiscellaneousGeneralMerchandise) = "miscellaneous_general_merchandise"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumMiscellaneousGeneralServices) = "miscellaneous_general_services"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumMiscellaneousHomeFurnishingSpecialtyStores) = "miscellaneous_home_furnishing_specialty_stores"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumMiscellaneousPublishingAndPrinting) = "miscellaneous_publishing_and_printing"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumMiscellaneousRecreationServices) = "miscellaneous_recreation_services"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumMiscellaneousRepairShops) = "miscellaneous_repair_shops"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumMiscellaneousSpecialtyRetail) = "miscellaneous_specialty_retail"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumMobileHomeDealers) = "mobile_home_dealers"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumMotionPictureTheaters) = "motion_picture_theaters"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumMotorFreightCarriersAndTrucking) = "motor_freight_carriers_and_trucking"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumMotorHomesDealers) = "motor_homes_dealers"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumMotorVehicleSuppliesAndNewParts) = "motor_vehicle_supplies_and_new_parts"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumMotorcycleShopsAndDealers) = "motorcycle_shops_and_dealers"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumMotorcycleShopsDealers) = "motorcycle_shops_dealers"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumMusicStoresMusicalInstrumentsPianosAndSheetMusic) = "music_stores_musical_instruments_pianos_and_sheet_music"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumNewsDealersAndNewsstands) = "news_dealers_and_newsstands"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumNonFiMoneyOrders) = "non_fi_money_orders"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumNonFiStoredValueCardPurchaseLoad) = "non_fi_stored_value_card_purchase_load"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumNondurableGoods) = "nondurable_goods"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumNurseriesLawnAndGardenSupplyStores) = "nurseries_lawn_and_garden_supply_stores"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumNursingPersonalCare) = "nursing_personal_care"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumOfficeAndCommercialFurniture) = "office_and_commercial_furniture"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumOpticiansEyeglasses) = "opticians_eyeglasses"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumOptometristsOphthalmologist) = "optometrists_ophthalmologist"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumOrthopedicGoodsProstheticDevices) = "orthopedic_goods_prosthetic_devices"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumOsteopaths) = "osteopaths"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumPackageStoresBeerWineAndLiquor) = "package_stores_beer_wine_and_liquor"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumPaintsVarnishesAndSupplies) = "paints_varnishes_and_supplies"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumParkingLotsGarages) = "parking_lots_garages"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumPassengerRailways) = "passenger_railways"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumPawnShops) = "pawn_shops"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumPetShopsPetFoodAndSupplies) = "pet_shops_pet_food_and_supplies"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumPetroleumAndPetroleumProducts) = "petroleum_and_petroleum_products"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumPhotoDeveloping) = "photo_developing"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumPhotographicPhotocopyMicrofilmEquipmentAndSupplies) = "photographic_photocopy_microfilm_equipment_and_supplies"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumPhotographicStudios) = "photographic_studios"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumPictureVideoProduction) = "picture_video_production"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumPieceGoodsNotionsAndOtherDryGoods) = "piece_goods_notions_and_other_dry_goods"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumPlumbingHeatingEquipmentAndSupplies) = "plumbing_heating_equipment_and_supplies"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumPoliticalOrganizations) = "political_organizations"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumPostalServicesGovernmentOnly) = "postal_services_government_only"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumPreciousStonesAndMetalsWatchesAndJewelry) = "precious_stones_and_metals_watches_and_jewelry"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumProfessionalServices) = "professional_services"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumPublicWarehousingAndStorage) = "public_warehousing_and_storage"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumQuickCopyReproAndBlueprint) = "quick_copy_repro_and_blueprint"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumRailroads) = "railroads"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumRealEstateAgentsAndManagersRentals) = "real_estate_agents_and_managers_rentals"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumRecordStores) = "record_stores"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumRecreationalVehicleRentals) = "recreational_vehicle_rentals"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumReligiousGoodsStores) = "religious_goods_stores"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumReligiousOrganizations) = "religious_organizations"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumRoofingSidingSheetMetal) = "roofing_siding_sheet_metal"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumSecretarialSupportServices) = "secretarial_support_services"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumSecurityBrokersDealers) = "security_brokers_dealers"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumServiceStations) = "service_stations"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumSewingNeedleworkFabricAndPieceGoodsStores) = "sewing_needlework_fabric_and_piece_goods_stores"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumShoeRepairHatCleaning) = "shoe_repair_hat_cleaning"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumShoeStores) = "shoe_stores"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumSmallApplianceRepair) = "small_appliance_repair"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumSnowmobileDealers) = "snowmobile_dealers"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumSpecialTradeServices) = "special_trade_services"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumSpecialtyCleaning) = "specialty_cleaning"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumSportingGoodsStores) = "sporting_goods_stores"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumSportingRecreationCamps) = "sporting_recreation_camps"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumSportsAndRidingApparelStores) = "sports_and_riding_apparel_stores"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumSportsClubsFields) = "sports_clubs_fields"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumStampAndCoinStores) = "stamp_and_coin_stores"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumStationaryOfficeSuppliesPrintingAndWritingPaper) = "stationary_office_supplies_printing_and_writing_paper"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumStationeryStoresOfficeAndSchoolSupplyStores) = "stationery_stores_office_and_school_supply_stores"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumSwimmingPoolsSales) = "swimming_pools_sales"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumTUiTravelGermany) = "t_ui_travel_germany"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumTailorsAlterations) = "tailors_alterations"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumTaxPaymentsGovernmentAgencies) = "tax_payments_government_agencies"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumTaxPreparationServices) = "tax_preparation_services"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumTaxicabsLimousines) = "taxicabs_limousines"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumTelecommunicationEquipmentAndTelephoneSales) = "telecommunication_equipment_and_telephone_sales"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumTelecommunicationServices) = "telecommunication_services"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumTelegraphServices) = "telegraph_services"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumTentAndAwningShops) = "tent_and_awning_shops"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumTestingLaboratories) = "testing_laboratories"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumTheatricalTicketAgencies) = "theatrical_ticket_agencies"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumTimeshares) = "timeshares"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumTireRetreadingAndRepair) = "tire_retreading_and_repair"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumTollsBridgeFees) = "tolls_bridge_fees"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumTouristAttractionsAndExhibits) = "tourist_attractions_and_exhibits"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumTowingServices) = "towing_services"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumTrailerParksCampgrounds) = "trailer_parks_campgrounds"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumTransportationServices) = "transportation_services"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumTravelAgenciesTourOperators) = "travel_agencies_tour_operators"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumTruckStopIteration) = "truck_stop_iteration"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumTruckUtilityTrailerRentals) = "truck_utility_trailer_rentals"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumTypesettingPlateMakingAndRelatedServices) = "typesetting_plate_making_and_related_services"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumTypewriterStores) = "typewriter_stores"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumUSFederalGovernmentAgenciesOrDepartments) = "u_s_federal_government_agencies_or_departments"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumUniformsCommercialClothing) = "uniforms_commercial_clothing"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumUsedMerchandiseAndSecondhandStores) = "used_merchandise_and_secondhand_stores"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumUtilities) = "utilities"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumVarietyStores) = "variety_stores"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumVeterinaryServices) = "veterinary_services"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumVideoAmusementGameSupplies) = "video_amusement_game_supplies"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumVideoGameArcades) = "video_game_arcades"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumVideoTapeRentalStores) = "video_tape_rental_stores"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumVocationalTradeSchools) = "vocational_trade_schools"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumWatchJewelryRepair) = "watch_jewelry_repair"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumWeldingRepair) = "welding_repair"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumWholesaleClubs) = "wholesale_clubs"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumWigAndToupeeStores) = "wig_and_toupee_stores"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumWiresMoneyOrders) = "wires_money_orders"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumWomensAccessoryAndSpecialtyShops) = "womens_accessory_and_specialty_shops"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumWomensReadyToWearStores) = "womens_ready_to_wear_stores"
  toJSON (Issuing'cardholderSpendingControls'BlockedCategories'EnumWreckingAndSalvageYards) = "wrecking_and_salvage_yards"

instance Data.Aeson.Types.FromJSON.FromJSON Issuing'cardholderSpendingControls'BlockedCategories' where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "ac_refrigeration_repair" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumAcRefrigerationRepair
            | val GHC.Classes.== "accounting_bookkeeping_services" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumAccountingBookkeepingServices
            | val GHC.Classes.== "advertising_services" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumAdvertisingServices
            | val GHC.Classes.== "agricultural_cooperative" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumAgriculturalCooperative
            | val GHC.Classes.== "airlines_air_carriers" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumAirlinesAirCarriers
            | val GHC.Classes.== "airports_flying_fields" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumAirportsFlyingFields
            | val GHC.Classes.== "ambulance_services" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumAmbulanceServices
            | val GHC.Classes.== "amusement_parks_carnivals" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumAmusementParksCarnivals
            | val GHC.Classes.== "antique_reproductions" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumAntiqueReproductions
            | val GHC.Classes.== "antique_shops" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumAntiqueShops
            | val GHC.Classes.== "aquariums" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumAquariums
            | val GHC.Classes.== "architectural_surveying_services" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumArchitecturalSurveyingServices
            | val GHC.Classes.== "art_dealers_and_galleries" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumArtDealersAndGalleries
            | val GHC.Classes.== "artists_supply_and_craft_shops" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumArtistsSupplyAndCraftShops
            | val GHC.Classes.== "auto_and_home_supply_stores" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumAutoAndHomeSupplyStores
            | val GHC.Classes.== "auto_body_repair_shops" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumAutoBodyRepairShops
            | val GHC.Classes.== "auto_paint_shops" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumAutoPaintShops
            | val GHC.Classes.== "auto_service_shops" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumAutoServiceShops
            | val GHC.Classes.== "automated_cash_disburse" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumAutomatedCashDisburse
            | val GHC.Classes.== "automated_fuel_dispensers" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumAutomatedFuelDispensers
            | val GHC.Classes.== "automobile_associations" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumAutomobileAssociations
            | val GHC.Classes.== "automotive_parts_and_accessories_stores" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumAutomotivePartsAndAccessoriesStores
            | val GHC.Classes.== "automotive_tire_stores" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumAutomotiveTireStores
            | val GHC.Classes.== "bail_and_bond_payments" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumBailAndBondPayments
            | val GHC.Classes.== "bakeries" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumBakeries
            | val GHC.Classes.== "bands_orchestras" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumBandsOrchestras
            | val GHC.Classes.== "barber_and_beauty_shops" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumBarberAndBeautyShops
            | val GHC.Classes.== "betting_casino_gambling" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumBettingCasinoGambling
            | val GHC.Classes.== "bicycle_shops" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumBicycleShops
            | val GHC.Classes.== "billiard_pool_establishments" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumBilliardPoolEstablishments
            | val GHC.Classes.== "boat_dealers" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumBoatDealers
            | val GHC.Classes.== "boat_rentals_and_leases" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumBoatRentalsAndLeases
            | val GHC.Classes.== "book_stores" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumBookStores
            | val GHC.Classes.== "books_periodicals_and_newspapers" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumBooksPeriodicalsAndNewspapers
            | val GHC.Classes.== "bowling_alleys" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumBowlingAlleys
            | val GHC.Classes.== "bus_lines" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumBusLines
            | val GHC.Classes.== "business_secretarial_schools" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumBusinessSecretarialSchools
            | val GHC.Classes.== "buying_shopping_services" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumBuyingShoppingServices
            | val GHC.Classes.== "cable_satellite_and_other_pay_television_and_radio" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumCableSatelliteAndOtherPayTelevisionAndRadio
            | val GHC.Classes.== "camera_and_photographic_supply_stores" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumCameraAndPhotographicSupplyStores
            | val GHC.Classes.== "candy_nut_and_confectionery_stores" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumCandyNutAndConfectioneryStores
            | val GHC.Classes.== "car_and_truck_dealers_new_used" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumCarAndTruckDealersNewUsed
            | val GHC.Classes.== "car_and_truck_dealers_used_only" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumCarAndTruckDealersUsedOnly
            | val GHC.Classes.== "car_rental_agencies" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumCarRentalAgencies
            | val GHC.Classes.== "car_washes" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumCarWashes
            | val GHC.Classes.== "carpentry_services" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumCarpentryServices
            | val GHC.Classes.== "carpet_upholstery_cleaning" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumCarpetUpholsteryCleaning
            | val GHC.Classes.== "caterers" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumCaterers
            | val GHC.Classes.== "charitable_and_social_service_organizations_fundraising" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumCharitableAndSocialServiceOrganizationsFundraising
            | val GHC.Classes.== "chemicals_and_allied_products" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumChemicalsAndAlliedProducts
            | val GHC.Classes.== "child_care_services" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumChildCareServices
            | val GHC.Classes.== "childrens_and_infants_wear_stores" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumChildrensAndInfantsWearStores
            | val GHC.Classes.== "chiropodists_podiatrists" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumChiropodistsPodiatrists
            | val GHC.Classes.== "chiropractors" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumChiropractors
            | val GHC.Classes.== "cigar_stores_and_stands" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumCigarStoresAndStands
            | val GHC.Classes.== "civic_social_fraternal_associations" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumCivicSocialFraternalAssociations
            | val GHC.Classes.== "cleaning_and_maintenance" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumCleaningAndMaintenance
            | val GHC.Classes.== "clothing_rental" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumClothingRental
            | val GHC.Classes.== "colleges_universities" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumCollegesUniversities
            | val GHC.Classes.== "commercial_equipment" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumCommercialEquipment
            | val GHC.Classes.== "commercial_footwear" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumCommercialFootwear
            | val GHC.Classes.== "commercial_photography_art_and_graphics" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumCommercialPhotographyArtAndGraphics
            | val GHC.Classes.== "commuter_transport_and_ferries" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumCommuterTransportAndFerries
            | val GHC.Classes.== "computer_network_services" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumComputerNetworkServices
            | val GHC.Classes.== "computer_programming" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumComputerProgramming
            | val GHC.Classes.== "computer_repair" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumComputerRepair
            | val GHC.Classes.== "computer_software_stores" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumComputerSoftwareStores
            | val GHC.Classes.== "computers_peripherals_and_software" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumComputersPeripheralsAndSoftware
            | val GHC.Classes.== "concrete_work_services" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumConcreteWorkServices
            | val GHC.Classes.== "construction_materials" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumConstructionMaterials
            | val GHC.Classes.== "consulting_public_relations" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumConsultingPublicRelations
            | val GHC.Classes.== "correspondence_schools" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumCorrespondenceSchools
            | val GHC.Classes.== "cosmetic_stores" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumCosmeticStores
            | val GHC.Classes.== "counseling_services" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumCounselingServices
            | val GHC.Classes.== "country_clubs" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumCountryClubs
            | val GHC.Classes.== "courier_services" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumCourierServices
            | val GHC.Classes.== "court_costs" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumCourtCosts
            | val GHC.Classes.== "credit_reporting_agencies" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumCreditReportingAgencies
            | val GHC.Classes.== "cruise_lines" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumCruiseLines
            | val GHC.Classes.== "dairy_products_stores" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumDairyProductsStores
            | val GHC.Classes.== "dance_hall_studios_schools" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumDanceHallStudiosSchools
            | val GHC.Classes.== "dating_escort_services" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumDatingEscortServices
            | val GHC.Classes.== "dentists_orthodontists" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumDentistsOrthodontists
            | val GHC.Classes.== "department_stores" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumDepartmentStores
            | val GHC.Classes.== "detective_agencies" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumDetectiveAgencies
            | val GHC.Classes.== "digital_goods_applications" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumDigitalGoodsApplications
            | val GHC.Classes.== "digital_goods_games" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumDigitalGoodsGames
            | val GHC.Classes.== "digital_goods_large_volume" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumDigitalGoodsLargeVolume
            | val GHC.Classes.== "digital_goods_media" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumDigitalGoodsMedia
            | val GHC.Classes.== "direct_marketing_catalog_merchant" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumDirectMarketingCatalogMerchant
            | val GHC.Classes.== "direct_marketing_combination_catalog_and_retail_merchant" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumDirectMarketingCombinationCatalogAndRetailMerchant
            | val GHC.Classes.== "direct_marketing_inbound_telemarketing" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumDirectMarketingInboundTelemarketing
            | val GHC.Classes.== "direct_marketing_insurance_services" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumDirectMarketingInsuranceServices
            | val GHC.Classes.== "direct_marketing_other" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumDirectMarketingOther
            | val GHC.Classes.== "direct_marketing_outbound_telemarketing" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumDirectMarketingOutboundTelemarketing
            | val GHC.Classes.== "direct_marketing_subscription" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumDirectMarketingSubscription
            | val GHC.Classes.== "direct_marketing_travel" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumDirectMarketingTravel
            | val GHC.Classes.== "discount_stores" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumDiscountStores
            | val GHC.Classes.== "doctors" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumDoctors
            | val GHC.Classes.== "door_to_door_sales" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumDoorToDoorSales
            | val GHC.Classes.== "drapery_window_covering_and_upholstery_stores" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumDraperyWindowCoveringAndUpholsteryStores
            | val GHC.Classes.== "drinking_places" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumDrinkingPlaces
            | val GHC.Classes.== "drug_stores_and_pharmacies" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumDrugStoresAndPharmacies
            | val GHC.Classes.== "drugs_drug_proprietaries_and_druggist_sundries" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumDrugsDrugProprietariesAndDruggistSundries
            | val GHC.Classes.== "dry_cleaners" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumDryCleaners
            | val GHC.Classes.== "durable_goods" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumDurableGoods
            | val GHC.Classes.== "duty_free_stores" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumDutyFreeStores
            | val GHC.Classes.== "eating_places_restaurants" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumEatingPlacesRestaurants
            | val GHC.Classes.== "educational_services" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumEducationalServices
            | val GHC.Classes.== "electric_razor_stores" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumElectricRazorStores
            | val GHC.Classes.== "electrical_parts_and_equipment" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumElectricalPartsAndEquipment
            | val GHC.Classes.== "electrical_services" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumElectricalServices
            | val GHC.Classes.== "electronics_repair_shops" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumElectronicsRepairShops
            | val GHC.Classes.== "electronics_stores" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumElectronicsStores
            | val GHC.Classes.== "elementary_secondary_schools" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumElementarySecondarySchools
            | val GHC.Classes.== "employment_temp_agencies" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumEmploymentTempAgencies
            | val GHC.Classes.== "equipment_rental" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumEquipmentRental
            | val GHC.Classes.== "exterminating_services" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumExterminatingServices
            | val GHC.Classes.== "family_clothing_stores" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumFamilyClothingStores
            | val GHC.Classes.== "fast_food_restaurants" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumFastFoodRestaurants
            | val GHC.Classes.== "financial_institutions" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumFinancialInstitutions
            | val GHC.Classes.== "fines_government_administrative_entities" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumFinesGovernmentAdministrativeEntities
            | val GHC.Classes.== "fireplace_fireplace_screens_and_accessories_stores" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumFireplaceFireplaceScreensAndAccessoriesStores
            | val GHC.Classes.== "floor_covering_stores" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumFloorCoveringStores
            | val GHC.Classes.== "florists" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumFlorists
            | val GHC.Classes.== "florists_supplies_nursery_stock_and_flowers" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumFloristsSuppliesNurseryStockAndFlowers
            | val GHC.Classes.== "freezer_and_locker_meat_provisioners" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumFreezerAndLockerMeatProvisioners
            | val GHC.Classes.== "fuel_dealers_non_automotive" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumFuelDealersNonAutomotive
            | val GHC.Classes.== "funeral_services_crematories" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumFuneralServicesCrematories
            | val GHC.Classes.== "furniture_home_furnishings_and_equipment_stores_except_appliances" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumFurnitureHomeFurnishingsAndEquipmentStoresExceptAppliances
            | val GHC.Classes.== "furniture_repair_refinishing" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumFurnitureRepairRefinishing
            | val GHC.Classes.== "furriers_and_fur_shops" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumFurriersAndFurShops
            | val GHC.Classes.== "general_services" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumGeneralServices
            | val GHC.Classes.== "gift_card_novelty_and_souvenir_shops" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumGiftCardNoveltyAndSouvenirShops
            | val GHC.Classes.== "glass_paint_and_wallpaper_stores" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumGlassPaintAndWallpaperStores
            | val GHC.Classes.== "glassware_crystal_stores" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumGlasswareCrystalStores
            | val GHC.Classes.== "golf_courses_public" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumGolfCoursesPublic
            | val GHC.Classes.== "government_services" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumGovernmentServices
            | val GHC.Classes.== "grocery_stores_supermarkets" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumGroceryStoresSupermarkets
            | val GHC.Classes.== "hardware_equipment_and_supplies" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumHardwareEquipmentAndSupplies
            | val GHC.Classes.== "hardware_stores" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumHardwareStores
            | val GHC.Classes.== "health_and_beauty_spas" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumHealthAndBeautySpas
            | val GHC.Classes.== "hearing_aids_sales_and_supplies" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumHearingAidsSalesAndSupplies
            | val GHC.Classes.== "heating_plumbing_a_c" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumHeatingPlumbingAC
            | val GHC.Classes.== "hobby_toy_and_game_shops" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumHobbyToyAndGameShops
            | val GHC.Classes.== "home_supply_warehouse_stores" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumHomeSupplyWarehouseStores
            | val GHC.Classes.== "hospitals" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumHospitals
            | val GHC.Classes.== "hotels_motels_and_resorts" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumHotelsMotelsAndResorts
            | val GHC.Classes.== "household_appliance_stores" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumHouseholdApplianceStores
            | val GHC.Classes.== "industrial_supplies" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumIndustrialSupplies
            | val GHC.Classes.== "information_retrieval_services" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumInformationRetrievalServices
            | val GHC.Classes.== "insurance_default" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumInsuranceDefault
            | val GHC.Classes.== "insurance_underwriting_premiums" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumInsuranceUnderwritingPremiums
            | val GHC.Classes.== "intra_company_purchases" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumIntraCompanyPurchases
            | val GHC.Classes.== "jewelry_stores_watches_clocks_and_silverware_stores" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumJewelryStoresWatchesClocksAndSilverwareStores
            | val GHC.Classes.== "landscaping_services" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumLandscapingServices
            | val GHC.Classes.== "laundries" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumLaundries
            | val GHC.Classes.== "laundry_cleaning_services" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumLaundryCleaningServices
            | val GHC.Classes.== "legal_services_attorneys" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumLegalServicesAttorneys
            | val GHC.Classes.== "luggage_and_leather_goods_stores" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumLuggageAndLeatherGoodsStores
            | val GHC.Classes.== "lumber_building_materials_stores" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumLumberBuildingMaterialsStores
            | val GHC.Classes.== "manual_cash_disburse" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumManualCashDisburse
            | val GHC.Classes.== "marinas_service_and_supplies" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumMarinasServiceAndSupplies
            | val GHC.Classes.== "masonry_stonework_and_plaster" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumMasonryStoneworkAndPlaster
            | val GHC.Classes.== "massage_parlors" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumMassageParlors
            | val GHC.Classes.== "medical_and_dental_labs" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumMedicalAndDentalLabs
            | val GHC.Classes.== "medical_dental_ophthalmic_and_hospital_equipment_and_supplies" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumMedicalDentalOphthalmicAndHospitalEquipmentAndSupplies
            | val GHC.Classes.== "medical_services" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumMedicalServices
            | val GHC.Classes.== "membership_organizations" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumMembershipOrganizations
            | val GHC.Classes.== "mens_and_boys_clothing_and_accessories_stores" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumMensAndBoysClothingAndAccessoriesStores
            | val GHC.Classes.== "mens_womens_clothing_stores" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumMensWomensClothingStores
            | val GHC.Classes.== "metal_service_centers" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumMetalServiceCenters
            | val GHC.Classes.== "miscellaneous" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumMiscellaneous
            | val GHC.Classes.== "miscellaneous_apparel_and_accessory_shops" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumMiscellaneousApparelAndAccessoryShops
            | val GHC.Classes.== "miscellaneous_auto_dealers" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumMiscellaneousAutoDealers
            | val GHC.Classes.== "miscellaneous_business_services" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumMiscellaneousBusinessServices
            | val GHC.Classes.== "miscellaneous_food_stores" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumMiscellaneousFoodStores
            | val GHC.Classes.== "miscellaneous_general_merchandise" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumMiscellaneousGeneralMerchandise
            | val GHC.Classes.== "miscellaneous_general_services" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumMiscellaneousGeneralServices
            | val GHC.Classes.== "miscellaneous_home_furnishing_specialty_stores" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumMiscellaneousHomeFurnishingSpecialtyStores
            | val GHC.Classes.== "miscellaneous_publishing_and_printing" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumMiscellaneousPublishingAndPrinting
            | val GHC.Classes.== "miscellaneous_recreation_services" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumMiscellaneousRecreationServices
            | val GHC.Classes.== "miscellaneous_repair_shops" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumMiscellaneousRepairShops
            | val GHC.Classes.== "miscellaneous_specialty_retail" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumMiscellaneousSpecialtyRetail
            | val GHC.Classes.== "mobile_home_dealers" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumMobileHomeDealers
            | val GHC.Classes.== "motion_picture_theaters" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumMotionPictureTheaters
            | val GHC.Classes.== "motor_freight_carriers_and_trucking" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumMotorFreightCarriersAndTrucking
            | val GHC.Classes.== "motor_homes_dealers" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumMotorHomesDealers
            | val GHC.Classes.== "motor_vehicle_supplies_and_new_parts" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumMotorVehicleSuppliesAndNewParts
            | val GHC.Classes.== "motorcycle_shops_and_dealers" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumMotorcycleShopsAndDealers
            | val GHC.Classes.== "motorcycle_shops_dealers" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumMotorcycleShopsDealers
            | val GHC.Classes.== "music_stores_musical_instruments_pianos_and_sheet_music" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumMusicStoresMusicalInstrumentsPianosAndSheetMusic
            | val GHC.Classes.== "news_dealers_and_newsstands" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumNewsDealersAndNewsstands
            | val GHC.Classes.== "non_fi_money_orders" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumNonFiMoneyOrders
            | val GHC.Classes.== "non_fi_stored_value_card_purchase_load" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumNonFiStoredValueCardPurchaseLoad
            | val GHC.Classes.== "nondurable_goods" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumNondurableGoods
            | val GHC.Classes.== "nurseries_lawn_and_garden_supply_stores" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumNurseriesLawnAndGardenSupplyStores
            | val GHC.Classes.== "nursing_personal_care" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumNursingPersonalCare
            | val GHC.Classes.== "office_and_commercial_furniture" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumOfficeAndCommercialFurniture
            | val GHC.Classes.== "opticians_eyeglasses" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumOpticiansEyeglasses
            | val GHC.Classes.== "optometrists_ophthalmologist" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumOptometristsOphthalmologist
            | val GHC.Classes.== "orthopedic_goods_prosthetic_devices" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumOrthopedicGoodsProstheticDevices
            | val GHC.Classes.== "osteopaths" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumOsteopaths
            | val GHC.Classes.== "package_stores_beer_wine_and_liquor" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumPackageStoresBeerWineAndLiquor
            | val GHC.Classes.== "paints_varnishes_and_supplies" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumPaintsVarnishesAndSupplies
            | val GHC.Classes.== "parking_lots_garages" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumParkingLotsGarages
            | val GHC.Classes.== "passenger_railways" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumPassengerRailways
            | val GHC.Classes.== "pawn_shops" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumPawnShops
            | val GHC.Classes.== "pet_shops_pet_food_and_supplies" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumPetShopsPetFoodAndSupplies
            | val GHC.Classes.== "petroleum_and_petroleum_products" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumPetroleumAndPetroleumProducts
            | val GHC.Classes.== "photo_developing" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumPhotoDeveloping
            | val GHC.Classes.== "photographic_photocopy_microfilm_equipment_and_supplies" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumPhotographicPhotocopyMicrofilmEquipmentAndSupplies
            | val GHC.Classes.== "photographic_studios" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumPhotographicStudios
            | val GHC.Classes.== "picture_video_production" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumPictureVideoProduction
            | val GHC.Classes.== "piece_goods_notions_and_other_dry_goods" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumPieceGoodsNotionsAndOtherDryGoods
            | val GHC.Classes.== "plumbing_heating_equipment_and_supplies" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumPlumbingHeatingEquipmentAndSupplies
            | val GHC.Classes.== "political_organizations" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumPoliticalOrganizations
            | val GHC.Classes.== "postal_services_government_only" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumPostalServicesGovernmentOnly
            | val GHC.Classes.== "precious_stones_and_metals_watches_and_jewelry" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumPreciousStonesAndMetalsWatchesAndJewelry
            | val GHC.Classes.== "professional_services" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumProfessionalServices
            | val GHC.Classes.== "public_warehousing_and_storage" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumPublicWarehousingAndStorage
            | val GHC.Classes.== "quick_copy_repro_and_blueprint" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumQuickCopyReproAndBlueprint
            | val GHC.Classes.== "railroads" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumRailroads
            | val GHC.Classes.== "real_estate_agents_and_managers_rentals" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumRealEstateAgentsAndManagersRentals
            | val GHC.Classes.== "record_stores" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumRecordStores
            | val GHC.Classes.== "recreational_vehicle_rentals" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumRecreationalVehicleRentals
            | val GHC.Classes.== "religious_goods_stores" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumReligiousGoodsStores
            | val GHC.Classes.== "religious_organizations" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumReligiousOrganizations
            | val GHC.Classes.== "roofing_siding_sheet_metal" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumRoofingSidingSheetMetal
            | val GHC.Classes.== "secretarial_support_services" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumSecretarialSupportServices
            | val GHC.Classes.== "security_brokers_dealers" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumSecurityBrokersDealers
            | val GHC.Classes.== "service_stations" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumServiceStations
            | val GHC.Classes.== "sewing_needlework_fabric_and_piece_goods_stores" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumSewingNeedleworkFabricAndPieceGoodsStores
            | val GHC.Classes.== "shoe_repair_hat_cleaning" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumShoeRepairHatCleaning
            | val GHC.Classes.== "shoe_stores" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumShoeStores
            | val GHC.Classes.== "small_appliance_repair" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumSmallApplianceRepair
            | val GHC.Classes.== "snowmobile_dealers" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumSnowmobileDealers
            | val GHC.Classes.== "special_trade_services" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumSpecialTradeServices
            | val GHC.Classes.== "specialty_cleaning" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumSpecialtyCleaning
            | val GHC.Classes.== "sporting_goods_stores" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumSportingGoodsStores
            | val GHC.Classes.== "sporting_recreation_camps" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumSportingRecreationCamps
            | val GHC.Classes.== "sports_and_riding_apparel_stores" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumSportsAndRidingApparelStores
            | val GHC.Classes.== "sports_clubs_fields" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumSportsClubsFields
            | val GHC.Classes.== "stamp_and_coin_stores" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumStampAndCoinStores
            | val GHC.Classes.== "stationary_office_supplies_printing_and_writing_paper" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumStationaryOfficeSuppliesPrintingAndWritingPaper
            | val GHC.Classes.== "stationery_stores_office_and_school_supply_stores" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumStationeryStoresOfficeAndSchoolSupplyStores
            | val GHC.Classes.== "swimming_pools_sales" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumSwimmingPoolsSales
            | val GHC.Classes.== "t_ui_travel_germany" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumTUiTravelGermany
            | val GHC.Classes.== "tailors_alterations" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumTailorsAlterations
            | val GHC.Classes.== "tax_payments_government_agencies" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumTaxPaymentsGovernmentAgencies
            | val GHC.Classes.== "tax_preparation_services" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumTaxPreparationServices
            | val GHC.Classes.== "taxicabs_limousines" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumTaxicabsLimousines
            | val GHC.Classes.== "telecommunication_equipment_and_telephone_sales" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumTelecommunicationEquipmentAndTelephoneSales
            | val GHC.Classes.== "telecommunication_services" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumTelecommunicationServices
            | val GHC.Classes.== "telegraph_services" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumTelegraphServices
            | val GHC.Classes.== "tent_and_awning_shops" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumTentAndAwningShops
            | val GHC.Classes.== "testing_laboratories" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumTestingLaboratories
            | val GHC.Classes.== "theatrical_ticket_agencies" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumTheatricalTicketAgencies
            | val GHC.Classes.== "timeshares" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumTimeshares
            | val GHC.Classes.== "tire_retreading_and_repair" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumTireRetreadingAndRepair
            | val GHC.Classes.== "tolls_bridge_fees" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumTollsBridgeFees
            | val GHC.Classes.== "tourist_attractions_and_exhibits" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumTouristAttractionsAndExhibits
            | val GHC.Classes.== "towing_services" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumTowingServices
            | val GHC.Classes.== "trailer_parks_campgrounds" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumTrailerParksCampgrounds
            | val GHC.Classes.== "transportation_services" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumTransportationServices
            | val GHC.Classes.== "travel_agencies_tour_operators" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumTravelAgenciesTourOperators
            | val GHC.Classes.== "truck_stop_iteration" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumTruckStopIteration
            | val GHC.Classes.== "truck_utility_trailer_rentals" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumTruckUtilityTrailerRentals
            | val GHC.Classes.== "typesetting_plate_making_and_related_services" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumTypesettingPlateMakingAndRelatedServices
            | val GHC.Classes.== "typewriter_stores" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumTypewriterStores
            | val GHC.Classes.== "u_s_federal_government_agencies_or_departments" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumUSFederalGovernmentAgenciesOrDepartments
            | val GHC.Classes.== "uniforms_commercial_clothing" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumUniformsCommercialClothing
            | val GHC.Classes.== "used_merchandise_and_secondhand_stores" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumUsedMerchandiseAndSecondhandStores
            | val GHC.Classes.== "utilities" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumUtilities
            | val GHC.Classes.== "variety_stores" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumVarietyStores
            | val GHC.Classes.== "veterinary_services" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumVeterinaryServices
            | val GHC.Classes.== "video_amusement_game_supplies" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumVideoAmusementGameSupplies
            | val GHC.Classes.== "video_game_arcades" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumVideoGameArcades
            | val GHC.Classes.== "video_tape_rental_stores" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumVideoTapeRentalStores
            | val GHC.Classes.== "vocational_trade_schools" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumVocationalTradeSchools
            | val GHC.Classes.== "watch_jewelry_repair" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumWatchJewelryRepair
            | val GHC.Classes.== "welding_repair" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumWeldingRepair
            | val GHC.Classes.== "wholesale_clubs" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumWholesaleClubs
            | val GHC.Classes.== "wig_and_toupee_stores" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumWigAndToupeeStores
            | val GHC.Classes.== "wires_money_orders" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumWiresMoneyOrders
            | val GHC.Classes.== "womens_accessory_and_specialty_shops" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumWomensAccessoryAndSpecialtyShops
            | val GHC.Classes.== "womens_ready_to_wear_stores" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumWomensReadyToWearStores
            | val GHC.Classes.== "wrecking_and_salvage_yards" -> Issuing'cardholderSpendingControls'BlockedCategories'EnumWreckingAndSalvageYards
            | GHC.Base.otherwise -> Issuing'cardholderSpendingControls'BlockedCategories'Other val
      )

-- | Defines the enum schema located at @components.schemas.issuing.cardholder.properties.status@ in the specification.
--
-- Specifies whether to permit authorizations on this cardholder\'s cards.
data Issuing'cardholderStatus'
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    Issuing'cardholderStatus'Other Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    Issuing'cardholderStatus'Typed Data.Text.Internal.Text
  | -- | Represents the JSON value @"active"@
    Issuing'cardholderStatus'EnumActive
  | -- | Represents the JSON value @"blocked"@
    Issuing'cardholderStatus'EnumBlocked
  | -- | Represents the JSON value @"inactive"@
    Issuing'cardholderStatus'EnumInactive
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON Issuing'cardholderStatus' where
  toJSON (Issuing'cardholderStatus'Other val) = val
  toJSON (Issuing'cardholderStatus'Typed val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (Issuing'cardholderStatus'EnumActive) = "active"
  toJSON (Issuing'cardholderStatus'EnumBlocked) = "blocked"
  toJSON (Issuing'cardholderStatus'EnumInactive) = "inactive"

instance Data.Aeson.Types.FromJSON.FromJSON Issuing'cardholderStatus' where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "active" -> Issuing'cardholderStatus'EnumActive
            | val GHC.Classes.== "blocked" -> Issuing'cardholderStatus'EnumBlocked
            | val GHC.Classes.== "inactive" -> Issuing'cardholderStatus'EnumInactive
            | GHC.Base.otherwise -> Issuing'cardholderStatus'Other val
      )

-- | Defines the enum schema located at @components.schemas.issuing.cardholder.properties.type@ in the specification.
--
-- One of \`individual\` or \`company\`.
data Issuing'cardholderType'
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    Issuing'cardholderType'Other Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    Issuing'cardholderType'Typed Data.Text.Internal.Text
  | -- | Represents the JSON value @"company"@
    Issuing'cardholderType'EnumCompany
  | -- | Represents the JSON value @"individual"@
    Issuing'cardholderType'EnumIndividual
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON Issuing'cardholderType' where
  toJSON (Issuing'cardholderType'Other val) = val
  toJSON (Issuing'cardholderType'Typed val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (Issuing'cardholderType'EnumCompany) = "company"
  toJSON (Issuing'cardholderType'EnumIndividual) = "individual"

instance Data.Aeson.Types.FromJSON.FromJSON Issuing'cardholderType' where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "company" -> Issuing'cardholderType'EnumCompany
            | val GHC.Classes.== "individual" -> Issuing'cardholderType'EnumIndividual
            | GHC.Base.otherwise -> Issuing'cardholderType'Other val
      )
